////////////////////////////////////////////////////////////////////////
/// \file CheckDAQChannelMap.h
//
/// \version 
/// \author  denis
////////////////////////////////////////////////////////////////////////
#ifndef RAWP_CHECKDAQCHANNELMAPS_H
#define RAWP_CHECKDAQCHANNELMAPS_H
#include "JobControl/Module.h"
#include "RawData/DAQHeader.h"
//#include "DAQ2RawDigit/OnlineUnpack.h"

namespace edm { class EventHandle; }
namespace cfg { class Config;      }
class TH1F;
class TH2F;

namespace rawp {

    enum OfflineChanMASKS{
    MASK_OFFLINE_DETECTOR  = 0x00000000, //!< Detector ID, (4bit), valid range 1-4
    MASK_OFFLINE_PLANE     = 0xFFFFFC00, //!< Diblock ID, (6bit), valid range 1-15
    MASK_OFFLINE_CELL      = 0x000003FF, //!< DCM ID, (6bit), valid range 1-384

    SHIFT_OFFLINE_DETECTOR = 0,
    SHIFT_OFFLINE_PLANE    = 10,
    SHIFT_OFFLINE_CELL     = 0,
  };



    /// A module to process the Flat files
  class CheckDAQChannelMap : public jobc::Module {
  public:
    CheckDAQChannelMap(const char* version);
    ~CheckDAQChannelMap();
    void Update(const cfg::Config& c);

    jobc::Result Reco(edm::EventHandle& evt);


    uint32_t getChannel(uint32_t plane, uint32_t cell);

    void getLimits(uint32_t diblock, uint32_t dcm, uint32_t dcmport, uint32_t pixel);
    void getDCMPortLimits(uint32_t currentdiblock, uint32_t currentdcm);

    uint32_t isForbidden(uint32_t idiblock,uint32_t idcm,uint32_t idcmport);

  private:

  uint32_t _detector;
  uint32_t _diblock;
  uint32_t _dcm;
  uint32_t _dcmport;
  uint32_t _pixel;



  uint32_t _diblockLimit[2];
  uint32_t _dcmLimit[2];
  uint32_t _dcmportLimit[2];
  uint32_t _pixelLimit[2];

  };
};// end of namespace rawp

#endif // RAWP_CHECKDAQCHANNELMAPS_H
////////////////////////////////////////////////////////////////////////
