////////////////////////////////////////////////////////////////////////
/// \file FillRawDigits.h
//
/// \version 
/// \author  denis
////////////////////////////////////////////////////////////////////////
#ifndef RAWP_FILLRAWDIGITS_H
#define RAWP_FILLRAWDIGITS_H
#include "JobControl/Module.h"
#include "RawData/DAQHeader.h"
//#include "DAQ2RawDigit/OnlineUnpack.h"

namespace edm { class EventHandle; }
namespace cfg { class Config;      }
class TH1F;
class TH2F;

namespace rawp {

    enum OfflineChanMASKS{
    MASK_OFFLINE_DETECTOR  = 0x00000000, //!< Detector ID, (4bit), valid range 1-4
    MASK_OFFLINE_PLANE     = 0xFFFFFC00, //!< Diblock ID, (6bit), valid range 1-15
    MASK_OFFLINE_CELL      = 0x000003FF, //!< DCM ID, (6bit), valid range 1-384

    SHIFT_OFFLINE_DETECTOR = 0,
    SHIFT_OFFLINE_PLANE    = 10,
    SHIFT_OFFLINE_CELL     = 0,
  };



    /// A module to process the Flat files
  class FillRawDigits : public jobc::Module {
  public:
    FillRawDigits(const char* version);
    ~FillRawDigits();
    void Update(const cfg::Config& c);

    jobc::Result Reco(edm::EventHandle& evt);


    uint32_t getChannel(uint32_t plane, uint32_t cell);

  private:


  };
};// end of namespace rawp

#endif // RAWP_FILLRAWDIGITS_H
////////////////////////////////////////////////////////////////////////
