#ifndef RAWCONFIGURATIONSYSTEMID_H
#define RAWCONFIGURATIONSYSTEMID_H
#include "DAQDataFormats/RawConfigurationSystemIDV0.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationSystemID
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE rawconfsysid
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

    namespace CURRENT_FIELDS_SUB_NAMESPACE {

        const uint32_t MAXIMUM_SIZE = 1000;

        static const version_t RAWCONFIGURATIONSYSTEMID_LATEST_VERSION = LAST_CLASS_VERSION;
    }

    class RawConfigurationSystemID: public PREVIOUS_VERSION_CLASS_NAME{
        public:

            /// Constructors
            RawConfigurationSystemID (const version_t version = rawconfsysid::RAWCONFIGURATIONSYSTEMID_LATEST_VERSION);                             //! The default constructor
            RawConfigurationSystemID (const RawConfigurationSystemID& copy_in);  //! Deep copy constructor
            RawConfigurationSystemID (const void* dadablockheader_buffer, const version_t version = rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION); //! Shallow copy constructor
            /// Destructor
            ~RawConfigurationSystemID();

            IMPLEMENT_MAIN_STANDARD
            IMPLEMENT_MAIN_setBufferSource

            IMPLEMENT_GET_MAIN        (Version       , uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(DAQSystemID   , uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(DAQSubSystemID, uint32_t)
            IMPLEMENT_FUNCTION_RETURNING_FUNCTION_POINTER_1PAR(getVersionName, const, uint32_t,       std::string&);
            IMPLEMENT_FUNCTION_RETURNING_FUNCTION_POINTER_1PAR(setVersionName,      , uint32_t, const std::string&);
        protected:
            IMPLEMENT_GET_MAIN        (HeaderSize, uint32_t)
            IMPLEMENT_SET_MAIN        (Version   , uint32_t)

            IMPLEMENT_FIGUREOUT_VERSION_STATIC(RawConfigurationSystemID)

            bool setFunctionPointers();

    };
    
} // END NAMESPCE daqdataformats
#endif /* RAWCONFIGURATIONSYSTEMID_H */
