#ifndef RAWMICROBLOCKHEADER_H
#define RAWMICROBLOCKHEADER_H
#include "DAQDataFormats/RawMicroBlockHeaderV1.h"
#include "DAQDataFormats/FunctionBind.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMicroBlockHeader
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE microblock
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

    namespace microblock {
        static const version_t RAWMICROBLOCK_LATEST_VERSION = LAST_CLASS_VERSION;
    }

  class RawMicroBlockHeader: public PREVIOUS_VERSION_CLASS_NAME {

        public:

            // Constructors
            RawMicroBlockHeader(const version_t version = microblock::RAWMICROBLOCK_LATEST_VERSION); //! The default constructor
            RawMicroBlockHeader(const RawMicroBlockHeader& copy_in); //! Deep copy constructor
            RawMicroBlockHeader(const void*, const version_t version = rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION);      //! Shallow copy constructor
            /// Destructor
            ~RawMicroBlockHeader();

            IMPLEMENT_MAIN_STANDARD
            IMPLEMENT_MAIN_setBufferSource
                    
            IMPLEMENT_GET_AND_SET_MAIN(DestBuffID, uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(Partition, uint32_t)
            IMPLEMENT_GET_MAIN        (Version, uint32_t)

            IMPLEMENT_FIGUREOUT_VERSION_STATIC(RawMicroBlockHeader)
        protected:
            IMPLEMENT_GET_AND_SET_MAIN(V0, uint32_t)
            IMPLEMENT_GET_AND_SET_MAIN(V1, uint32_t)
            IMPLEMENT_SET_MAIN(Version, uint32_t)

            bool             setFunctionPointers();

  };


} // END NAMESPCE daqdataformats
#endif /* RAWMICROBLOCKHEADER_H */
