#ifndef RAWCONFIGURATIONTAIL_H
#define RAWCONFIGURATIONTAIL_H
#include "DAQDataFormats/RawConfigurationTailV0.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationTail
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE rawconftail
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

    namespace rawconftail {
        static const version_t RAWCONFIGURATIONBLOCKTAIL_LATEST_VERSION = LAST_CLASS_VERSION;
    }

    class RawConfigurationTail: public PREVIOUS_VERSION_CLASS_NAME{
        public:
            /// Constructors
            RawConfigurationTail (const version_t version = rawconftail::RAWCONFIGURATIONBLOCKTAIL_LATEST_VERSION);                             //! The default constructor
            RawConfigurationTail (const RawConfigurationTail& copy_in);  //! Deep copy constructor
            RawConfigurationTail (const void* dadablockheader_buffer, const version_t version = rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION); //! Shallow copy constructor
            /// Destructor
            ~RawConfigurationTail();

            IMPLEMENT_MAIN_STANDARD
                    
            IMPLEMENT_GET_MAIN        (Version  , uint32_t);
            IMPLEMENT_GET_MAIN        (Reserved1, uint32_t);
            IMPLEMENT_GET_MAIN        (Reserved2, uint32_t);
            IMPLEMENT_GET_MAIN        (MarkerLo1, uint32_t);
            IMPLEMENT_GET_MAIN        (MarkerLo2, uint32_t);
            IMPLEMENT_GET_AND_SET_MAIN(CRC      , uint32_t);

        protected:
            IMPLEMENT_SET_MAIN        (Version  , uint32_t);
            IMPLEMENT_SET_MAIN        (Reserved1, uint32_t);
            IMPLEMENT_SET_MAIN        (Reserved2, uint32_t);
            IMPLEMENT_SET_MAIN        (MarkerLo1, uint32_t);
            IMPLEMENT_SET_MAIN        (MarkerLo2, uint32_t);

            IMPLEMENT_FIGUREOUT_VERSION_STATIC(RawConfigurationTail)
            bool             setFunctionPointers();

    };

} // END NAMESPCE daqdataformats
#endif /* RAWCONFIGURATIONTAIL_H */
