#ifndef RAWMICROBLOCK_H
#define RAWMICROBLOCK_H
#include "DAQDataFormats/RawMicroBlockV1.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMicroBlock
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE microblock
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

  static const uint32_t DEFAULT_MICROBLOCK_SIZE = 16385; /* Default MicroBlock Buffer Size  */

  class RawMicroBlock : public PREVIOUS_VERSION_CLASS_NAME {
        public:
            // Constructors
            RawMicroBlock (const version_t version=microblock::RAWMICROBLOCK_LATEST_VERSION, const uint32_t buffersize = DEFAULT_MICROBLOCK_SIZE); //! The default constructor
            RawMicroBlock (const RawMicroBlock& copy_in);                  //! Deep copy constructor
            RawMicroBlock (const void* microblock_buffer, const version_t version=rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION, const uint32_t buffersize = DEFAULT_MICROBLOCK_SIZE); //! Shallow copy constructor
            /// Destructor
            ~RawMicroBlock();

            IMPLEMENT_MAIN_STANDARD
            IMPLEMENT_MAIN_setBufferSource
            
            IMPLEMENT_FIGUREOUT_VERSION_STATIC(RawMicroBlockHeader)
        private:
            bool setFunctionPointers();

  };

} // END NAMESPCE daqdataformats
#endif /* RAWMICROBLOCK_H */
