#include "DAQDataFormats/RawTriggerHeader.h"
#include "DAQDataFormats/DataFormatException.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerHeader
#define  LAST_CLASS_VERSION           2
#define  CURRENT_FIELDS_SUB_NAMESPACE triggerheader
#include "DAQDataFormats/DataFormatLast.inc"


namespace daqdataformats{
 
//------------------------Constructors------------------------------------------
/// After this constructor the buffer pointer is set to the internal source
RawTriggerHeader::RawTriggerHeader(const version_t version):
     PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    /// Apply the default constructor
    defaultConstructorFixedSize();
}

//------------------------------------------------------------------------------
RawTriggerHeader::RawTriggerHeader(const RawTriggerHeader& copy_in):
    PREVIOUS_VERSION_CLASS_NAME(copy_in)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    lastOperationsInDeepCopy(copy_in);
}

//------------------------------------------------------------------------------
RawTriggerHeader::RawTriggerHeader(const void* buffer, const version_t version):
    PREVIOUS_VERSION_CLASS_NAME(version)
{
    INITIALIZE_DEBUGGING_VARIABLES;
    /// Use default Shallow copy constructor
    copy(buffer);
}
 
//------------------------------------------------------------------------------
RawTriggerHeader::~RawTriggerHeader(){ }


//------------------------------------------------------------------------------
/// All binding routines
#define STANDARD_ROUTINES                                                 \
            BIND_GET_AND_SET(Delimiter              , version0, uint32_t);\
            BIND_GET_AND_SET(Version                , version0, uint32_t);\
            BIND_GET_AND_SET(HWFlag                 , version0, uint32_t);\
            BIND_GET_AND_SET(Source                 , version0, uint32_t);\
            BIND_GET_AND_SET(SourceID               , version0, uint32_t);\
            BIND_GET_AND_SET(SourceSubID            , version0, uint32_t);\
            BIND_GET_AND_SET(TriggerNumberLow       , version0, uint32_t);\
            BIND_GET_AND_SET(TriggerNumberHigh      , version0, uint32_t);\
            BIND_GET_AND_SET(MasterTriggerNumberLow , version0, uint32_t);\
            BIND_GET_AND_SET(MasterTriggerNumberHigh, version0, uint32_t);\
            BIND_GET_AND_SET(MasterTriggerNumber    , version0, uint64_t);\
            BIND_GET_AND_SET(TriggerNumber          , version0, uint64_t);\
            BIND_STADARD_FUNCTION(sizeofdata);                            \
            BIND_STADARD_FUNCTION(readData);

#include "DAQDataFormats/setFunctionPointers_template.inc"


}// end of namespaces
