#include "DAQDataFormats/BitFields.h"

#define SWAB32_OLD(word) ( (((word) & 0xFF000000) >> 24) | (((word) & 0x00FF0000) >> 8) | (((word) & 0x0000FF00) << 8 | (((word) & 0x000000FF) << 24)) )
#define SWAB64_OLD(word) ( SWAB32_OLD( (uint32_t)((word)>>32) ) | (uint64_t)SWAB32_OLD( (uint32_t)(word) )<<32 )


#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <stdint.h>
#include <time.h>

#include <boost/timer.hpp>
#include <vector>

//! A short program to test RawNanoSliceHeader
int main(){

#if __BYTE_ORDER != __BIG_ENDIAN
    std::cout<<"This test is only for Big Endian\n";
    return 0;
#endif
    
    for(int i=0; i< 100000; ++i){
        uint32_t random_number = rand();
        
        uint32_t swap_1 = SWAB32_OLD(random_number);
        uint32_t swap_2 = SWAB32(random_number);
        
        if(swap_1 != swap_2) {
            std::cout<<"bug\n";
            return 1;
        }
        //std::cout<<"random_number = "<<random_number<<" "<<swap_1<<" "<<swap_2<<"\n";
    }
    
    
    for(int i=0; i< 100000; ++i){
        uint32_t random_number1 = rand();
        uint32_t random_number2 = rand();
        uint64_t random_number = (((uint64_t)random_number1)<<32) | random_number2;
        
        
        uint64_t swap_1 = SWAB64_OLD(random_number);
        uint64_t swap_2 = SWAB64(random_number);
        
        if(swap_1 != swap_2) {
            std::cout<<"bug\n";
            return 1;
        }
        //std::cout<<"random_number = "<<random_number<<" "<<swap_1<<" "<<swap_2<<"\n";
    }
    
    std::vector<uint32_t> v1, v2;
    double el1, el2;

    {
        boost::timer t2;
        for(int i=0; i< 10000000; ++i){
                uint32_t random_number = rand();
                uint32_t swap_1 = SWAB32(random_number);
        }
        
        el2 = t2.elapsed();
    }
    {
        boost::timer t1;
        for(int i=0; i< 10000000; ++i){
                uint32_t random_number = rand();
                uint32_t swap_1 = SWAB32_OLD(random_number);
        }
        
        el1 = t1.elapsed();
    }
        
    std::cout<<"El1 = "<<el1<<"\n";
    std::cout<<"El2 = "<<el2<<"\n";
    
    
    
    
    

std::cout<<"OK\n";

return 0;

} // END MAIN
