#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <sstream>

#include "DAQDataFormats/RawMilliSlice.h"
#include "DAQDataFormats/RawDataBlock.h"
using namespace daqdataformats;

//! A short program to test RawMicroSlice
int main(){
  


version_t vv = 1;

NanoSlice params;
        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 2;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 22;
        params.Header.FrameSequenceNumber = 5;
        params.Header.Version             = 0;
        params.TimeStamp                  = 1001;
        params.PulseHeight                = 89;

RawNanoSlice *nanoslice_nonempty = new RawNanoSlice(params);

        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 3;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 23;
        params.Header.FrameSequenceNumber = 6;
        params.TimeStamp                  = 1002;
        params.PulseHeight                = 90;

RawNanoSlice *nanoslice_nonempty1 = new RawNanoSlice(params);

        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 4;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 24;
        params.Header.FrameSequenceNumber = 7;
        params.TimeStamp                  = 1003;
        params.PulseHeight                = 91;
RawNanoSlice *nanoslice_nonempty2 = new RawNanoSlice(params);

RawMicroSlice *microslice1 = new RawMicroSlice();
microslice1->getTimingMarker()->generate();
microslice1->addNanoSlice(nanoslice_nonempty->getBuffer());

RawMicroSlice *microslice2 = new RawMicroSlice();
microslice2->getTimingMarker()->generate();
microslice2->addNanoSlice(nanoslice_nonempty1->getBuffer());

RawMicroSlice *microslice3 = new RawMicroSlice();
microslice3->getTimingMarker()->generate();
microslice3->addNanoSlice(nanoslice_nonempty2->getBuffer());

RawMilliSlice *millislice1 = new RawMilliSlice();


millislice1->setDiblockId(1);
millislice1->setDCMId(2);
millislice1->setDetId(3);
        millislice1->setDestBuffID(4);
        millislice1->setPartition(5);
        millislice1->setTimeStartLow(6);
        millislice1->setTimeStartHigh(7);
        millislice1->setTimeLength(8);
microslice1->setLowWord(1);
microslice2->setLowWord(2);

//microslice1->print();
millislice1->addMicroSlice(microslice1->getBuffer());
millislice1->addMicroSlice(microslice2->getBuffer());
//millislice1->addMicroSlice(microslice3->getBuffer());
millislice1->close();



RawMicroSlice       *slice   = new RawMicroSlice();

RawMicroBlock *block = new RawMicroBlock(vv);


block->setMicroBlockHeader(millislice1->getBuffer());
block->setMicroSlice(slice->getBuffer());

//block->print();return 0;

daqdataformats::RawDataBlock *datablock1 = new daqdataformats::RawDataBlock();


std::cout<<"Setting up db\n";
datablock1->setBuffId(12);
datablock1->setTrigNumLo(13);
std::cout<<"Adding microblock\n";
//block->print();
datablock1->addMicroBlock(block->getBuffer());;
std::cout<<"End of Adding microblock\n";
datablock1->close();

datablock1->print();
datablock1->print();

uint32_t pslice_buffer[1000];

datablock1->writeData(pslice_buffer);

RawDataBlock *datablock2 = new RawDataBlock();
datablock2->readData((void*)pslice_buffer);


RawDataBlock datablock3(datablock2->getBuffer(), -1);
datablock3.print();
RawDataBlock datablock4(datablock3);
datablock4.print();

std::cout<<"Custom printing\n";
std::ostringstream str;
datablock4.print(str);
std::cout<<str.str()<<"\n";


} // END MAIN
