#include <vector>
#include <stdio.h>
#include <stdlib.h>
//#include "TObject.h"
#include "DAQDataFormats/RawMilliSlice.h"
#include "DAQDataFormats/RawDataBlock.h"
#include "DAQDataFormats/RawEvent.h"
#include "DAQDataFormats/RawEventHeader.h"
#include "DAQDataFormats/RawEventTail.h"
#include "DAQDataFormats/RawDataBlock.h"
#include "DAQDataFormats/RawTrigger.h"
#include "DAQDataFormats/RawEvent.h"
#include "DAQDataFormats/RawTriggerHeader.h"
#include "DAQDataFormats/RawTriggerTimingMarker.h"
#include "DAQDataFormats/RawTriggerRange.h"
#include "DAQDataFormats/RawTriggerTime.h"
#include "DAQDataFormats/RawTriggerMask.h"

#include <sstream>

using namespace daqdataformats;

//! A short program to test RawMicroSlice
int main(){
  
version_t vv = 1;

NanoSlice params;
        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 2;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 22;
        params.Header.FrameSequenceNumber = 5;
        params.Header.Version             = 0;
        params.TimeStamp                  = 1001;
        params.PulseHeight                = 89;

RawNanoSlice *nanoslice_nonempty = new RawNanoSlice(params);

        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 3;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 23;
        params.Header.FrameSequenceNumber = 6;
        params.TimeStamp                  = 1002;
        params.PulseHeight                = 90;

RawNanoSlice *nanoslice_nonempty1 = new RawNanoSlice(params);

        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 4;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 24;
        params.Header.FrameSequenceNumber = 7;
        params.TimeStamp                  = 1003;
        params.PulseHeight                = 91;
RawNanoSlice *nanoslice_nonempty2 = new RawNanoSlice(params);

RawMicroSlice *microslice1 = new RawMicroSlice();
microslice1->getTimingMarker()->generate();
microslice1->addNanoSlice(nanoslice_nonempty->getBuffer());

RawMicroSlice *microslice2 = new RawMicroSlice();
microslice2->getTimingMarker()->generate();
microslice2->addNanoSlice(nanoslice_nonempty1->getBuffer());

RawMicroSlice *microslice3 = new RawMicroSlice();
microslice3->getTimingMarker()->generate();
microslice3->addNanoSlice(nanoslice_nonempty2->getBuffer());

RawMilliSlice *millislice1 = new RawMilliSlice();


millislice1->setDiblockId(1);
millislice1->setDCMId(2);
millislice1->setDetId(3);
        millislice1->setDestBuffID(4);
        millislice1->setPartition(5);
        millislice1->setTimeStartLow(6);
        millislice1->setTimeStartHigh(7);
        millislice1->setTimeLength(8);
microslice1->setLowWord(1);
microslice2->setLowWord(2);

microslice1->print();
millislice1->addMicroSlice(microslice1->getBuffer());
millislice1->addMicroSlice(microslice2->getBuffer());
millislice1->addMicroSlice(microslice3->getBuffer());
millislice1->close();

RawMicroSlice       *slice   = new RawMicroSlice();

RawMicroBlock *block = new RawMicroBlock(vv);


block->setMicroBlockHeader(millislice1->getBuffer());
block->setMicroSlice(slice->getBuffer());


RawDataBlock *datablock1 = new RawDataBlock();

datablock1->setBuffId(12);
datablock1->setTrigNumLo(13);
datablock1->addMicroBlock(block->getBuffer());;
datablock1->close();

RawTrigger *trigger = new RawTrigger();


RawTriggerHeader *header = new RawTriggerHeader();
header->setMasterTriggerNumberHigh(1);
header->setMasterTriggerNumberLow(2);
header->setSource(3);
header->setSourceID(4);
header->setSourceSubID(5);
header->setTriggerNumberHigh(6);
header->setTriggerNumberLow(7);
header->setHWFlag(1);


RawTriggerMask *mask = new RawTriggerMask();
mask->setMonteCarloFlag(1);
mask->setPrescale(1);
mask->setTrigMask_High(2);
mask->setTrigMask_High2(3);
mask->setTrigMask_Low(4);
mask->setTrigMod(5);

RawTriggerRange *range = new RawTriggerRange();
range->setTriggerLength(12);


RawTriggerTime *time = new RawTriggerTime();
time->setClockSource(1);
time->setTriggerTimeStampHigh(2);
time->setTriggerTimeStampLow(3);
time->setTriggerTimeStampTvSec(4);
time->setTriggerTimeStampTvUsec(5);

RawTriggerTimingMarker *marker = new RawTriggerTimingMarker();
marker->setTriggerStartLow_baseClock(1);
marker->setTriggerStartHigh_baseClock(2);
marker->setTriggerStartLow_833kHz(3);
marker->setTriggerStartHigh_833kHz(4);


trigger->setTriggerHeader(*header);
trigger->setTriggerMask(*mask);
trigger->setTriggerRange(*range);
trigger->setTriggerTime(*time);
trigger->setTriggerTimingMarker(*marker);


printf("New Event\n");
RawEvent* ev1 = new RawEvent();
ev1->setConfigIDX(1);
ev1->setDataLoggerID(2);
ev1->setEventIncomplete(true);
ev1->setEventNumberLo(4);
ev1->setEventNumberHi(5);
ev1->setEventType(6);
ev1->setPartition(7);
ev1->setRunNumber(9);
ev1->setRunType(10);
ev1->setSubrun(11);
ev1->setTrigger(trigger->getBuffer());
ev1->addDataBlock(datablock1->getBuffer());
ev1->close();
std::cout<<"Printing...\n";
ev1->print();


uint32_t pslice_buffer[1000];

ev1->writeData(pslice_buffer);

RawEvent *ev2 = new RawEvent();
ev2->readData((void*)pslice_buffer);
ev1->print();
ev2->print();

for(uint32_t i=0; i<50;i++)
    std::cout<<"\n";


ev1->print();
for(uint32_t i=0; i<10;i++)
    std::cout<<"\n";
ev2->print();


for(uint32_t i=0; i<5;i++){
        std::cout<<"Cddress "<<&pslice_buffer[i]<<"   ";
        printf("0x%08x", pslice_buffer[i]);
        printf("\n");
}

RawEvent ev3(ev2->getBuffer(), -1);
ev3.print();
RawEvent ev4(ev3);
ev4.print();


std::cout<<"Custom printing\n";
std::ostringstream str;
ev4.print(str);
std::cout<<str.str()<<"\n";



std::cout<<"Custom printing2\n";
std::ostringstream str2;
str2<<ev4;
std::string hh = str2.str();
std::cout<<hh;

} // END MAIN
