#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include "DAQDataFormats/RawMicroBlockHeader.h"        // Front Endboard Simulator

using namespace daqdataformats;

//! A short program to test RawMicroBlockHeader
int main(){


    version_t vv = 1;
std::cout<<"RawMicroBlockHeader Test"<<std::endl;

std::cout<<"Empty microsliceheader1:"<<std::endl;
RawMicroBlockHeader *header1 = new RawMicroBlockHeader(vv);

header1->print();std::cout<<"\n";

std::cout<<"\nNon empty microsliceheader2:"<<std::endl;

RawMicroBlockHeader *header2 = new RawMicroBlockHeader(vv);
header2->setDCMId(1);
header2->setDetId(2);
header2->setDiblockId(3);
header2->setPartition(4);
header2->setDestBuffID(5);

header2->print();std::cout<<"\n";


unsigned int buffer[1];
unsigned int* pbuffer = (unsigned int*)buffer;
std::cout<<"\n\nWriting microsliceheader2 to a buffer... ";
header2->writeData(pbuffer);

std::cout<<"\nReading the buffer to microsliceheader1";
header1->readData(buffer);

std::cout<<"microsliceheader1 now:"<<std::endl;
header1->print();std::cout<<"\n";



std::cout<<"Constructing new "<<std::endl;
RawMicroBlockHeader header3(*header1);
std::cout<<"microsliceheader3 now:"<<std::endl;
header3.print();;std::cout<<"\n";

RawMicroBlockHeader header4(vv);
unsigned int* pointer = (unsigned int*)header3.getBuffer();
header4.setBufferSource(pointer);
std::cout<<"microsliceheader4 now:"<<std::endl;
header4.print();


return 0;
} // END MAIN
