#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <DAQDataFormats/RawMicroBlock.h>
#include <DAQDataFormats/RawMilliSlice.h>
#include "DAQDataFormats/RawMicroBlockHeader.h"        // Front Endboard Simulator
#include <sstream>

using namespace daqdataformats;

//! A short program to test RawMicroBlockHeader
int main(){

version_t vv = 1;

NanoSlice params;
        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 2;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 22;
        params.Header.FrameSequenceNumber = 5;
        params.Header.Version             = 0;
        params.TimeStamp                  = 1001;
        params.PulseHeight                = 89;

RawNanoSlice *nanoslice_nonempty = new RawNanoSlice(params);

        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 3;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 23;
        params.Header.FrameSequenceNumber = 6;
        params.TimeStamp                  = 1002;
        params.PulseHeight                = 90;

RawNanoSlice *nanoslice_nonempty1 = new RawNanoSlice(params);

        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 4;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 24;
        params.Header.FrameSequenceNumber = 7;
        params.TimeStamp                  = 1003;
        params.PulseHeight                = 91;
RawNanoSlice *nanoslice_nonempty2 = new RawNanoSlice(params);

RawMicroSlice *microslice1 = new RawMicroSlice();
microslice1->getTimingMarker()->generate();
microslice1->addNanoSlice(nanoslice_nonempty->getBuffer());

RawMicroSlice *microslice2 = new RawMicroSlice();
microslice2->getTimingMarker()->generate();
microslice2->addNanoSlice(nanoslice_nonempty1->getBuffer());

RawMicroSlice *microslice3 = new RawMicroSlice();
microslice3->getTimingMarker()->generate();
microslice3->addNanoSlice(nanoslice_nonempty2->getBuffer());

RawMilliSlice *millislice1 = new RawMilliSlice();


millislice1->setDiblockId(1);
millislice1->setDCMId(2);
millislice1->setDetId(3);
        millislice1->setDestBuffID(4);
        millislice1->setPartition(5);
        millislice1->setTimeStartLow(6);
        millislice1->setTimeStartHigh(7);
        millislice1->setTimeLength(8);
microslice1->setLowWord(1);
microslice2->setLowWord(2);

//microslice1->print();
millislice1->addMicroSlice(microslice1->getBuffer(),false);
millislice1->addMicroSlice(microslice2->getBuffer(),false);
//millislice1->addMicroSlice(microslice3->getBuffer());
millislice1->close();



//RawMicroSlice       *slice   = new RawMicroSlice();

std::cout<<"Constructing block1\n";
RawMicroBlock *block  = new RawMicroBlock(vv);
RawMicroBlock *block2 = new RawMicroBlock(vv);
std::cout<<"Setting header\n";
block->setMicroBlockHeader(millislice1->getBuffer());
block->setMicroSlice(microslice3->getBuffer());
//block->print();std::cout<<"\n";
//return 0;

unsigned int buffer[10000];
unsigned int* pbuffer = (unsigned int*)buffer;
std::cout<<"\n\nWriting microblock1 to a buffer... ";
block->writeData(pbuffer);

std::cout<<"\nReading the buffer to microblock2";
block2->readData(buffer);
std::cout<<"microblock2 now:"<<std::endl;
block2->print();std::cout<<"\n";
std::cout<<"Constructing new "<<std::endl;
RawMicroBlock block3(block->getBuffer(), vv);
std::cout<<"microblock3 now:"<<std::endl;
block3.print();std::cout<<"\n";

RawMicroBlock block4(block3);
std::cout<<"microblock4 now:"<<std::endl;
block4.print();std::cout<<"\n";


RawMicroBlock block5(-1);
block5.setBufferSource(block4.getBuffer());
std::cout<<"microblock5 now:"<<std::endl;
block5.print();


std::cout<<"Custom printing\n";
std::ostringstream str;
block5.print(str);
std::cout<<str.str()<<"\n";



return 0;
} // END MAIN
