#include <vector>
#include <stdio.h>
#include <stdlib.h>

#include "DAQDataFormats/RawMicroSlice.h"        // Front Endboard Simulator
#include <sstream>

using namespace daqdataformats;

//! A short program to test RawMicroSlice
int main(){

version_t microslice_header_version = 1;

RawMicroSlice *microslice1 = new RawMicroSlice(rawmicro::DEFAULT_MICROSLICE_SIZE, false, microslice_header_version);
microslice1->getTimingMarker()->generate();
//microslice1->print();
//return 0;


NanoSlice params;
        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 2;
        params.Header.FEBStatus           = 0x40;
        params.Header.PixelAddress        = 22;
        params.Header.FrameSequenceNumber = 5;

        params.Header.Version             = 0;

        params.TimeStamp                  = 1001;
        params.PulseHeight                = 89;

	params.Value1                   = 60;
        params.Value2                   = 40;


std::cout<<"Non empty nanoslice"<<std::endl;
RawNanoSlice *nanoslice_nonempty = new RawNanoSlice(params);
//nanoslice_nonempty->print();
//nanoslice_nonempty->resetBufferSource();
//unsigned int r= *((int*)nanoslice_nonempty->getBuffer());std::cout<<"RR="<<r<<"\n";
//return 0;

unsigned int buffer[200];
void* pbuffer = (void*) buffer; //pointer to the buffer
std::cout<<"Writing nanoslicenanoslice_nonempty to a buffer... ";
nanoslice_nonempty->writeData(pbuffer);
//std::cout<<"RR="<<buffer[0]<<"\n";


//microslice1->print();

std::cout<<"Adding the nanoslice to the microslice. And add generator"<<std::endl;
microslice1->addNanoSlice(pbuffer);
microslice1->setHitProbability(.001);
microslice1->generate();
//microslice1->print();
microslice1->writeData(pbuffer);
std::cout<<"Empty rawmicroslice2"<<std::endl;
RawMicroSlice microslice2;

// std::cout << " microslice1->sizeofdata() = " << microslice1->sizeofdata() << std::endl;
 
microslice2.readData(pbuffer);

std::cout<<"rawmicroslice2 now:"<<std::endl;
microslice2.print();
return 0;


//std::cout<<"rawmicroslice3:"<<std::endl;
//RawMicroSlice microslice3(microslice2);
//microslice3.print();

std::cout<<"rawmicroslice3 now:"<<std::endl;
 RawMicroSlice microslice4(microslice2); std::cout << "before microslice4.print " << std::endl;


microslice4.print();

std::cout << "after microslice4.print " << std::endl;

RawMicroSlice microslice5;
unsigned int* pointer = (unsigned int*)microslice4.getBuffer();
microslice5.setBufferSource(pointer);
microslice5.print();


std::cout << "microslice6.print " << std::endl;
RawMicroSlice microslice6;
microslice6.copy(microslice5);

microslice6.print();

std::cout<<"Custom printing\n";
std::ostringstream str;
microslice6.print(str);
std::cout<<str.str()<<"\n";




} // END MAIN
