#include <vector>
#include <stdio.h>
#include <stdlib.h>

#include "DAQDataFormats/RawMilliSlice.h"

#include <sstream>

using namespace daqdataformats;

//! A short program to test RawMicroSlice
int main(){

NanoSlice params;
        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 2;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 22;
        params.Header.FrameSequenceNumber = 5;
        params.Header.Version             = 0;
        params.TimeStamp                  = 1001;
        params.PulseHeight                = 89;

RawNanoSlice *nanoslice_nonempty = new RawNanoSlice(params);
        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 3;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 23;
        params.Header.FrameSequenceNumber = 6;
        params.TimeStamp                  = 1002;
        params.PulseHeight                = 90;

RawNanoSlice *nanoslice_nonempty1 = new RawNanoSlice(params);

        params.Header.LinkStatus          = true;
        params.Header.DataPresent         = true;
        params.Header.DebugMode           = false;
        params.Header.FEBLinkID           = 4;
        params.Header.FEBStatus           = 75;
        params.Header.PixelAddress        = 24;
        params.Header.FrameSequenceNumber = 7;
        params.TimeStamp                  = 1003;
        params.PulseHeight                = 91;
RawNanoSlice *nanoslice_nonempty2 = new RawNanoSlice(params);

RawMicroSlice *microslice1 = new RawMicroSlice();
microslice1->getTimingMarker()->generate();
microslice1->addNanoSlice(nanoslice_nonempty->getBuffer());

RawMicroSlice *microslice2 = new RawMicroSlice();
microslice2->getTimingMarker()->generate();
microslice2->addNanoSlice(nanoslice_nonempty1->getBuffer());

RawMicroSlice *microslice3 = new RawMicroSlice();
microslice3->getTimingMarker()->generate();
microslice3->addNanoSlice(nanoslice_nonempty2->getBuffer());

std::cout<<"rawmillislice1 with added microslice0"<<std::endl;
RawMilliSlice *millislice1 = new RawMilliSlice();
//millislice1->getHeader()->print();


std::cout<<"rawmillislice1 with added microslice1"<<std::endl;

millislice1->setDiblockId(1);
millislice1->print();
std::cout<<"rawmillislice1 with added microslice2"<<std::endl;

millislice1->setDCMId(2);
        millislice1->setDetId(3);
        millislice1->setDestBuffID(4);
std::cout<<"rawmillislice1 with added microslice3"<<std::endl;
        millislice1->setPartition(5);
        millislice1->setTimeStartLow(6);
        millislice1->setTimeStartHigh(7);
        millislice1->setTimeLength(8);
microslice1->setLowWord(1);
microslice2->setLowWord(2);

//microslice1->print();
millislice1->addMicroSlice(microslice1->getBuffer());
millislice1->addMicroSlice(microslice2->getBuffer());
std::cout<<"rawmillislice1 with added microslice4"<<std::endl;
//millislice1->addMicroSlice(microslice3->getBuffer());
std::cout<<"rawmillislice1 with added microslice5"<<std::endl;
millislice1->close();
std::cout<<"rawmillislice1 with added microslice6"<<std::endl;
millislice1->print();

RawMilliSlice *millislice2 = new RawMilliSlice();
millislice2->readData(millislice1->getBuffer());
std::cout<<"rawmillislice1 with added microslice7"<<std::endl;


RawMilliSlice m3(*millislice2);
std::cout<<"rawmillislice1 with added microslice8"<<std::endl;
m3.print();
std::cout<<"rawmillislice1 with added microslice9"<<std::endl;

RawMilliSlice m4;
std::cout<<"rawmillislice1 with added microslice10"<<std::endl;
unsigned int* pointer = (unsigned int*)m3.getBuffer();
std::cout<<"rawmillislice1 with added microslice11"<<std::endl;
m4.setBufferSource(pointer);
std::cout<<"rawmillislice1 with added microslice12"<<std::endl;
m4.print();
std::cout<<"rawmillislice1 with added microslice13"<<std::endl;


m4.setFloatingMicroSlice(0);
std::cout<<"rawmillislice1 with added microslice14"<<std::endl;
m4.getFloatingMicroSlice()->print();
std::cout<<"rawmillislice1 with added microslice15"<<std::endl;


std::cout<<"Custom printing\n";
std::ostringstream str;
m4.print(str);
std::cout<<str.str()<<"\n";


return 0;
} // END MAIN
