#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include "DAQDataFormats/RawNanoSliceHeader.h"        // Front Endboard Simulator
#include <sstream>

using namespace daqdataformats;

void printvector(std::vector <int>& vv){

    
    std::cout<<"Vector has size "<<vv.size()<<"   : ";

    for(uint32_t i = 0; i < vv.size(); ++i)
        std::cout<<" "<<vv[i];


    std::cout<<"\n";

}


//! A short program to test RawNanoSliceHeader
int main(){


    version_t version  = 0;

std::cout<<"RawNanoSliceHeader Test"<<std::endl;

std::cout<<"Empty nanosliceheader1:"<<std::endl;
//RawNanoSliceHeader *header1 = new RawNanoSliceHeader(-1);
RawNanoSliceHeader *header1 = new RawNanoSliceHeader();
std::cout<<"Printing"<<std::endl;
header1->print();


NanoSliceHeader params;
        params.Version             = version;
        params.LinkStatus          = true;
        params.DataPresent         = true;
        params.DebugMode           = false;
        params.FEBLinkID           = 53;
        params.FEBStatus           = 18;
        params.PixelAddress        = 22;
        params.FrameSequenceNumber = 5;

std::cout<<"\nNon empty nanosliceheader2:!!!!!!!!!!!!!!!!!"<<std::endl;
RawNanoSliceHeader *header2 = new RawNanoSliceHeader(params);
header2->print();std::cout<<"\n";


unsigned int buffer[1];
unsigned int* pbuffer = (unsigned int*)buffer;
std::cout<<"\n\nWriting nanosliceheader2 to a buffer... ";
header2->writeData(pbuffer);
printf("Buffer = 0x%08x\n", buffer[0]);


std::cout<<"\nReading the buffer to nanosliceheader1";
header1->readData(buffer);

std::cout<<"nanosliceheader1 now:"<<std::endl;
header1->print();std::cout<<"\n";

std::cout<<"nanosliceheader3:"<<std::endl;
RawNanoSliceHeader header3(*header1);
header3.print();

RawNanoSliceHeader header4(version);
unsigned int* pointer = (unsigned int*)header3.getBuffer();
header4.setBufferSource(pointer);
std::cout<<"nanosliceheader4:"<<std::endl;
header4.print();
std::cout<<"\n";


version_t vv_c = RawNanoSliceHeader::figureOutTheVersionStatic(pointer);
std::cout<<"Version = "<<vv_c<<"\n";



std::cout<<"Custom printing\n";

std::ostringstream str;
header4.print(str);
std::cout<<str.str()<<"\n";


return 0;

} // END MAIN
