#include <vector>
#include <stdio.h>
#include <stdlib.h>

#include <sstream>
#include <DAQDataFormats/RawNanoSliceV0.h>


#include "DAQDataFormats/RawNanoSlice.h"        // Front Endboard Simulator

using namespace daqdataformats;

//! A short program to test RawNanoSlice
int main(){



    version_t vers = 4;

//RawNanoSlice try1(vers);
//try1.print();
//return 0;




std::cout<<"RawNanoSlice Test"<<std::endl;

std::cout<<"Empty nanoslice1"<<std::endl;
RawNanoSlice nano1((version_t) -1);
nano1.print();

    NanoSlice params;
    params.Header.LinkStatus          = true;
    params.Header.DataPresent         = true;
    params.Header.DebugMode           = false;
    params.Header.FEBLinkID           = 2;
    params.Header.FEBStatus           = 6;
    params.Header.PixelAddress        = 22;
    params.Header.FrameSequenceNumber = 5;
    params.Header.Version = vers;

    params.TimeStamp                  = 1001;
    params.PulseHeight                = 89;

    params.Value1                   = 60;
    params.Value2                   = 40;



    std::cout<<"Non empty nanoslice2"<<std::endl;
    RawNanoSlice nano2(params);

    if(vers > 1){

        const int nsamples = nano2.getNSamples();
        for(int i=0; i<nsamples; ++i)
            nano2.setValue(i,i+1);
    }


nano2.print();




unsigned int  buffer[1000];
unsigned int* pbuffer = (unsigned int*) buffer;

std::cout<<"Writing nanoslice2 to a buffer... \n";
nano2.writeData(pbuffer);
std::cout<<"Buf "<<buffer[0]<<" "<<buffer[1]<<" "<<buffer[2]<<"\n";

std::cout<<"Reading the buffer to nanoslice1\n";
nano1.readData(pbuffer);

std::cout<<"nanoslice1 now"<<std::endl;
nano1.print();

/// Deep copy nanoslice
std::cout<<"Deep copy nanoslice\n";
RawNanoSlice nanoslice3(nano1);
std::cout<<"nanoslice3 now"<<std::endl;
nanoslice3.print();

RawNanoSlice nanoslice4(-1);
nanoslice4.print();

unsigned int* pointer = (unsigned int*)nanoslice3.getBuffer();
nanoslice4.setBufferSource(pointer);
std::cout<<"nanoslice4 now"<<std::endl;
nanoslice4.print();


std::cout<<"Custom printing\n";
std::ostringstream str;
nanoslice4.print(str);
std::cout<<str.str()<<"\n";

std::cout<<"Custom printing2\n";
std::ostringstream str2;
str2<<nanoslice4;
std::string hh = str2.str();
std::cout<<hh;


//std::cout<<"Checking for cafe..."<<nanoslice4.checkReservedForCafe()<<"\n";

return 0;
} // END MAIN
