#include "DAQDataFormats/RawTrigger.h"        // Front Endboard Simulator
#include "DAQDataFormats/RawTriggerHeader.h"
#include "DAQDataFormats/RawTriggerTimingMarker.h"
#include "DAQDataFormats/RawTriggerRange.h"
#include "DAQDataFormats/RawTriggerTime.h"
#include "DAQDataFormats/RawTriggerMask.h"

#include <cstdio>
#include <iostream>             /* Iostream for printing   */
#include <sstream>

using namespace daqdataformats;

//! A short program to test RawTrigger
int main(){
  
std::cout<<"RawTrigger Test1"<<std::endl;

std::cout<<"Empty datablockheader:"<<std::endl;

RawTrigger *header1 = new RawTrigger();
RawTrigger *trigger = new RawTrigger();


RawTriggerHeader *header = new RawTriggerHeader();
header->setMasterTriggerNumberHigh(1);
header->setMasterTriggerNumberLow(2);
header->setSource(3);
header->setSourceID(4);
header->setSourceSubID(5);
header->setTriggerNumberHigh(6);
header->setTriggerNumberLow(7);
header->setHWFlag(1);


RawTriggerMask *mask = new RawTriggerMask();
mask->setMonteCarloFlag(1);
mask->setPrescale(1);
mask->setTrigMask_High(2);
mask->setTrigMask_High2(3);
mask->setTrigMask_Low(4);
mask->setTrigMod(5);

RawTriggerRange *range = new RawTriggerRange();
range->setTriggerLength(12);


RawTriggerTime *time = new RawTriggerTime();
time->setClockSource(1);
time->setTriggerTimeStampHigh(2);
time->setTriggerTimeStampLow(3);
time->setTriggerTimeStampTvSec(4);
time->setTriggerTimeStampTvUsec(5);

RawTriggerTimingMarker *marker = new RawTriggerTimingMarker();
marker->setTriggerStartLow_baseClock(1);
marker->setTriggerStartHigh_baseClock(2);
marker->setTriggerStartLow_833kHz(3);
marker->setTriggerStartHigh_833kHz(4);


trigger->setTriggerHeader(*header);
trigger->setTriggerMask(*mask);
trigger->setTriggerRange(*range);
trigger->setTriggerTime(*time);
trigger->setTriggerTimingMarker(*marker);


trigger->print();
std::cout<<"\n";
std::cout<<"\nNon empty datablockheader2 end:"<<std::endl;
unsigned int buffer[100];
unsigned int* pbuffer = (unsigned int*)buffer;
std::cout<<"\n\nWriting datablockheader2 to a buffer... ";
trigger->writeData(pbuffer);


std::cout<<"\nReading the buffer to datablockheader";
header1->readData(pbuffer);
header1->print();
RawTrigger h3(header1->getBuffer(), 0);
h3.print();
RawTrigger h4(h3);
h4.print();
RawTrigger h5;
h5.setBufferSource(h4.getBuffer());

h4.print();
h5.print();


std::cout<<"Custom printing\n";
std::ostringstream str;
h5.print(str);
std::cout<<str.str()<<"\n";













return 0;
} // END MAIN
