#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fcntl.h>
#include <sys/stat.h>
#include "DAQDataFormats/RawEvent.h"
#include "DAQDataFormats/RawTrigger.h"
#include "DAQDataFormats/RawDataBlock.h"

#define MAXIMUM_BUFFER_SIZE 1000000
//using namespace mcdatadaq;

using namespace daqdataformats;

//! A short program to test RawMicroSlice
int main(){

    RawEvent rawevent;

    uint32_t fileformat_version_number[1];
    // Reading the TriggerBlock
    {
    uint32_t* pfileformat_version_number = (uint32_t*)fileformat_version_number;
    char FileName[300] ="/home/denis/NoVA_DAQ/Online_my/Output_DataLogger/muon_TriggerBlocks.raw" ;
    struct stat file_status;
    stat(FileName, &file_status);

    int file_handler = open(FileName, O_RDONLY);
    read(file_handler,pfileformat_version_number,4);
    std::cout<<"DCM Simulator Version (for the TriggerBlock file)= "<<fileformat_version_number[0]<<std::endl;

    uint32_t  TrigBlocksBuffer[MAXIMUM_BUFFER_SIZE];         // The real buffer of all TriggerBlocks
    uint32_t* pBuffer = (uint32_t*)TrigBlocksBuffer;         // It's pointer
    read(file_handler, pBuffer, file_status.st_size - 4);    // Read all TriggerBlocks into pBuffer


    RawTrigger trigger;
        pBuffer = (uint32_t*)trigger.readData(pBuffer);

        trigger.print();

    close(file_handler);

    rawevent.setTrigger(trigger);

    size_t size = rawevent.sizeofdata();
    std::cout<<"\nsize = "<<size<<"\n";

    }

// Reading the DataBlock
    {
    uint32_t* pfileformat_version_number = (uint32_t*)fileformat_version_number;
    char FileName[300] ="/home/denis/NoVA_DAQ/Online_my/Output_DataLogger/muon_DataBlocks.raw" ;
    struct stat file_status;
    stat(FileName, &file_status);

    int file_handler = open(FileName, O_RDONLY);
    read(file_handler,pfileformat_version_number,4);
    std::cout<<"DCM Simulator Version (for the DataBlock file)= "<<fileformat_version_number[0]<<std::endl;

    uint32_t  DataBlocksBuffer[MAXIMUM_BUFFER_SIZE];     // The real buffer of all DataBlocks
    uint32_t* pBuffer = (uint32_t*)DataBlocksBuffer; // It's pointer
    read(file_handler, pBuffer, file_status.st_size - 4);    // Read all DataBlocks into pBuffer


    RawDataBlock datablock;
    for(int i = 0; i < 8; ++i){
        pBuffer = (uint32_t*)datablock.readData(pBuffer);
        std::cout<<i<<"-th Buffer Node. DataBlock size = "<<datablock.sizeofdata()<<"\n"; // size = 4 means an empty DataBlock

        rawevent.addDataBlock(datablock.getBuffer());
    }

    close(file_handler);
     size_t size = rawevent.sizeofdata();
    std::cout<<"\nsize = "<<size<<"\n";

    }

// close the event
rawevent.close();

//rawevent.print();

    FILE* out_small = fopen ("event.raw","wb");
    //fwrite(fileformat_version_number, 4, 1, out_small);
    size_t size = rawevent.sizeofdata();
    std::cout<<"size = "<<rawevent.sizeofdata()<<"\n";
        // write out the MicroSlice into the output file
        fwrite (rawevent.getBuffer() , 4 , size , out_small);

    fclose (out_small);




    return 0;

} // END MAIN
