/*
#include "DAQDataFormats/RawDataBlock.h"

#include <iostream>

using namespace std;
using namespace daqdataformats;

//------------------------------------------------------------

void TestDataBlockHeader(datablock::RawDataBlockHeader& hdr)
{
  unsigned int buff[100];

  // test packing method
  hdr.setVersion(2);
  hdr.setMarker(8);
  hdr.setTrigNum(1);
  hdr.setNumBlocks(32);
  hdr.setBuffId(5);
  hdr.setDataSize(20);

  memset(buff,0,sizeof(buff));
  hdr.pack(buff);
  cout.setf(ios::showbase);

  for (int i=0; i<100; ++i) {
    if (buff[i] == 0) break;
    cout << hex << buff[i] << dec << endl;
  }    

  // test unpacking method
  hdr.clear();
  hdr.unpack(buff);
  cout << "version        = " << hdr.getVersion() << endl;
  cout << "marker         = " << hdr.getMarker() << endl;
  cout << "trig num       = " << hdr.getTrigNum() << endl;
  cout << "num blocks     = " << hdr.getNumBlocks() << endl;
  cout << "buffer node id = " << hdr.getBuffId() << endl;
  cout << "data size      = " << hdr.getDataSize() << endl;

  cout << "hdr.size       = " << hdr.sizeofdata() << endl;
  
}

//------------------------------------------------------------

void TestMilliSliceHeader(RawMilliSliceHeader& hdr)
{
  unsigned int buff[100];

  // test packing method
  hdr.setVersion(2);
  hdr.setMarker(10);
  hdr.setSliceSeq(4);
  hdr.setFrameSeq(8);
  hdr.setDestBuffId(64);
  hdr.setDCMChan(6);
  hdr.setTStart(0x14567);
  hdr.setTEnd(0x14867);
  hdr.setSliceSize(100);
  hdr.setNFrames(20);

  memset(buff,0,sizeof(buff));
  hdr.pack(buff);
  cout.setf(ios::showbase);

  for (int i=0; i<100; ++i) {
    if (buff[i] == 0) break;
    cout << hex << buff[i] << dec << endl;
  }    

  // test unpacking method
  hdr.clear();
  hdr.unpack(buff);
  cout << "version        = " << hdr.getVersion() << endl;
  cout << "marker         = " << hdr.getMarker() << endl;
  cout << "slice seq      = " << hdr.getSliceSeq() << endl;
  cout << "frame seq      = " << hdr.getFrameSeq() << endl;
  cout << "buffer node id = " << hdr.getDestBuffId() << endl;
  cout << "DCM channel    = " << hdr.getDCMChan() << endl;
  cout << "Tstart         = " << hex << hdr.getTStart() << endl;
  cout << "Tend           - " << hex << hdr.getTEnd() << dec << endl;
  cout << "slice size     = " << hdr.getSliceSize() << endl;
  cout << "num frames     = " << hdr.getNFrames() << endl;

  cout << "hdr.size       = " << hdr.sizeofdata() << endl;
  
}

//------------------------------------------------------------

void TestMilliSubframeHeader(RawMilliSubframeHeader& hdr)
{
  unsigned int buff[100];

  // test packing method
  hdr.setTStart(0x14567);
  hdr.setTEnd(0x14867);
  hdr.setDataSize(5);
  hdr.setDebugMode(true);
  hdr.setDataPresent(true);
  hdr.setLinkStatus(false);

  memset(buff,0,sizeof(buff));
  hdr.pack(buff);
  cout.setf(ios::showbase);

  for (int i=0; i<100; ++i) {
    if (buff[i] == 0) break;
    cout << hex << buff[i] << dec << endl;
  }    

  // test unpacking method
  hdr.clear();
  hdr.unpack(buff);
  cout << "Tstart         = " << hex << hdr.getTStart() << endl;
  cout << "Tend           = " << hex << hdr.getTEnd() << dec << endl;
  cout << "data size      = " << hdr.getDataSize() << endl;
  cout << "debug mode     = " << hdr.getDebugMode() << endl;
  cout << "data present   = " << hdr.getDataPresent() << endl;
  cout << "link status    = " << hdr.getLinkStatus() << endl;

  cout << "hdr.size       = " << hdr.sizeofdata() << endl;
  
}

//------------------------------------------------------------
*/
int main()
{
  /*unsigned int buff[100];
  memset(buff,0,sizeof(buff));

  // test Data Block objects
  datablock::RawDataBlock blk;
  datablock::RawDataBlockHeader hdr;

  cout << "******************************" << endl;
  cout << "Testing Data Block Header..." << endl;
  cout << "******************************" << endl;
  TestDataBlockHeader(hdr);
  blk.add(hdr);

  RawMilliSlice milli;
  RawMilliSliceHeader millihdr;

  cout << "******************************" << endl;
  cout << "Testing Millislice Header..." << endl;
  cout << "******************************" << endl;
  TestMilliSliceHeader(millihdr);
  milli.add(millihdr);

  blk.add(milli);
  cout << "blk.size = " << blk.sizeofdata() << endl;

  RawMilliSubframe millisf;
  RawMilliSubframeHeader millisfhdr;
  cout << "******************************" << endl;
  cout << "Testing MilliSubframe Header..." << endl;
  cout << "******************************" << endl;
  TestMilliSubframeHeader(millisfhdr);
  millisf.add(millisfhdr);*/


    return 0;
} // END MAIN
