/* 
 * File:   ConfigurationBlockConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/ConfigurationBlockConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationBlock
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE configurationblock
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

//------------------------------------------------------------------------------
ConfigurationBlockConstructor::ConfigurationBlockConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::rawconfhdr::RAWCONFIGURATIONBLOCKHEADER_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
ConfigurationBlockConstructor::~ConfigurationBlockConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* ConfigurationBlockConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawConfigurationBlock* out = new daqdataformats::RawConfigurationBlock(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* ConfigurationBlockConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    RawConfigurationBlock* out = new daqdataformats::RawConfigurationBlock(ver);
    
    if(ver != rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION)
        out->close();
    
    return out;
}

//------------------------------------------------------------------------------
bool ConfigurationBlockConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawConfigurationBlock* cblock = (daqdataformats::RawConfigurationBlock*)dataformat;

    RawConfigurationSystemID* sysid = (RawConfigurationSystemID*)_configurationSystemIDConstructor.getFilledDataFormat(0);
    cblock->addSystemID(sysid->getBuffer());

    sysid->setVersionName("That's funny");
    cblock->addSystemID(sysid->getBuffer());

    sysid->setVersionName("Ho Ho Ho");
    cblock->addSystemID(sysid->getBuffer());

    cblock->close();

    delete sysid;
    
    return true;
}






}}// end of namespaces
