/* 
 * File:   ConfigurationBlockConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef CONFIGURATIONBLOCKCONSTRUCTOR_H
#define	CONFIGURATIONBLOCKCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "ConfigurationSystemIDConstructor.h"
#include "DAQDataFormats/RawConfigurationBlock.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationBlock
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE configurationblock
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

class ConfigurationBlockConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    ConfigurationBlockConstructor();
    ~ConfigurationBlockConstructor();

    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawConfigurationBlock* nano_ver = (const RawConfigurationBlock*)inver;
        return nano_ver->getConfigurationVersion();
    }
    
public:

    rawconfsysid::ConfigurationSystemIDConstructor _configurationSystemIDConstructor;

};

}}// end of namespaces


#endif	/* CONFIGURATIONBLOCKCONSTRUCTOR_H */

