/* 
 * File:   ConfigurationHeaderConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/ConfigurationHeaderConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationHeader
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE rawconfhdr
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

//------------------------------------------------------------------------------
ConfigurationHeaderConstructor::ConfigurationHeaderConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::CURRENT_FIELDS_SUB_NAMESPACE::RAWCONFIGURATIONBLOCKHEADER_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
ConfigurationHeaderConstructor::~ConfigurationHeaderConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* ConfigurationHeaderConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawConfigurationHeader* out = (RawConfigurationHeader*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* ConfigurationHeaderConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawConfigurationHeader(ver);
}

//------------------------------------------------------------------------------
bool ConfigurationHeaderConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawConfigurationHeader* microblock = (daqdataformats::RawConfigurationHeader*)dataformat;
    setFieldToTestValue_DetectorID(microblock);
    setFieldToTestValue_ConfigurationBlockSize(microblock);
    setFieldToTestValue_ResourceManagerID(microblock);
    setFieldToTestValue_RunNumber(microblock);
    setFieldToTestValue_RunType(microblock);
    setFieldToTestValue_ConfigurationIDX(microblock);
    setFieldToTestValue_Partition(microblock);
    setFieldToTestValue_Subrun(microblock);
    setFieldToTestValue_SystemNumber(microblock);
    setFieldToTestValue_SystemVersionIDX(microblock);

    return true;
}

}}// end of namespaces
