/* 
 * File:   ConfigurationHeaderConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef CONFIGURATIONHEADERCONSTRUCTOR_H
#define	CONFIGURATIONHEADERCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawConfigurationHeader.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationHeader
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE rawconfhdr
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

            enum ConfigurationHeaderTestValues {
                TEST_VALUE_DetectorID               = 3,
                TEST_VALUE_ConfigurationBlockSize   = 13,
                TEST_VALUE_ResourceManagerID        = 14,
                TEST_VALUE_RunNumber                = 15,
                TEST_VALUE_RunType                  = 16,
                TEST_VALUE_ConfigurationIDX         = 17,
                TEST_VALUE_Partition                = 18,
                TEST_VALUE_Subrun                   = 19,
                TEST_VALUE_SystemNumber             = 20,
                TEST_VALUE_SystemVersionIDX         = 21
	    };// end of ConfigurationHeaderMASKS


class ConfigurationHeaderConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    ConfigurationHeaderConstructor();
    ~ConfigurationHeaderConstructor();
    DEFINE_TESTVALUE     (DetectorID);
    DEFINE_TESTVALUE     (ConfigurationBlockSize);
    DEFINE_TESTVALUE     (ResourceManagerID);
    DEFINE_TESTVALUE     (RunNumber);
    DEFINE_TESTVALUE     (RunType);
    DEFINE_TESTVALUE     (ConfigurationIDX);
    DEFINE_TESTVALUE     (Partition);
    DEFINE_TESTVALUE     (Subrun);
    DEFINE_TESTVALUE     (SystemNumber);
    DEFINE_TESTVALUE     (SystemVersionIDX);
    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawConfigurationHeader* nano_ver = (const RawConfigurationHeader*)inver;
        return nano_ver->getConfigurationHeaderVersion();
    }
    
private:

};

}}// end of namespaces


#endif	/* CONFIGURATIONHEADERCONSTRUCTOR_H */

