/* 
 * File:   ConfigurationNameConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/ConfigurationNameConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationName
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE rawconfname
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

//------------------------------------------------------------------------------
ConfigurationNameConstructor::ConfigurationNameConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::CURRENT_FIELDS_SUB_NAMESPACE::RAWCONFIGURATIONNAME_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
ConfigurationNameConstructor::~ConfigurationNameConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* ConfigurationNameConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawConfigurationName* out = (RawConfigurationName*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* ConfigurationNameConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawConfigurationName(ver);
}

//------------------------------------------------------------------------------
bool ConfigurationNameConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawConfigurationName* cname = (daqdataformats::RawConfigurationName*)dataformat;
    setFieldToTestValue_Name(cname);
    return true;
}


//------------------------------------------------------------------------------
bool ConfigurationNameConstructor::checkField_Name(daqdataformats::CURRENT_CLASS* dataformat) const {

            if(!setFieldToTestValue_Name(dataformat)) {                                 
                    LOG_ERROR("UNITTEST") << std::endl<< __PRETTY_FUNCTION__                    
                                          <<"\nsetFieldToTestValue_"<<"Name"<<" failed.\n" 
                                          <<"Test value = "<<TEST_VALUE_Name<<"\n";     
                    if(getVersion(dataformat) > rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION)
                        LOG_ERROR("UNITTEST")<<"version =  "<<getVersion(dataformat)<<"\n";     
                    return false;                                                               
            }

            if(TEST_VALUE_Name.compare(getFieldValue_Name(dataformat)) != 0 ){
                    LOG_ERROR("UNITTEST") << std::endl<< __PRETTY_FUNCTION__                    
                                          <<"\ngetFieldToTestValue_"<<"Name"<<" failed.\n" 
                                          <<"Test value = "<<TEST_VALUE_Name<<"!"
                                          <<" but get is "                                      
                                          << getFieldValue_Name(dataformat)<<"!\n";
                    if(getVersion(dataformat) > rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION)
                        LOG_ERROR("UNITTEST")<<"version =  "<<getVersion(dataformat)<<"\n";     
                    return false;                                                               
            }                                                                                   
                                                                                                
            std::string suceed_string = "Checking BitField in ";                                
            suceed_string.append(__PRETTY_FUNCTION__);                                          
            suceed_string.append(" field ");                                                    
            suceed_string.append("Name");                                                  
            suceed_string.append(" suceeded for version =  ");                                  
            suceed_string.append(boost::lexical_cast<std::string>(getVersion(dataformat)));     
            suceed_string.append(" (set to ");                                                  
            suceed_string.append(boost::lexical_cast<std::string>(TEST_VALUE_Name));    
            suceed_string.append(" received ");                                                 
            suceed_string.append(boost::lexical_cast<std::string>(getFieldValue_Name(dataformat))); 
            suceed_string.append(").");                                                         
                                                                                                
            if(!setFieldToZeroValue_Name(dataformat)){                                  
                    LOG_ERROR("UNITTEST")<<"\nsetFieldToZeroValue_"<<"Name"<<" failed.\n"  
                             <<"version =  "<<getVersion(dataformat)<<"\n";                     
                    return false;                                                               
            }                                                                                   
            if(getFieldValue_Name(dataformat).size() != 0) {
                    LOG_ERROR("UNITTEST")<<"\ngetFieldValue_"<<"Name"<<" failed.\n"        
                             <<"Should be zero"                                                 
                             <<" but get is "<<getFieldValue_Name(dataformat)<<"\n"     
                             <<"version =  "<<getVersion(dataformat)<<"\n";                     
                    return false;                                                               
            }                                                                                   
            LOG_DEBUG("UNITTEST")<< suceed_string;                                              
            return true;                                                                        
}






}}// end of namespaces
