/* 
 * File:   ConfigurationNameConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef CONFIGURATIONNAMECONSTRUCTOR_H
#define	CONFIGURATIONNAMECONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawConfigurationName.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationName
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE rawconfname
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

    const std::string TEST_VALUE_Name = "test1";


class ConfigurationNameConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    ConfigurationNameConstructor();
    ~ConfigurationNameConstructor();

    bool        setFieldToTestValue_Name(daqdataformats::CURRENT_CLASS* dataformat) const {return dataformat->setName(TEST_VALUE_Name);}
    bool        setFieldToZeroValue_Name(daqdataformats::CURRENT_CLASS* dataformat) const {const std::string null_str; return dataformat->setName(null_str);}
    std::string getFieldValue_Name(const daqdataformats::CURRENT_CLASS* dataformat) const {std::string name; dataformat->getName(name); return name;}
    bool        checkField_Name(daqdataformats::CURRENT_CLASS* dataformat) const;


    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawConfigurationName* nano_ver = (const RawConfigurationName*)inver;
        return nano_ver->getVersion();
    }
    
private:

};

}}// end of namespaces


#endif	/* CONFIGURATIONNAMECONSTRUCTOR_H */

