/* 
 * File:   ConfigurationNameUnitTest.cpp
 * Author: denis
 * 
 * Created on September 24, 2012, 10:18 AM
 */
//#include "DAQDataFormats/../unittest/RawDAQDataUnitTest.h"
//#include "DAQDataFormats/../unittest/ConfigurationNameConstructor.h"
#include "RawDAQDataUnitTest.h"
#include "ConfigurationNameConstructor.h"

namespace daqdataformats {

class ConfigurationNameUnitTest : public RawDAQDataUnitTest {
    CPPUNIT_TEST_SUITE(ConfigurationNameUnitTest);
    CPPUNIT_TEST(basicFieldGetAndSetChecks);
    CPPUNIT_TEST(testReadDataIntoSameVersion);
    CPPUNIT_TEST(testReadDataIntoUnknownVersion);
    CPPUNIT_TEST(checkDeepCopyConstructor);
    CPPUNIT_TEST(checkShallowCopyConstructor);
    CPPUNIT_TEST_SUITE_END();
public:
    ConfigurationNameUnitTest();
    ~ConfigurationNameUnitTest();

    DEFINE_checkDeepCopyConstructor(RawConfigurationName)
    DEFINE_checkShallowCopyConstructor(RawConfigurationName)
    DEFINE_testReadDataIntoSameVersion
    DEFINE_testReadDataIntoUnknownVersion

private:
    void basicFieldGetAndSetChecksForGivenVersion(const version_t);

private:
    rawconfname::ConfigurationNameConstructor* _mainDFConstructor;
};

//------------------------------------------------------------------------------
ConfigurationNameUnitTest::ConfigurationNameUnitTest():
     RawDAQDataUnitTest(new rawconfname::ConfigurationNameConstructor())
    ,_mainDFConstructor((rawconfname::ConfigurationNameConstructor*)_dataFormatConstructor)
{
}

//------------------------------------------------------------------------------
ConfigurationNameUnitTest::~ConfigurationNameUnitTest() { }

//------------------------------------------------------------------------------
void ConfigurationNameUnitTest::basicFieldGetAndSetChecksForGivenVersion(const version_t version) {

    RawConfigurationName* df = (RawConfigurationName*)_mainDFConstructor->getEmptyDataFormat(version);

    CPPUNIT_ASSERT(version == (version_t) df->getVersion());
    ASSERT_CHECK_FIELD(Name)
    ASSERT_PRINT_IS_NOT_UNKNOWN;
    
    delete df;
}

//CPPUNIT_TEST_SUITE_REGISTRATION(ConfigurationNameUnitTest);
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(ConfigurationNameUnitTest, "DAQDataFormats");
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("DAQDataFormats");

}// end of class
