/* 
 * File:   ConfigurationSystemIDConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef CONFIGURATIONSYSTEMIDCONSTRUCTOR_H
#define	CONFIGURATIONSYSTEMIDCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawConfigurationSystemID.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationSystemID
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE rawconfsysid
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

            const std::string TEST_VALUE_VersionName = "NOvA Testing the Version name.";

            enum ConfigurationTailTestValues {
                TEST_VALUE_DAQSystemID       = 12,
                TEST_VALUE_DAQSubSystemID    = 13,
	    };// end of ConfigurationTailMASKS

class ConfigurationSystemIDConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    ConfigurationSystemIDConstructor();
    ~ConfigurationSystemIDConstructor();
    DEFINE_TESTVALUE     (DAQSystemID);
    DEFINE_TESTVALUE     (DAQSubSystemID);

    bool        setFieldToTestValue_VersionName(daqdataformats::CURRENT_CLASS* dataformat) const {return dataformat->setVersionName(TEST_VALUE_VersionName);}
    bool        setFieldToZeroValue_VersionName(daqdataformats::CURRENT_CLASS* dataformat) const {const std::string null_str; return dataformat->setVersionName(null_str);}
    std::string getFieldValue_VersionName(const daqdataformats::CURRENT_CLASS* dataformat) const {std::string name; dataformat->getVersionName(name); return name;}
    bool        checkField_VersionName(daqdataformats::CURRENT_CLASS* dataformat) const;


    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawConfigurationSystemID* nano_ver = (const RawConfigurationSystemID*)inver;
        return nano_ver->getVersion();
    }
    
private:

};

}}// end of namespaces


#endif	/* CONFIGURATIONSYSTEMIDCONSTRUCTOR_H */

