/* 
 * File:   ConfigurationSystemIDUnitTest.cpp
 * Author: denis
 * 
 * Created on September 24, 2012, 10:18 AM
 */
//#include "DAQDataFormats/../unittest/RawDAQDataUnitTest.h"
//#include "DAQDataFormats/../unittest/ConfigurationSystemIDConstructor.h"
#include "RawDAQDataUnitTest.h"
#include "ConfigurationSystemIDConstructor.h"

namespace daqdataformats {

class ConfigurationSystemIDUnitTest : public RawDAQDataUnitTest {
    CPPUNIT_TEST_SUITE(ConfigurationSystemIDUnitTest);
    CPPUNIT_TEST(basicFieldGetAndSetChecks);
    CPPUNIT_TEST(testReadDataIntoSameVersion);
    CPPUNIT_TEST(testReadDataIntoUnknownVersion);
    CPPUNIT_TEST(checkDeepCopyConstructor);
    CPPUNIT_TEST(checkShallowCopyConstructor);
    CPPUNIT_TEST_SUITE_END();
public:
    ConfigurationSystemIDUnitTest();
    ~ConfigurationSystemIDUnitTest();

    DEFINE_checkDeepCopyConstructor(RawConfigurationSystemID)
    DEFINE_checkShallowCopyConstructor(RawConfigurationSystemID)
    DEFINE_testReadDataIntoSameVersion
    DEFINE_testReadDataIntoUnknownVersion

private:
    void basicFieldGetAndSetChecksForGivenVersion(const version_t);

private:
    rawconfsysid::ConfigurationSystemIDConstructor* _mainDFConstructor;
};

//------------------------------------------------------------------------------
ConfigurationSystemIDUnitTest::ConfigurationSystemIDUnitTest():
     RawDAQDataUnitTest(new rawconfsysid::ConfigurationSystemIDConstructor())
    ,_mainDFConstructor((rawconfsysid::ConfigurationSystemIDConstructor*)_dataFormatConstructor)
{
}

//------------------------------------------------------------------------------
ConfigurationSystemIDUnitTest::~ConfigurationSystemIDUnitTest() { }

//------------------------------------------------------------------------------
void ConfigurationSystemIDUnitTest::basicFieldGetAndSetChecksForGivenVersion(const version_t version) {

    RawConfigurationSystemID* df = (RawConfigurationSystemID*)_mainDFConstructor->getEmptyDataFormat(version);

    CPPUNIT_ASSERT(version == (version_t) df->getVersion());

    ASSERT_CHECK_FIELD     (DAQSystemID);
    ASSERT_CHECK_FIELD     (DAQSubSystemID);
    ASSERT_CHECK_FIELD     (VersionName);


    ASSERT_PRINT_IS_NOT_UNKNOWN;
    
    delete df;
}

//CPPUNIT_TEST_SUITE_REGISTRATION(ConfigurationSystemIDUnitTest);
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(ConfigurationSystemIDUnitTest, "DAQDataFormats");
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("DAQDataFormats");

}// end of class
