/* 
 * File:   ConfigurationTailConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/ConfigurationTailConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawConfigurationTail
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE rawconftail
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

//------------------------------------------------------------------------------
ConfigurationTailConstructor::ConfigurationTailConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::CURRENT_FIELDS_SUB_NAMESPACE::RAWCONFIGURATIONBLOCKTAIL_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
ConfigurationTailConstructor::~ConfigurationTailConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* ConfigurationTailConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawConfigurationTail* out = (RawConfigurationTail*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* ConfigurationTailConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawConfigurationTail(ver);
}

//------------------------------------------------------------------------------
bool ConfigurationTailConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawConfigurationTail* microblock = (daqdataformats::RawConfigurationTail*)dataformat;
    setFieldToTestValue_CRC(microblock);

    return true;
}

}}// end of namespaces
