/* 
 * File:   ConfigurationTailUnitTest.cpp
 * Author: denis
 * 
 * Created on September 24, 2012, 10:18 AM
 */
//#include "DAQDataFormats/../unittest/RawDAQDataUnitTest.h"
//#include "DAQDataFormats/../unittest/ConfigurationTailConstructor.h"
#include "RawDAQDataUnitTest.h"
#include "ConfigurationTailConstructor.h"

namespace daqdataformats {

class ConfigurationTailUnitTest : public RawDAQDataUnitTest {
    CPPUNIT_TEST_SUITE(ConfigurationTailUnitTest);
    CPPUNIT_TEST(basicFieldGetAndSetChecks);
    CPPUNIT_TEST(testReadDataIntoSameVersion);
    CPPUNIT_TEST(testReadDataIntoUnknownVersion);
    CPPUNIT_TEST(checkDeepCopyConstructor);
    CPPUNIT_TEST(checkShallowCopyConstructor);
    CPPUNIT_TEST_SUITE_END();
public:
    ConfigurationTailUnitTest();
    ~ConfigurationTailUnitTest();

    DEFINE_checkDeepCopyConstructor(RawConfigurationTail)
    DEFINE_checkShallowCopyConstructor(RawConfigurationTail)
    DEFINE_testReadDataIntoSameVersion
    DEFINE_testReadDataIntoUnknownVersion

private:
    void basicFieldGetAndSetChecksForGivenVersion(const version_t);

private:
    rawconftail::ConfigurationTailConstructor* _mainDFConstructor;
};

//------------------------------------------------------------------------------
ConfigurationTailUnitTest::ConfigurationTailUnitTest():
     RawDAQDataUnitTest(new rawconftail::ConfigurationTailConstructor())
    ,_mainDFConstructor((rawconftail::ConfigurationTailConstructor*)_dataFormatConstructor)
{
}

//------------------------------------------------------------------------------
ConfigurationTailUnitTest::~ConfigurationTailUnitTest() { }

//------------------------------------------------------------------------------
void ConfigurationTailUnitTest::basicFieldGetAndSetChecksForGivenVersion(const version_t version) {

    RawConfigurationTail* df = (RawConfigurationTail*)_mainDFConstructor->getEmptyDataFormat(version);

    ASSERT_CHECK_FIELD     (CRC);

    CPPUNIT_ASSERT(df->getMarkerLo1() == rawconftail::Marker_value[0]);
    CPPUNIT_ASSERT(df->getMarkerLo2() == rawconftail::Marker_value[1]);

    CPPUNIT_ASSERT(version == (version_t) df->getVersion());

    ASSERT_PRINT_IS_NOT_UNKNOWN;
    
    delete df;
}

//CPPUNIT_TEST_SUITE_REGISTRATION(ConfigurationTailUnitTest);
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(ConfigurationTailUnitTest, "DAQDataFormats");
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("DAQDataFormats");

}// end of class
