/* 
 * File:   DataBlockConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef DATABLOCKCONSTRUCTOR_H
#define	DATABLOCKCONSTRUCTOR_H

#include "DAQDataFormats/RawDataBlock.h"
#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "DAQDataFormats/../unittest/DataBlockHeaderConstructor.h"
#include "DAQDataFormats/../unittest/TriggerConstructor.h"
#include "DAQDataFormats/../unittest/MicroBlockConstructor.h"
#include "DAQDataFormats/../unittest/MilliSliceConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawDataBlock
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE datablock
#include "DAQDataFormats/DataFormatLast.inc"


namespace daqdataformats {


class DataBlockConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    DataBlockConstructor();
    ~DataBlockConstructor();

    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)  const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)  const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)      const;

    /// Gets the DataBlock version
    version_t getDataBlockVersion(const RawDataBlock*) const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawDataBlock*  nano_ver = (const RawDataBlock*)inver;
        return nano_ver->getHeader()->getVersion();
    }
private:

    daqdataformats::RawDataBlock* constructDataBlock(const daqdataformats::version_t) const;

public:
    datablockheader::DataBlockHeaderConstructor _DataBlockHeaderConstructor;
    TriggerConstructor                          _TriggerConstructor;
    microblock::MicroBlockConstructor           _MicroBlockConstructor;
    MilliSliceConstructor                       _MilliSliceConstructor;

};

}// end of namespaces


#endif	/* DATABLOCKCONSTRUCTOR_H */

