/* 
 * File:   DataBlockHeaderConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/DataBlockHeaderConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawDataBlockHeader
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE datablockheader
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

//------------------------------------------------------------------------------
DataBlockHeaderConstructor::DataBlockHeaderConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::CURRENT_FIELDS_SUB_NAMESPACE::RAWDATABLOCKHEADER_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
DataBlockHeaderConstructor::~DataBlockHeaderConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* DataBlockHeaderConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawDataBlockHeader* out = (RawDataBlockHeader*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* DataBlockHeaderConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawDataBlockHeader(ver);
}

//------------------------------------------------------------------------------
bool DataBlockHeaderConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawDataBlockHeader* datablock = (daqdataformats::RawDataBlockHeader*)dataformat;
    setFieldToTestValue_TrigNumLo(datablock);
    setFieldToTestValue_TrigNumHi(datablock);
    setFieldToTestValue_BuffId(datablock);
    setFieldToTestValue_MonteCarloFlag(datablock);
    setFieldToTestValue_CRCCalculationUsed(datablock);
    setFieldToTestValue_ConnectionInitialization(datablock);
    setFieldToTestValue_CloseConnection(datablock);
    setFieldToTestValue_MissingData(datablock);
    setFieldToTestValue_DataSize(datablock);

    return true;
}

}}// end of namespaces
