/* 
 * File:   DataBlockHeaderConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef DATABLOCKHEADERCONSTRUCTOR_H
#define	DATABLOCKHEADERCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawDataBlockHeader.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawDataBlockHeader
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE datablockheader
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {
            enum DataBlockHeaderTestValues {
                TEST_VALUE_TrigNumLo   = 123,
                TEST_VALUE_TrigNumHi   = 124,
                TEST_VALUE_NumMicroBlocks   = 125,
                TEST_VALUE_BuffId   = 126,
                TEST_VALUE_DataSize   = 128,
                TEST_VALUE_MonteCarloFlag   = 1,
                TEST_VALUE_CRCCalculationUsed   = 1,
                TEST_VALUE_ConnectionInitialization   = 1,
                TEST_VALUE_CloseConnection   = 1,
                TEST_VALUE_MissingData   = 1,
	    };// end of DataBlockHeaderMASKS

class DataBlockHeaderConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    DataBlockHeaderConstructor();
    ~DataBlockHeaderConstructor();
    DEFINE_TESTVALUE        (TrigNumLo);
    DEFINE_TESTVALUE        (TrigNumHi);
    DEFINE_TESTVALUE_CUSTOM (NumMicroBlocks, uint16_t);
    DEFINE_TESTVALUE_CUSTOM (BuffId, uint16_t);
    DEFINE_TESTVALUE        (DataSize);
    DEFINE_TESTVALUE_BOOL   (MonteCarloFlag);
    DEFINE_TESTVALUE_IS     (CRCCalculationUsed);
    DEFINE_TESTVALUE_IS     (ConnectionInitialization);
    DEFINE_TESTVALUE_IS     (CloseConnection);
    DEFINE_TESTVALUE_IS     (MissingData);
    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawDataBlockHeader* nano_ver = (const RawDataBlockHeader*)inver;
        return nano_ver->getVersion();
    }
    
private:

};

}}// end of namespaces


#endif	/* DATABLOCKHEADERCONSTRUCTOR_H */

