/* 
 * File:   EventConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef EVENTCONSTRUCTOR_H
#define	EVENTCONSTRUCTOR_H

#include "DAQDataFormats/RawEvent.h"
#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "DAQDataFormats/../unittest/EventHeaderConstructor.h"
#include "DAQDataFormats/../unittest/TriggerConstructor.h"
#include "DAQDataFormats/../unittest/DataBlockConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawEvent
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE rawevent
#include "DAQDataFormats/DataFormatLast.inc"


namespace daqdataformats {


class EventConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    EventConstructor();
    ~EventConstructor();

    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)  const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)  const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)      const;

    /// Gets the Event version
    version_t getEventVersion(const RawEvent*) const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawEvent*  nano_ver = (const RawEvent*)inver;
        return nano_ver->getHeader()->getVersion();
    }
private:

    daqdataformats::RawEvent* constructEvent(const daqdataformats::version_t) const;

public:
    raweventhdr::EventHeaderConstructor _EventHeaderConstructor;
    TriggerConstructor                  _TriggerConstructor;
    DataBlockConstructor                _DataBlockConstructor;

};

}// end of namespaces


#endif	/* EVENTCONSTRUCTOR_H */

