/* 
 * File:   EventHeaderConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef EVENTHEADERCONSTRUCTOR_H
#define	EVENTHEADERCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawEventHeader.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawEventHeader
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE raweventhdr
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {
            enum EventHeaderTestValues {
                TEST_VALUE_DataLoggerID   = 123,
                TEST_VALUE_RunNumber   = 124,
                TEST_VALUE_RunType   = 125,
                TEST_VALUE_ConfigIDX   = 126,
                TEST_VALUE_Partition   = 127,
                TEST_VALUE_Subrun   = 12,
                TEST_VALUE_EventNumberLo   = 129,
                TEST_VALUE_EventNumberHi   = 130,
                TEST_VALUE_EventType   = 131,
                TEST_VALUE_EventSize   = 132,
                TEST_VALUE_DataBlockNumber   = 133,
                TEST_VALUE_TriggerFilled   = 1,
                TEST_VALUE_TailFilled   = 1,
                TEST_VALUE_MonteCarloFlag   = 1,
                TEST_VALUE_CRCCalculationUsed   = 1,
                TEST_VALUE_EventIncomplete   = 1,
                TEST_VALUE_EventNumber   = 123,
	    };// end of EventHeaderMASKS
class EventHeaderConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    EventHeaderConstructor();
    ~EventHeaderConstructor();
    DEFINE_TESTVALUE        (DataLoggerID);
    DEFINE_TESTVALUE        (RunNumber);
    DEFINE_TESTVALUE        (RunType);
    DEFINE_TESTVALUE        (ConfigIDX);
    DEFINE_TESTVALUE        (Partition);
    DEFINE_TESTVALUE        (Subrun);
    DEFINE_TESTVALUE        (EventNumberLo);
    DEFINE_TESTVALUE        (EventNumberHi);
    DEFINE_TESTVALUE        (EventType);
    DEFINE_TESTVALUE        (EventSize);
    DEFINE_TESTVALUE        (DataBlockNumber);
    DEFINE_TESTVALUE        (TriggerFilled);
    DEFINE_TESTVALUE        (TailFilled);
    DEFINE_TESTVALUE_BOOL   (MonteCarloFlag);
    DEFINE_TESTVALUE_IS     (CRCCalculationUsed);
    DEFINE_TESTVALUE_IS     (EventIncomplete);
    DEFINE_TESTVALUE_64     (EventNumber);
    
    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawEventHeader* nano_ver = (const RawEventHeader*)inver;
        return nano_ver->getVersion();
    }
    
private:

};

}}// end of namespaces


#endif	/* EVENTHEADERCONSTRUCTOR_H */

