/* 
 * File:   EventTailConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/EventTailConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawEventTail
#define  CURRENT_CLASS_VERSION        0
#define  CURRENT_FIELDS_SUB_NAMESPACE raweventtail
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

//------------------------------------------------------------------------------
EventTailConstructor::EventTailConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::CURRENT_FIELDS_SUB_NAMESPACE::RAWEVENTTAIL_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
EventTailConstructor::~EventTailConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* EventTailConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawEventTail* out = (RawEventTail*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* EventTailConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawEventTail(ver);
}

//------------------------------------------------------------------------------
bool EventTailConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawEventTail* eventheader = (daqdataformats::RawEventTail*)dataformat;

    setFieldToTestValue_EventNumberLo(eventheader);
    setFieldToTestValue_EventNumberHi(eventheader);
    setFieldToTestValue_EventSize(eventheader);
    
    return true;
}

}}// end of namespaces
