/* 
 * File:   EventTailConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef EVENTHEADERCONSTRUCTOR_H
#define	EVENTHEADERCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "EventHeaderConstructor.h"
#include "DAQDataFormats/RawEventTail.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawEventTail
#define  CURRENT_CLASS_VERSION        0
#define  CURRENT_FIELDS_SUB_NAMESPACE raweventtail
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

                enum EventTailTestValues {
                    TEST_VALUE_EventNumberLo   = 123,
                    TEST_VALUE_EventNumberHi   = 123,
                    TEST_VALUE_EventSize   = 123,
                };


    class EventTailConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    EventTailConstructor();
    ~EventTailConstructor();
    DEFINE_TESTVALUE        (EventNumberLo);
    DEFINE_TESTVALUE        (EventNumberHi);
    DEFINE_TESTVALUE        (EventSize);
    
    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawEventTail* nano_ver = (const RawEventTail*)inver;
        return nano_ver->getVersion();
    }
    

};

}}// end of namespaces


#endif	/* EVENTHEADERCONSTRUCTOR_H */

