/* 
 * File:   EventTailUnitTest.cpp
 * Author: denis
 * 
 * Created on September 24, 2012, 10:18 AM
 */
//#include "DAQDataFormats/../unittest/RawDAQDataUnitTest.h"
//#include "DAQDataFormats/../unittest/EventTailConstructor.h"
#include "RawDAQDataUnitTest.h"
#include "EventTailConstructor.h"

namespace daqdataformats {

class EventTailUnitTest : public RawDAQDataUnitTest {
    CPPUNIT_TEST_SUITE(EventTailUnitTest);
    CPPUNIT_TEST(basicFieldGetAndSetChecks);
    CPPUNIT_TEST(testReadDataIntoSameVersion);
    CPPUNIT_TEST(testReadDataIntoUnknownVersion);
    CPPUNIT_TEST(checkDeepCopyConstructor);
    CPPUNIT_TEST(checkShallowCopyConstructor);
    CPPUNIT_TEST_SUITE_END();
public:
    EventTailUnitTest();
    ~EventTailUnitTest();

    DEFINE_checkDeepCopyConstructor(RawEventTail)
    DEFINE_checkShallowCopyConstructor(RawEventTail)
    DEFINE_testReadDataIntoSameVersion
    DEFINE_testReadDataIntoUnknownVersion

private:
    void basicFieldGetAndSetChecksForGivenVersion(const version_t);

private:
    raweventtail::EventTailConstructor* _mainDFConstructor;
};

//------------------------------------------------------------------------------
EventTailUnitTest::EventTailUnitTest():
     RawDAQDataUnitTest(new raweventtail::EventTailConstructor())
    ,_mainDFConstructor((raweventtail::EventTailConstructor*)_dataFormatConstructor)
{
}

//------------------------------------------------------------------------------
EventTailUnitTest::~EventTailUnitTest() { }

//------------------------------------------------------------------------------
void EventTailUnitTest::basicFieldGetAndSetChecksForGivenVersion(const version_t version) {

    RawEventTail* df = (RawEventTail*)_mainDFConstructor->getEmptyDataFormat(version);


    ASSERT_CHECK_FIELD        (EventNumberLo);
    ASSERT_CHECK_FIELD        (EventNumberHi);
    ASSERT_CHECK_FIELD        (EventSize);
    
    CPPUNIT_ASSERT(version == (version_t) df->getVersion());

    ASSERT_PRINT_IS_NOT_UNKNOWN;

    delete df;
}

//CPPUNIT_TEST_SUITE_REGISTRATION(EventTailUnitTest);
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(EventTailUnitTest, "DAQDataFormats");
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("DAQDataFormats");

}// end of class
