/* 
 * File:   MicroBlockConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef MICROBLOCKCONSTRUCTOR_H
#define	MICROBLOCKCONSTRUCTOR_H

#include "DAQDataFormats/RawMicroBlock.h"
#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "MilliSliceConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMicroBlock
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE microblock
#include "DAQDataFormats/DataFormatLast.inc"


namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

class MicroBlockConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    MicroBlockConstructor();
    ~MicroBlockConstructor();

    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)  const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)  const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)      const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawMicroBlock*  nano_ver = (const RawMicroBlock*)inver;
        return nano_ver->getHeader()->getVersion();
    }

public:
    MilliSliceConstructor _milliSliceConstructor;

};

}}// end of namespaces


#endif	/* MICROBLOCKCONSTRUCTOR_H */

