/* 
 * File:   MicroBlockHeaderConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/MicroBlockHeaderConstructor.h"
/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMicroBlockHeader
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE microblock
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

//------------------------------------------------------------------------------
MicroBlockHeaderConstructor::MicroBlockHeaderConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::CURRENT_FIELDS_SUB_NAMESPACE::RAWMICROBLOCK_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
MicroBlockHeaderConstructor::~MicroBlockHeaderConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* MicroBlockHeaderConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawMicroBlockHeader* out = (RawMicroBlockHeader*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* MicroBlockHeaderConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawMicroBlockHeader(ver);
}

//------------------------------------------------------------------------------
bool MicroBlockHeaderConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawMicroBlockHeader* microblock = (daqdataformats::RawMicroBlockHeader*)dataformat;
    setFieldToTestValue_DestBuffID(microblock);
    setFieldToTestValue_Partition(microblock);
    return true;
}

}}// end of namespaces
