/* 
 * File:   MicroBlockHeaderConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef MICROBLOCKHEADERCONSTRUCTOR_H
#define	MICROBLOCKHEADERCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawMicroBlockHeader.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMicroBlockHeader
#define  LAST_CLASS_VERSION           1
#define  CURRENT_FIELDS_SUB_NAMESPACE microblock
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

            enum MicroBlockHeaderTestValues {
                TEST_VALUE_DestBuffID  = 12, //! Link Status                         (1 bit)
                TEST_VALUE_Partition   = 4, //! Denis Perevalov Present/Absent flag (1 bit)
	    };// end of MicroBlockHeaderMASKS

class MicroBlockHeaderConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    MicroBlockHeaderConstructor();
    ~MicroBlockHeaderConstructor();
    DEFINE_TESTVALUE     (DestBuffID);
    DEFINE_TESTVALUE     (Partition);
    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawMicroBlockHeader* nano_ver = (const RawMicroBlockHeader*)inver;
        return nano_ver->getVersion();
    }
    
private:

};

}}// end of namespaces


#endif	/* MICROBLOCKHEADERCONSTRUCTOR_H */

