/* 
 * File:   MicroBlockHeaderUnitTest.cpp
 * Author: denis
 * 
 * Created on September 24, 2012, 10:18 AM
 */
//#include "DAQDataFormats/../unittest/RawDAQDataUnitTest.h"
//#include "DAQDataFormats/../unittest/MicroBlockHeaderConstructor.h"
#include "RawDAQDataUnitTest.h"
#include "MicroBlockHeaderConstructor.h"

namespace daqdataformats {

class MicroBlockHeaderUnitTest : public RawDAQDataUnitTest {
    CPPUNIT_TEST_SUITE(MicroBlockHeaderUnitTest);
    CPPUNIT_TEST(basicFieldGetAndSetChecks);
    CPPUNIT_TEST(testReadDataIntoSameVersion);
    CPPUNIT_TEST(testReadDataIntoUnknownVersion);
    CPPUNIT_TEST(checkDeepCopyConstructor);
    CPPUNIT_TEST(checkShallowCopyConstructor);
    CPPUNIT_TEST_SUITE_END();
public:
    MicroBlockHeaderUnitTest();
    ~MicroBlockHeaderUnitTest();

    DEFINE_checkDeepCopyConstructor(RawMicroBlockHeader)
    DEFINE_checkShallowCopyConstructor(RawMicroBlockHeader)
    DEFINE_testReadDataIntoSameVersion
    DEFINE_testReadDataIntoUnknownVersion

private:
    void basicFieldGetAndSetChecksForGivenVersion(const version_t);

private:
    microblock::MicroBlockHeaderConstructor* _mainDFConstructor;
};

//------------------------------------------------------------------------------
MicroBlockHeaderUnitTest::MicroBlockHeaderUnitTest():
     RawDAQDataUnitTest(new microblock::MicroBlockHeaderConstructor())
    ,_mainDFConstructor((microblock::MicroBlockHeaderConstructor*)_dataFormatConstructor)
{
}

//------------------------------------------------------------------------------
MicroBlockHeaderUnitTest::~MicroBlockHeaderUnitTest() { }

//------------------------------------------------------------------------------
void MicroBlockHeaderUnitTest::basicFieldGetAndSetChecksForGivenVersion(const version_t version) {

    RawMicroBlockHeader* df = (RawMicroBlockHeader*)_mainDFConstructor->getEmptyDataFormat(version);
    ASSERT_CHECK_FIELD(DestBuffID);
    ASSERT_CHECK_FIELD(Partition);
    CPPUNIT_ASSERT(version == (version_t) df->getVersion());

    ASSERT_PRINT_IS_NOT_UNKNOWN;
    
    delete df;
}

//CPPUNIT_TEST_SUITE_REGISTRATION(MicroBlockHeaderUnitTest);
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(MicroBlockHeaderUnitTest, "DAQDataFormats");
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("DAQDataFormats");

}// end of class
