/* 
 * File:   MicroSliceConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef MICROSLICECONSTRUCTOR_H
#define	MICROSLICECONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawMicroSlice.h"
#include "NanoSliceConstructor.h"

#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMicroSlice

namespace daqdataformats {

            const uint32_t TEST_VALUE_MonteCarloFlag     = 1;
            const uint32_t TEST_VALUE_LowWord            = 5;
            const uint32_t TEST_VALUE_HighWord           = 8;
            const uint64_t TEST_VALUE_Time               = 0xB00000000A0L;

class MicroSliceConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    MicroSliceConstructor();
    ~MicroSliceConstructor();
    
    DEFINE_TESTVALUE_BOOL(MonteCarloFlag);
    DEFINE_TESTVALUE     (LowWord);
    DEFINE_TESTVALUE     (HighWord);
    DEFINE_TESTVALUE_64  (Time);

    daqdataformats::RawDAQData* getFilledDataFormat(const version_t) const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const version_t) const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*) const;

    /// Gets the NanoSlices version in the MicroSlice
    version_t getNanoSlicesVersion(const RawMicroSlice*) const;
    
public:

    version_t                     _currentNanoSliceVersion;

    rawnano::NanoSliceConstructor _nanosliceConstructor;

};

}// end of namespaces


#endif	/* MICROSLICECONSTRUCTOR_H */

