/* 
 * File:   MicroSliceHeaderConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/MicroSliceHeaderConstructor.h"

namespace daqdataformats {

//------------------------------------------------------------------------------
MicroSliceHeaderConstructor::MicroSliceHeaderConstructor(){ }

//------------------------------------------------------------------------------
MicroSliceHeaderConstructor::~MicroSliceHeaderConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* MicroSliceHeaderConstructor::getFilledDataFormat(const version_t) const {
    RawMicroSliceHeader* out = (RawMicroSliceHeader*)getEmptyDataFormat(-1);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* MicroSliceHeaderConstructor::getEmptyDataFormat(const version_t) const {
    return new daqdataformats::RawMicroSliceHeader();
}

//------------------------------------------------------------------------------
bool MicroSliceHeaderConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawMicroSliceHeader* microsliceheader = (daqdataformats::RawMicroSliceHeader*)dataformat;
    setFieldToTestValue_DataPresent(microsliceheader);
    setFieldToTestValue_MonteCarloFlag(microsliceheader);
    setFieldToTestValue_ByteCount(microsliceheader);
    return true;
}

}// end of namespaces
