/* 
 * File:   MicroSliceHeaderUnitTest.cpp
 * Author: denis
 * 
 * Created on September 24, 2012, 10:18 AM
 */
//#include "DAQDataFormats/../unittest/RawDAQDataUnitTest.h"
//#include "DAQDataFormats/../unittest/MicroSliceHeaderConstructor.h"
#include "RawDAQDataUnitTest.h"
#include "MicroSliceHeaderConstructor.h"

namespace daqdataformats {

class MicroSliceHeaderUnitTest : public RawDAQDataUnitTest {
    CPPUNIT_TEST_SUITE(MicroSliceHeaderUnitTest);
    CPPUNIT_TEST(basicFieldGetAndSetChecks);
    CPPUNIT_TEST(checkDeepCopyConstructor);
    CPPUNIT_TEST(checkShallowCopyConstructor);
    CPPUNIT_TEST(testReadDataIntoSameVersion);
    CPPUNIT_TEST_SUITE_END();
public:
    MicroSliceHeaderUnitTest();
    ~MicroSliceHeaderUnitTest();

    DEFINE_checkDeepCopyConstructor(RawMicroSliceHeader)
    DEFINE_checkShallowCopyConstructor(RawMicroSliceHeader)
    DEFINE_testReadDataIntoSameVersion

    void basicFieldGetAndSetChecks();

private:
    MicroSliceHeaderConstructor* _mainDFConstructor;
};

//------------------------------------------------------------------------------
MicroSliceHeaderUnitTest::MicroSliceHeaderUnitTest():
     RawDAQDataUnitTest(new MicroSliceHeaderConstructor())
    ,_mainDFConstructor((MicroSliceHeaderConstructor*)_dataFormatConstructor)
{
}

//------------------------------------------------------------------------------
MicroSliceHeaderUnitTest::~MicroSliceHeaderUnitTest() { }

//------------------------------------------------------------------------------
void MicroSliceHeaderUnitTest::basicFieldGetAndSetChecks() {

    RawMicroSliceHeader* df = (RawMicroSliceHeader*)_mainDFConstructor->getEmptyDataFormat(rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION);
    ASSERT_CHECK_FIELD(DataPresent);
    ASSERT_CHECK_FIELD(MonteCarloFlag);
    ASSERT_CHECK_FIELD(ByteCount);

    ASSERT_PRINT_IS_NOT_UNKNOWN;

    delete df;
}

//CPPUNIT_TEST_SUITE_REGISTRATION(MicroSliceHeaderUnitTest);
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(MicroSliceHeaderUnitTest, "DAQDataFormats");
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("DAQDataFormats");

}// end of class
