/* 
 * File:   MilliSliceConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef MILLISLICECONSTRUCTOR_H
#define	MILLISLICECONSTRUCTOR_H

#include "DAQDataFormats/RawMilliSlice.h"
#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "MicroSliceConstructor.h"

#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMilliSlice


namespace daqdataformats {

class MilliSliceConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    MilliSliceConstructor();
    ~MilliSliceConstructor();

    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)  const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)  const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)      const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawMilliSlice*  nano_ver = (const RawMilliSlice*)inver;
        return nano_ver->getVersion();
    }

    /// Gets the NanoSlices version in the MilliSlice
    version_t getNanoSlicesVersion(const RawMilliSlice*) const;

public:
    MicroSliceConstructor _microSliceConstructor;


};

}// end of namespaces


#endif	/* MILLISLICECONSTRUCTOR_H */

