/* 
 * File:   MilliSliceHeaderConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/MilliSliceHeaderConstructor.h"

#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMilliSliceHeader
#define  CURRENT_FIELDS_SUB_NAMESPACE rawmillihdr

namespace daqdataformats {

//------------------------------------------------------------------------------
MilliSliceHeaderConstructor::MilliSliceHeaderConstructor()
{
}

//------------------------------------------------------------------------------
MilliSliceHeaderConstructor::~MilliSliceHeaderConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* MilliSliceHeaderConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawMilliSliceHeader* out = (RawMilliSliceHeader*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* MilliSliceHeaderConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawMilliSliceHeader();
}

//------------------------------------------------------------------------------
bool MilliSliceHeaderConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawMilliSliceHeader* millislice_header = (daqdataformats::RawMilliSliceHeader*)dataformat;

    setFieldToTestValue_SliceSize(millislice_header);
    setFieldToTestValue_Partition(millislice_header);
    setFieldToTestValue_DestBuffID(millislice_header);
    setFieldToTestValue_DiblockId(millislice_header);
    setFieldToTestValue_DCMId(millislice_header);
    setFieldToTestValue_DetId(millislice_header);
    setFieldToTestValue_GlobalDCMID(millislice_header);
    setFieldToTestValue_MilliSliceSEQ(millislice_header);
    setFieldToTestValue_TimeStartLow(millislice_header);
    setFieldToTestValue_TimeStartHigh(millislice_header);
    setFieldToTestValue_TimeLength(millislice_header);
    setFieldToTestValue_Complete(millislice_header);
    setFieldToTestValue_Mode(millislice_header);
    setFieldToTestValue_ConnectionInitialization(millislice_header);
    setFieldToTestValue_CloseConnection(millislice_header);
    setFieldToTestValue_MicrosliceNumber(millislice_header);
    setFieldToTestValue_FrameSEQ(millislice_header);
    setFieldToTestValue_MilliSliceIndexNumber(millislice_header);
    setFieldToTestValue_MicroSliceTimeLength_usec(millislice_header);
    setFieldToTestValue_MonteCarloFlag(millislice_header);
    setFieldToTestValue_CRCCalculationUsed(millislice_header);
    setFieldToTestValue_MilliSliceIndexUsed(millislice_header);
    

    return true;
}

}// end of namespaces
