/* 
 * File:   MilliSliceHeaderConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef MILLISLICEHEADERCONSTRUCTOR_H
#define	MILLISLICEHEADERCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawMilliSliceHeader.h"

#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawMilliSliceHeader
#define  CURRENT_FIELDS_SUB_NAMESPACE rawmillihdr

namespace daqdataformats {

                const uint32_t TEST_VALUE_SliceSize                = 4;
                const uint32_t TEST_VALUE_Partition                = 5;
                const uint32_t TEST_VALUE_DestBuffID               = 6;
                const uint32_t TEST_VALUE_DiblockId                = 7;
                const uint32_t TEST_VALUE_DCMId                    = 8;
                const uint32_t TEST_VALUE_DetId                    = 3;
                const uint32_t TEST_VALUE_GlobalDCMID              = 9;
                const uint32_t TEST_VALUE_MilliSliceSEQ            = 56;
                const uint32_t TEST_VALUE_TimeStartLow             = 57;
                const uint32_t TEST_VALUE_TimeStartHigh            = 58;
                const uint32_t TEST_VALUE_TimeLength               = 59;
                const uint32_t TEST_VALUE_Complete                 = 1;
                const rawmillihdr::Mode_t TEST_VALUE_Mode          = rawmillihdr::Mode_Discard_Empty_MicroSlices;
                const uint32_t TEST_VALUE_ConnectionInitialization = 1;
                const uint32_t TEST_VALUE_CloseConnection          = 1;
                const uint32_t TEST_VALUE_CorruptData              = 1;
                const uint32_t TEST_VALUE_MissingData              = 1;
                const uint32_t TEST_VALUE_MicrosliceNumber         = 60;
                const uint32_t TEST_VALUE_FrameSEQ                 = 42;
                const uint32_t TEST_VALUE_MilliSliceIndexNumber    = 61;
                const uint32_t TEST_VALUE_MicroSliceTimeLength_usec= 31;
                const uint32_t TEST_VALUE_MonteCarloFlag           = 1;
                const uint32_t TEST_VALUE_CRCCalculationUsed       = 1;
                const uint32_t TEST_VALUE_MilliSliceIndexUsed      = 1;

class MilliSliceHeaderConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    MilliSliceHeaderConstructor();
    ~MilliSliceHeaderConstructor();
    DEFINE_TESTVALUE     (SliceSize);
    DEFINE_TESTVALUE     (Partition);
    DEFINE_TESTVALUE     (DestBuffID);
    DEFINE_TESTVALUE     (DiblockId);
    DEFINE_TESTVALUE     (DCMId);
    DEFINE_TESTVALUE     (DetId);
    DEFINE_TESTVALUE     (GlobalDCMID);
    DEFINE_TESTVALUE     (MilliSliceSEQ);
    DEFINE_TESTVALUE     (TimeStartLow);
    DEFINE_TESTVALUE     (TimeStartHigh);
    DEFINE_TESTVALUE     (TimeLength);
    DEFINE_TESTVALUE_IS  (Complete);
    DEFINE_TESTVALUE_IS  (ConnectionInitialization);
    DEFINE_TESTVALUE_IS  (CloseConnection);
    DEFINE_TESTVALUE_IS  (CorruptData);
    DEFINE_TESTVALUE_IS  (MissingData);
    DEFINE_TESTVALUE     (MicrosliceNumber);
    DEFINE_TESTVALUE     (FrameSEQ);
    DEFINE_TESTVALUE     (MilliSliceIndexNumber);
    DEFINE_TESTVALUE     (MicroSliceTimeLength_usec);
    DEFINE_TESTVALUE_BOOL(MonteCarloFlag);
    DEFINE_TESTVALUE_IS  (CRCCalculationUsed);
    DEFINE_TESTVALUE_IS  (MilliSliceIndexUsed);
    bool     setFieldToTestValue_Mode(daqdataformats::CURRENT_CLASS* dataformat) const {return dataformat->setMode(TEST_VALUE_Mode);} 
    bool     setFieldToZeroValue_Mode(daqdataformats::CURRENT_CLASS* dataformat) const {return dataformat->setMode(rawmillihdr::Mode_Keep_All_MicroSlices);}
    uint64_t getFieldValue_Mode(const daqdataformats::CURRENT_CLASS* dataformat) const {return boost::lexical_cast<uint64_t> (dataformat->getMode());} 
    CHECK_FIELD(Mode)
    
    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawMilliSliceHeader* nano_ver = (const RawMilliSliceHeader*)inver;
        return nano_ver->getVersion();
    }
    
private:

};

}// end of namespaces


#endif	/* MILLISLICEHEADERCONSTRUCTOR_H */

