/* 
 * File:   MilliSliceHeaderUnitTest.cpp
 * Author: denis
 * 
 * Created on September 24, 2012, 10:18 AM
 */
//#include "DAQDataFormats/../unittest/RawDAQDataUnitTest.h"
//#include "DAQDataFormats/../unittest/MilliSliceHeaderConstructor.h"
#include "RawDAQDataUnitTest.h"
#include "MilliSliceHeaderConstructor.h"

namespace daqdataformats {

class MilliSliceHeaderUnitTest : public RawDAQDataUnitTest {
    CPPUNIT_TEST_SUITE(MilliSliceHeaderUnitTest);
    CPPUNIT_TEST(basicFieldGetAndSetChecks);
    CPPUNIT_TEST(testReadDataIntoSameVersion);
    CPPUNIT_TEST(checkDeepCopyConstructor);
    CPPUNIT_TEST(checkShallowCopyConstructor);
    CPPUNIT_TEST_SUITE_END();
public:
    MilliSliceHeaderUnitTest();
    ~MilliSliceHeaderUnitTest();

    DEFINE_checkDeepCopyConstructor(RawMilliSliceHeader)
    DEFINE_checkShallowCopyConstructor(RawMilliSliceHeader)
    DEFINE_testReadDataIntoSameVersion
    DEFINE_testReadDataIntoUnknownVersion

private:
    void basicFieldGetAndSetChecks();

private:
    MilliSliceHeaderConstructor* _mainDFConstructor;
};

//------------------------------------------------------------------------------
MilliSliceHeaderUnitTest::MilliSliceHeaderUnitTest():
     RawDAQDataUnitTest(new MilliSliceHeaderConstructor())
    ,_mainDFConstructor((MilliSliceHeaderConstructor*)_dataFormatConstructor)
{
}

//------------------------------------------------------------------------------
MilliSliceHeaderUnitTest::~MilliSliceHeaderUnitTest() { }

//------------------------------------------------------------------------------
void MilliSliceHeaderUnitTest::basicFieldGetAndSetChecks() {

    RawMilliSliceHeader* df = (RawMilliSliceHeader*)_mainDFConstructor->getEmptyDataFormat(rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION);
    ASSERT_CHECK_FIELD(SliceSize);
    ASSERT_CHECK_FIELD(Partition);
    ASSERT_CHECK_FIELD(DestBuffID);
    ASSERT_CHECK_FIELD(DiblockId);
    ASSERT_CHECK_FIELD(DCMId);
    ASSERT_CHECK_FIELD(DetId);
    ASSERT_CHECK_FIELD(GlobalDCMID);
    ASSERT_CHECK_FIELD(MilliSliceSEQ);
    ASSERT_CHECK_FIELD(TimeStartLow);
    ASSERT_CHECK_FIELD(TimeStartHigh);
    ASSERT_CHECK_FIELD(TimeLength);
    ASSERT_CHECK_FIELD(Complete);
    ASSERT_CHECK_FIELD(ConnectionInitialization);
    ASSERT_CHECK_FIELD(CloseConnection);
    ASSERT_CHECK_FIELD(MicrosliceNumber);
    ASSERT_CHECK_FIELD(FrameSEQ);
    ASSERT_CHECK_FIELD(MilliSliceIndexNumber);
    ASSERT_CHECK_FIELD(MicroSliceTimeLength_usec);
    ASSERT_CHECK_FIELD(MonteCarloFlag);
    ASSERT_CHECK_FIELD(CRCCalculationUsed);
    ASSERT_CHECK_FIELD(MilliSliceIndexUsed);

    CPPUNIT_ASSERT((version_t) df->getVersion() == 0);

    ASSERT_PRINT_IS_NOT_UNKNOWN;

    delete df;
}

//CPPUNIT_TEST_SUITE_REGISTRATION(MilliSliceHeaderUnitTest);
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(MilliSliceHeaderUnitTest, "DAQDataFormats");
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("DAQDataFormats");

}// end of class
