/* 
 * File:   NanoSliceConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */

#include <DAQDataFormats/RawNanoSlice.h>

#include "DAQDataFormats/../unittest/NanoSliceConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawNanoSlice
#define  LAST_CLASS_VERSION           2
#define  CURRENT_FIELDS_SUB_NAMESPACE rawnano
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

NanoSliceConstructor::NanoSliceConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::nanosliceheader::RAWNANOSLICE_LATEST_VERSION)
{
}
NanoSliceConstructor::~NanoSliceConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* NanoSliceConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawNanoSlice* out = (RawNanoSlice*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* NanoSliceConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const {
    return new daqdataformats::RawNanoSlice(ver);
}

//------------------------------------------------------------------------------
bool NanoSliceConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawNanoSlice* nanoslice = (daqdataformats::RawNanoSlice*)dataformat;

    setFieldToTestValue_TimeStamp(nanoslice);
    if(nanoslice->getHeader()->getVersion() == 0){
    setFieldToTestValue_PulseHeight(nanoslice);
    }
    if(nanoslice->getHeader()->getVersion() == 1){
        setFieldToTestValue_Value1(nanoslice);
    }
    if(nanoslice->getHeader()->getVersion() == 2){
        //setFieldToTestValue_Value1(nanoslice);
        //setFieldToTestValue_Value2(nanoslice);
    }

    daqdataformats::RawNanoSliceHeader* nanoslice_header = (daqdataformats::RawNanoSliceHeader*)nanoslice->getHeader();

    _nanoSliceHeaderConstructor.fillDataFormat(nanoslice_header);




    return true;
}

//------------------------------------------------------------------------------
// Gets the NanoSlice version
version_t NanoSliceConstructor::getNanoSliceVersion(const RawNanoSlice* nano) const{
    return (version_t) nano->getHeader()->getVersion();
}

}}// end of namespaces
