/* 
 * File:   NanoSliceConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef NANOSLICECONSTRUCTOR_H
#define	NANOSLICECONSTRUCTOR_H

#include "DAQDataFormats/RawNanoSlice.h"
#include "RawDAQDataConstructor.h"
#include "NanoSliceHeaderConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawNanoSlice
#define  LAST_CLASS_VERSION           3
#define  CURRENT_FIELDS_SUB_NAMESPACE rawnano
#include "DAQDataFormats/DataFormatLast.inc"


namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

            enum NanoSliceTestValues {
                TEST_VALUE_TimeStamp   = 1067,
                TEST_VALUE_PulseHeight = 34,
                TEST_VALUE_Value1      = 12
	    };// end of NanoSliceMASKS

class NanoSliceConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    NanoSliceConstructor();
    ~NanoSliceConstructor();
    DEFINE_TESTVALUE(TimeStamp);
    DEFINE_TESTVALUE(PulseHeight);
    DEFINE_TESTVALUE(Value1);

    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)  const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)  const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)      const;

    /// Gets the NanoSlice version
    version_t getNanoSliceVersion(const RawNanoSlice*) const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawNanoSlice*  nano_ver = (const RawNanoSlice*)inver;
        return nano_ver->getHeader()->getVersion();
    }

public:
    nanosliceheader::NanoSliceHeaderConstructor _nanoSliceHeaderConstructor;

};

}}// end of namespaces


#endif	/* NANOSLICECONSTRUCTOR_H */

