/* 
 * File:   NanoSliceHeaderConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/NanoSliceHeaderConstructor.h"
/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawNanoSliceHeader
#define  LAST_CLASS_VERSION           2
#define  CURRENT_FIELDS_SUB_NAMESPACE nanosliceheader
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

//------------------------------------------------------------------------------
NanoSliceHeaderConstructor::NanoSliceHeaderConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::nanosliceheader::RAWNANOSLICE_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
NanoSliceHeaderConstructor::~NanoSliceHeaderConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* NanoSliceHeaderConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawNanoSliceHeader* out = (RawNanoSliceHeader*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* NanoSliceHeaderConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawNanoSliceHeader(ver);
}

//------------------------------------------------------------------------------
bool NanoSliceHeaderConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawNanoSliceHeader* nanoslice = (daqdataformats::RawNanoSliceHeader*)dataformat;
    setFieldToTestValue_LinkStatus(nanoslice);
    setFieldToTestValue_DataPresent(nanoslice);
    setFieldToTestValue_DebugMode(nanoslice);
    setFieldToTestValue_FEBId(nanoslice);
    setFieldToTestValue_FEBStatus(nanoslice);
    setFieldToTestValue_PixelAddr(nanoslice);
    setFieldToTestValue_Sequence(nanoslice);
    setFieldToTestValue_Pad3(nanoslice);
    setFieldToTestValue_DAQEnabled(nanoslice);
    setFieldToTestValue_BufferEmpty(nanoslice);
    setFieldToTestValue_BufferFull(nanoslice);
    setFieldToTestValue_CommError(nanoslice);
    setFieldToTestValue_PacketError(nanoslice);
    setFieldToTestValue_OverflowError(nanoslice);
    setFieldToTestValue_ADCError(nanoslice);
    return true;
}

}}// end of namespaces
