/* 
 * File:   RunHeaderConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/RunHeaderConstructor.h"

// It is requred to
//   1. include DAQDataFormats/DataFormatFirst.inc
//   2. define CURRENT_CLASS
//   3.    define CURRENT_CLASS_VERSION for version of the class
//      OR define LAST_CLASS_VERSION    for the main structure of the class
//   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
//   5. include DAQDataFormats/DataFormatLast.inc
// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawRunHeader
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE rawrunhdr
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

//------------------------------------------------------------------------------
RunHeaderConstructor::RunHeaderConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::CURRENT_FIELDS_SUB_NAMESPACE::RAWRUNHEADER_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
RunHeaderConstructor::~RunHeaderConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* RunHeaderConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawRunHeader* out = (RawRunHeader*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* RunHeaderConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawRunHeader(ver);
}

//------------------------------------------------------------------------------
bool RunHeaderConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawRunHeader* runheader = (daqdataformats::RawRunHeader*)dataformat;


    setFieldToTestValue_UniversalEventStart(runheader);
    setFieldToTestValue_UniversalEventEnd(runheader);
    setFieldToTestValue_CRC(runheader);
    setFieldToTestValue_TriggerPrescaleListIDX(runheader);
    setFieldToTestValue_TriggerListIDX(runheader);
    setFieldToTestValue_ValidTriggerTypesHigh2(runheader);
    setFieldToTestValue_ValidTriggerTypesHigh(runheader);
    setFieldToTestValue_ValidTriggerTypesLow(runheader);
    setFieldToTestValue_VTMod(runheader);
    setFieldToTestValue_TriggerMC(runheader);
    setFieldToTestValue_TriggerCtrlID(runheader);
    setFieldToTestValue_TriggerVersion(runheader);
    setFieldToTestValue_RunSize(runheader);
    setFieldToTestValue_UniversalEventEndHi(runheader);
    setFieldToTestValue_UniversalEventEndLo(runheader);
    setFieldToTestValue_UniversalEventStartHi(runheader);
    setFieldToTestValue_UniversalEventStartLo(runheader);
    setFieldToTestValue_TotalEvents(runheader);
    setFieldToTestValue_RunEndTime(runheader);
    setFieldToTestValue_SubRunEndTime(runheader);
    setFieldToTestValue_SubRunStartTime(runheader);
    setFieldToTestValue_RunStartTime(runheader);
    setFieldToTestValue_DataLoggerID(runheader);
    setFieldToTestValue_DataLoggerVersion(runheader);
    setFieldToTestValue_RunControlID(runheader);
    setFieldToTestValue_RunControlVersion(runheader);
    setFieldToTestValue_ConfigurationBlockSet(runheader);
    setFieldToTestValue_Subrun(runheader);
    setFieldToTestValue_Partition(runheader);
    setFieldToTestValue_ConfigIDX(runheader);
    setFieldToTestValue_RunType(runheader);
    setFieldToTestValue_RunNumber(runheader);


    return true;
}

}}// end of namespaces
