/* 
 * File:   RunHeaderConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef RUNHEADERCONSTRUCTOR_H
#define	RUNHEADERCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawRunHeader.h"

// It is requred to
//   1. include DAQDataFormats/DataFormatFirst.inc
//   2. define CURRENT_CLASS
//   3.    define CURRENT_CLASS_VERSION for version of the class
//      OR define LAST_CLASS_VERSION    for the main structure of the class
//   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
//   5. include DAQDataFormats/DataFormatLast.inc
// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawRunHeader
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE rawrunhdr
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {
            enum RunHeaderTestValues {
                TEST_VALUE_RunNumber   = 123,
                TEST_VALUE_RunType   = 124,
                TEST_VALUE_ConfigIDX   = 125,
                TEST_VALUE_Partition   = 126,
                TEST_VALUE_Subrun   = 12,
                TEST_VALUE_ConfigurationBlockSet   = 1,
                TEST_VALUE_RunControlVersion   = 63,
                TEST_VALUE_RunControlID   = 129,
                TEST_VALUE_DataLoggerVersion   = 56,
                TEST_VALUE_DataLoggerID  = 45,
                TEST_VALUE_RunStartTime   = 136,
                TEST_VALUE_SubRunStartTime   = 137,
                TEST_VALUE_SubRunEndTime   = 138,
                TEST_VALUE_RunEndTime   = 139,
                TEST_VALUE_TotalEvents   = 140,
                TEST_VALUE_UniversalEventStartLo   = 141,
                TEST_VALUE_UniversalEventStartHi   = 142,
                TEST_VALUE_UniversalEventEndLo   = 143,
                TEST_VALUE_UniversalEventEndHi   = 144,
                TEST_VALUE_RunSize   = 145,
                TEST_VALUE_TriggerVersion   = 146,
                TEST_VALUE_TriggerCtrlID   = 147,
                TEST_VALUE_TriggerMC   = 1,
                TEST_VALUE_VTMod   = 1,
                TEST_VALUE_ValidTriggerTypesLow   = 149,
                TEST_VALUE_ValidTriggerTypesHigh   = 150,
                TEST_VALUE_ValidTriggerTypesHigh2   = 151,
                TEST_VALUE_TriggerListIDX   = 152,
                TEST_VALUE_TriggerPrescaleListIDX   = 153,
                TEST_VALUE_CRC   = 154,
                TEST_VALUE_UniversalEventStart   = 155,
                TEST_VALUE_UniversalEventEnd   = 156,
	    };// end of RunHeaderMASKS


class RunHeaderConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    RunHeaderConstructor();
    ~RunHeaderConstructor();
    DEFINE_TESTVALUE_64     (UniversalEventStart);
    DEFINE_TESTVALUE_64     (UniversalEventEnd);
    DEFINE_TESTVALUE        (CRC);
    DEFINE_TESTVALUE        (TriggerPrescaleListIDX);
    DEFINE_TESTVALUE        (TriggerListIDX);
    DEFINE_TESTVALUE        (ValidTriggerTypesHigh2);
    DEFINE_TESTVALUE        (ValidTriggerTypesHigh);
    DEFINE_TESTVALUE        (ValidTriggerTypesLow);
    DEFINE_TESTVALUE        (VTMod);
    DEFINE_TESTVALUE        (TriggerMC);
    DEFINE_TESTVALUE        (TriggerCtrlID);
    DEFINE_TESTVALUE        (TriggerVersion);
    DEFINE_TESTVALUE        (RunSize);
    DEFINE_TESTVALUE        (UniversalEventEndHi);
    DEFINE_TESTVALUE        (UniversalEventEndLo);
    DEFINE_TESTVALUE        (UniversalEventStartHi);
    DEFINE_TESTVALUE        (UniversalEventStartLo);
    DEFINE_TESTVALUE        (TotalEvents);
    DEFINE_TESTVALUE        (RunEndTime);
    DEFINE_TESTVALUE        (SubRunEndTime);
    DEFINE_TESTVALUE        (SubRunStartTime);
    DEFINE_TESTVALUE        (RunStartTime);
    DEFINE_TESTVALUE        (DataLoggerID);
    DEFINE_TESTVALUE        (DataLoggerVersion);
    DEFINE_TESTVALUE        (RunControlID);
    DEFINE_TESTVALUE        (RunControlVersion);
    DEFINE_TESTVALUE        (ConfigurationBlockSet);
    DEFINE_TESTVALUE        (Subrun);
    DEFINE_TESTVALUE        (Partition);
    DEFINE_TESTVALUE        (ConfigIDX);
    DEFINE_TESTVALUE        (RunType);
    DEFINE_TESTVALUE        (RunNumber);
    
    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawRunHeader* nano_ver = (const RawRunHeader*)inver;
        return nano_ver->getVersion();
    }
    
private:

};

}}// end of namespaces


#endif	/* RUNHEADERCONSTRUCTOR_H */

