/* 
 * File:   TimingMarkerUnitTest.cpp
 * Author: denis
 * 
 * Created on September 24, 2012, 10:18 AM
 */
//#include "DAQDataFormats/../unittest/RawDAQDataUnitTest.h"
//#include "DAQDataFormats/../unittest/TimingMarkerConstructor.h"
#include "RawDAQDataUnitTest.h"
#include "TimingMarkerConstructor.h"

namespace daqdataformats {

class TimingMarkerUnitTest : public RawDAQDataUnitTest {
    CPPUNIT_TEST_SUITE(TimingMarkerUnitTest);
    CPPUNIT_TEST(basicFieldGetAndSetChecks);
    CPPUNIT_TEST(checkDeepCopyConstructor);
    CPPUNIT_TEST(checkShallowCopyConstructor);
    CPPUNIT_TEST(testReadDataIntoSameVersion);
    CPPUNIT_TEST_SUITE_END();
public:
    TimingMarkerUnitTest();
    ~TimingMarkerUnitTest();

    DEFINE_checkDeepCopyConstructor(RawTimingMarker)
    DEFINE_checkShallowCopyConstructor(RawTimingMarker)
    DEFINE_testReadDataIntoSameVersion

    void basicFieldGetAndSetChecks();

private:
    TimingMarkerConstructor* _mainDFConstructor;
};

//------------------------------------------------------------------------------
TimingMarkerUnitTest::TimingMarkerUnitTest():
     RawDAQDataUnitTest(new TimingMarkerConstructor())
    ,_mainDFConstructor((TimingMarkerConstructor*)_dataFormatConstructor)
{
}

//------------------------------------------------------------------------------
TimingMarkerUnitTest::~TimingMarkerUnitTest() { }

//------------------------------------------------------------------------------
void TimingMarkerUnitTest::basicFieldGetAndSetChecks() {

    RawTimingMarker* df = (RawTimingMarker*)_mainDFConstructor->getEmptyDataFormat(rawdaqdataformat::DAQDATAFORMAT_UNKNOWN_VERSION);
    ASSERT_CHECK_FIELD(LowWord);
    ASSERT_CHECK_FIELD(HighWord);
    ASSERT_CHECK_FIELD(Time);

    ASSERT_PRINT_IS_NOT_UNKNOWN;

    delete df;
}

//CPPUNIT_TEST_SUITE_REGISTRATION(TimingMarkerUnitTest);
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(TimingMarkerUnitTest, "DAQDataFormats");
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("DAQDataFormats");

}// end of class
