/* 
 * File:   TriggerConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef TRIGGERCONSTRUCTOR_H
#define	TRIGGERCONSTRUCTOR_H

#include "DAQDataFormats/RawTrigger.h"
#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "DAQDataFormats/../unittest/TriggerHeaderConstructor.h"
#include "DAQDataFormats/../unittest/TriggerMaskConstructor.h"
#include "DAQDataFormats/../unittest/TriggerRangeConstructor.h"
#include "DAQDataFormats/../unittest/TriggerTimeConstructor.h"
#include "DAQDataFormats/../unittest/TriggerTimingMarkerConstructor.h"


/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTrigger
#define  LAST_CLASS_VERSION           2
#define  CURRENT_FIELDS_SUB_NAMESPACE rawtrigger
#include "DAQDataFormats/DataFormatLast.inc"


namespace daqdataformats {


class TriggerConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    TriggerConstructor();
    ~TriggerConstructor();

    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)  const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)  const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)      const;

    /// Gets the Trigger version
    version_t getTriggerVersion(const RawTrigger*) const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawTrigger*  trigger = (const RawTrigger*)inver;
        return trigger->getTriggerHeader()->getVersion();
    }

public:
    TriggerHeaderConstructor       _TriggerHeaderConstructor;
    triggermask::TriggerMaskConstructor         _TriggerMaskConstructor;
    TriggerRangeConstructor        _TriggerRangeConstructor;
    TriggerTimeConstructor         _TriggerTimeConstructor;
    TriggerTimingMarkerConstructor _TriggerTimingMarkerConstructor;

};

}// end of namespaces


#endif	/* TRIGGERCONSTRUCTOR_H */

