/* 
 * File:   TriggerHeaderConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/TriggerHeaderConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerHeader
#define  LAST_CLASS_VERSION           2
#define  CURRENT_FIELDS_SUB_NAMESPACE triggerheader
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

//------------------------------------------------------------------------------
TriggerHeaderConstructor::TriggerHeaderConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::triggerheader::RAWTRIGGERHEADER_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
TriggerHeaderConstructor::~TriggerHeaderConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* TriggerHeaderConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawTriggerHeader* out = (RawTriggerHeader*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* TriggerHeaderConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawTriggerHeader(ver);
}

//------------------------------------------------------------------------------
bool TriggerHeaderConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawTriggerHeader* triggerheader = (daqdataformats::RawTriggerHeader*)dataformat;
    setFieldToTestValue_HWFlag(triggerheader);
    setFieldToTestValue_Source(triggerheader);
    setFieldToTestValue_SourceSubID(triggerheader);
    setFieldToTestValue_TriggerNumberLow(triggerheader);
    setFieldToTestValue_TriggerNumberHigh(triggerheader);
    setFieldToTestValue_MasterTriggerNumberLow(triggerheader);
    setFieldToTestValue_MasterTriggerNumberHigh(triggerheader);
    return true;
}

}// end of namespaces
