/* 
 * File:   TriggerHeaderConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef TRIGGERHEADERCONSTRUCTOR_H
#define	TRIGGERHEADERCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawTriggerHeader.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerHeader
#define  LAST_CLASS_VERSION           2
#define  CURRENT_FIELDS_SUB_NAMESPACE triggerheader
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

            enum TriggerHeaderTestValues{
                    TEST_VALUE_HWFlag                  = 1,
                    TEST_VALUE_Source                  = 2,
                    TEST_VALUE_SourceSubID             = 3,
                    TEST_VALUE_SourceID                = 4,
                    TEST_VALUE_TriggerNumberLow        = 5,
                    TEST_VALUE_TriggerNumberHigh       = 6,
                    TEST_VALUE_MasterTriggerNumberLow  = 7,
                    TEST_VALUE_MasterTriggerNumberHigh = 8
            };// end of TriggerHeaderMASKS



class TriggerHeaderConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    TriggerHeaderConstructor();
    ~TriggerHeaderConstructor();
    DEFINE_TESTVALUE     (HWFlag);
    DEFINE_TESTVALUE     (Source);
    DEFINE_TESTVALUE     (SourceSubID);
    DEFINE_TESTVALUE     (SourceID);
    DEFINE_TESTVALUE     (TriggerNumberLow);
    DEFINE_TESTVALUE     (TriggerNumberHigh);
    DEFINE_TESTVALUE     (MasterTriggerNumberLow);
    DEFINE_TESTVALUE     (MasterTriggerNumberHigh);
    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawTriggerHeader* nano_ver = (const RawTriggerHeader*)inver;
        return nano_ver->getVersion();
    }
    
private:

};

}// end of namespaces


#endif	/* TRIGGERHEADERCONSTRUCTOR_H */

