/* 
 * File:   TriggerMaskConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/TriggerMaskConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerMask
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE triggermask
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {
//------------------------------------------------------------------------------
TriggerMaskConstructor::TriggerMaskConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::triggermask::RAWTRIGGERMASK_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
TriggerMaskConstructor::~TriggerMaskConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* TriggerMaskConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawTriggerMask* out = (RawTriggerMask*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* TriggerMaskConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawTriggerMask(ver);
}

//------------------------------------------------------------------------------
bool TriggerMaskConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawTriggerMask* triggermask = (daqdataformats::RawTriggerMask*)dataformat;
    setFieldToTestValue_MonteCarloFlag(triggermask);
    setFieldToTestValue_TrigMod(triggermask);
    setFieldToTestValue_TrigMask_Low(triggermask);
    setFieldToTestValue_TrigMask_High(triggermask);
    setFieldToTestValue_TrigMask_High2(triggermask);
    setFieldToTestValue_Prescale(triggermask);

    return true;
}

}}// end of namespaces
