/* 
 * File:   TriggerMaskConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef TRIGGERMASKCONSTRUCTOR_H
#define	TRIGGERMASKCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawTriggerMask.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerMask
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE triggermask
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {
namespace CURRENT_FIELDS_SUB_NAMESPACE {

            enum TriggerMaskTestValues{
                    TEST_VALUE_MonteCarloFlag  = 1,
                    TEST_VALUE_TrigMod         = 2,
                    TEST_VALUE_TrigMask_Low    = 3,
                    TEST_VALUE_TrigMask_High   = 4,
                    TEST_VALUE_TrigMask_High2  = 5,
                    TEST_VALUE_Prescale        = 6,
            };// end of TriggerMaskMASKS



class TriggerMaskConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    TriggerMaskConstructor();
    ~TriggerMaskConstructor();
    DEFINE_TESTVALUE     (MonteCarloFlag);
    DEFINE_TESTVALUE     (TrigMod);
    DEFINE_TESTVALUE     (TrigMask_Low);
    DEFINE_TESTVALUE     (TrigMask_High);
    DEFINE_TESTVALUE     (TrigMask_High2);
    DEFINE_TESTVALUE     (Prescale);
    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawTriggerMask* nano_ver = (const RawTriggerMask*)inver;
        return nano_ver->getVersion();
    }
    
private:

};

}}// end of namespaces


#endif	/* TRIGGERMASKCONSTRUCTOR_H */

