/* 
 * File:   TriggerMaskUnitTest.cpp
 * Author: denis
 * 
 * Created on September 24, 2012, 10:18 AM
 */
//#include "DAQDataFormats/../unittest/RawDAQDataUnitTest.h"
//#include "DAQDataFormats/../unittest/TriggerMaskConstructor.h"
#include "RawDAQDataUnitTest.h"
#include "TriggerMaskConstructor.h"

namespace daqdataformats {

class TriggerMaskUnitTest : public RawDAQDataUnitTest {
    CPPUNIT_TEST_SUITE(TriggerMaskUnitTest);
    CPPUNIT_TEST(basicFieldGetAndSetChecks);
    CPPUNIT_TEST(testReadDataIntoSameVersion);
    CPPUNIT_TEST(testReadDataIntoUnknownVersion);
    CPPUNIT_TEST(checkDeepCopyConstructor);
    CPPUNIT_TEST(checkShallowCopyConstructor);
    CPPUNIT_TEST_SUITE_END();
public:
    TriggerMaskUnitTest();
    ~TriggerMaskUnitTest();

    DEFINE_checkDeepCopyConstructor(RawTriggerMask)
    DEFINE_checkShallowCopyConstructor(RawTriggerMask)
    DEFINE_testReadDataIntoSameVersion
    DEFINE_testReadDataIntoUnknownVersion

private:
    void basicFieldGetAndSetChecksForGivenVersion(const version_t);

private:
    triggermask::TriggerMaskConstructor* _mainDFConstructor;
};

//------------------------------------------------------------------------------
TriggerMaskUnitTest::TriggerMaskUnitTest():
     RawDAQDataUnitTest(new triggermask::TriggerMaskConstructor())
    ,_mainDFConstructor((triggermask::TriggerMaskConstructor*)_dataFormatConstructor)
{
}

//------------------------------------------------------------------------------
TriggerMaskUnitTest::~TriggerMaskUnitTest() { }

//------------------------------------------------------------------------------
void TriggerMaskUnitTest::basicFieldGetAndSetChecksForGivenVersion(const version_t version) {

    RawTriggerMask* df = (RawTriggerMask*)_mainDFConstructor->getEmptyDataFormat(version);
    ASSERT_CHECK_FIELD     (MonteCarloFlag);
    ASSERT_CHECK_FIELD     (TrigMod);
    ASSERT_CHECK_FIELD     (TrigMask_Low);
    ASSERT_CHECK_FIELD     (TrigMask_High);
    ASSERT_CHECK_FIELD     (TrigMask_High2);
    ASSERT_CHECK_FIELD     (Prescale);

    CPPUNIT_ASSERT(version == (version_t) df->getVersion());

    ASSERT_PRINT_IS_NOT_UNKNOWN;

    delete df;
}

//CPPUNIT_TEST_SUITE_REGISTRATION(TriggerMaskUnitTest);
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(TriggerMaskUnitTest, "DAQDataFormats");
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("DAQDataFormats");

}// end of class
