/* 
 * File:   TriggerRangeConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/TriggerRangeConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerRange
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE triggerrange
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

//------------------------------------------------------------------------------
TriggerRangeConstructor::TriggerRangeConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::CURRENT_FIELDS_SUB_NAMESPACE::RAWTRIGGERRANGE_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
TriggerRangeConstructor::~TriggerRangeConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* TriggerRangeConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawTriggerRange* out = (RawTriggerRange*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* TriggerRangeConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawTriggerRange(ver);
}

//------------------------------------------------------------------------------
bool TriggerRangeConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawTriggerRange* triggermask = (daqdataformats::RawTriggerRange*)dataformat;
    setFieldToTestValue_TriggerLength(triggermask);

    return true;
}

}// end of namespaces
