/* 
 * File:   TriggerRangeUnitTest.cpp
 * Author: denis
 * 
 * Created on September 24, 2012, 10:18 AM
 */
//#include "DAQDataFormats/../unittest/RawDAQDataUnitTest.h"
//#include "DAQDataFormats/../unittest/TriggerRangeConstructor.h"
#include "RawDAQDataUnitTest.h"
#include "TriggerRangeConstructor.h"

namespace daqdataformats {

class TriggerRangeUnitTest : public RawDAQDataUnitTest {
    CPPUNIT_TEST_SUITE(TriggerRangeUnitTest);
    CPPUNIT_TEST(basicFieldGetAndSetChecks);
    CPPUNIT_TEST(testReadDataIntoSameVersion);
    CPPUNIT_TEST(testReadDataIntoUnknownVersion);
    CPPUNIT_TEST(checkDeepCopyConstructor);
    CPPUNIT_TEST(checkShallowCopyConstructor);
    CPPUNIT_TEST_SUITE_END();
public:
    TriggerRangeUnitTest();
    ~TriggerRangeUnitTest();

    DEFINE_checkDeepCopyConstructor(RawTriggerRange)
    DEFINE_checkShallowCopyConstructor(RawTriggerRange)
    DEFINE_testReadDataIntoSameVersion
    DEFINE_testReadDataIntoUnknownVersion

private:
    void basicFieldGetAndSetChecksForGivenVersion(const version_t);

private:
    TriggerRangeConstructor* _mainDFConstructor;
};

//------------------------------------------------------------------------------
TriggerRangeUnitTest::TriggerRangeUnitTest():
     RawDAQDataUnitTest(new TriggerRangeConstructor())
    ,_mainDFConstructor((TriggerRangeConstructor*)_dataFormatConstructor)
{
}

//------------------------------------------------------------------------------
TriggerRangeUnitTest::~TriggerRangeUnitTest() { }

//------------------------------------------------------------------------------
void TriggerRangeUnitTest::basicFieldGetAndSetChecksForGivenVersion(const version_t version) {

    RawTriggerRange* df = (RawTriggerRange*)_mainDFConstructor->getEmptyDataFormat(version);
    ASSERT_CHECK_FIELD     (TriggerLength);

    CPPUNIT_ASSERT(version == (version_t) df->getVersion());

    ASSERT_PRINT_IS_NOT_UNKNOWN;

    delete df;
}

//CPPUNIT_TEST_SUITE_REGISTRATION(TriggerRangeUnitTest);
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(TriggerRangeUnitTest, "DAQDataFormats");
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("DAQDataFormats");

}// end of class
