/* 
 * File:   TriggerTimeConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/TriggerTimeConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerTime
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE triggertime
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

//------------------------------------------------------------------------------
TriggerTimeConstructor::TriggerTimeConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::CURRENT_FIELDS_SUB_NAMESPACE::RAWTRIGGERTIME_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
TriggerTimeConstructor::~TriggerTimeConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* TriggerTimeConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawTriggerTime* out = (RawTriggerTime*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* TriggerTimeConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawTriggerTime(ver);
}

//------------------------------------------------------------------------------
bool TriggerTimeConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawTriggerTime* triggermask = (daqdataformats::RawTriggerTime*)dataformat;
    setFieldToTestValue_TriggerTimeStampLow(triggermask);
    setFieldToTestValue_TriggerTimeStampHigh(triggermask);
    setFieldToTestValue_TriggerTimeStamp_sec(triggermask);
    setFieldToTestValue_TriggerTimeStamp_usec(triggermask);
    setFieldToTestValue_ClockSource(triggermask);
    setFieldToTestValue_TriggerTimeStamp(triggermask);
    setFieldToTestValue_TriggerTimeStampTvUsec(triggermask);
    return true;
}

}// end of namespaces
