/* 
 * File:   TriggerTimeConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef TRIGGERTIMECONSTRUCTOR_H
#define	TRIGGERTIMECONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawTriggerTime.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerTime
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE triggertime
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

            enum TriggerTimeTestValues{
                    TEST_VALUE_TriggerTimeStampLow  = 1256,
                    TEST_VALUE_TriggerTimeStampHigh = 1257,
                    TEST_VALUE_TriggerTimeStamp_sec  = 1258,
                    TEST_VALUE_TriggerTimeStamp_usec  = 1259,
                    TEST_VALUE_ClockSource  = 126,
                    TEST_VALUE_TriggerTimeStamp  = 1261,
                    TEST_VALUE_TriggerTimeStampTvUsec  = 1262,
            };// end of TriggerTimeMASKS


class TriggerTimeConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    TriggerTimeConstructor();
    ~TriggerTimeConstructor();
    DEFINE_TESTVALUE     (TriggerTimeStampLow);
    DEFINE_TESTVALUE     (TriggerTimeStampHigh);
    DEFINE_TESTVALUE     (TriggerTimeStamp_sec);
    DEFINE_TESTVALUE     (TriggerTimeStamp_usec);
    DEFINE_TESTVALUE     (ClockSource);
    DEFINE_TESTVALUE_64     (TriggerTimeStamp);
    DEFINE_TESTVALUE_CUSTOM     (TriggerTimeStampTvUsec, suseconds_t);
    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawTriggerTime* nano_ver = (const RawTriggerTime*)inver;
        return nano_ver->getVersion();
    }
    
private:

};

}// end of namespaces


#endif	/* TRIGGERTIMECONSTRUCTOR_H */

