/* 
 * File:   TriggerTimingMarkerConstructor.cpp
 * Author: denis
 * 
 * Created on September 20, 2012, 2:18 PM
 */
#include "DAQDataFormats/../unittest/TriggerTimingMarkerConstructor.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerTimingMarker
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE triggertimingmarker
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

//------------------------------------------------------------------------------
TriggerTimingMarkerConstructor::TriggerTimingMarkerConstructor():
    daqdataformats::RawDAQDataConstructor(daqdataformats::CURRENT_FIELDS_SUB_NAMESPACE::RAWTRIGGERTIMIMGMARKER_LATEST_VERSION)
{
}

//------------------------------------------------------------------------------
TriggerTimingMarkerConstructor::~TriggerTimingMarkerConstructor() { }

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* TriggerTimingMarkerConstructor::getFilledDataFormat(const daqdataformats::version_t ver) const {
    RawTriggerTimingMarker* out = (RawTriggerTimingMarker*)getEmptyDataFormat(ver);
    fillDataFormat(out);
    return out;
}

//------------------------------------------------------------------------------
daqdataformats::RawDAQData* TriggerTimingMarkerConstructor::getEmptyDataFormat(const daqdataformats::version_t ver) const{
    return new daqdataformats::RawTriggerTimingMarker(ver);
}

//------------------------------------------------------------------------------
bool TriggerTimingMarkerConstructor::fillDataFormat (daqdataformats::RawDAQData* dataformat) const {
    daqdataformats::RawTriggerTimingMarker* triggermask = (daqdataformats::RawTriggerTimingMarker*)dataformat;
    setFieldToTestValue_TriggerStartLow_baseClock(triggermask);
    setFieldToTestValue_TriggerStartHigh_baseClock(triggermask);
    setFieldToTestValue_TriggerStartLow_833kHz(triggermask);
    setFieldToTestValue_TriggerStartHigh_833kHz(triggermask);

    return true;
}

}// end of namespaces
