/* 
 * File:   TriggerTimingMarkerConstructor.h
 * Author: denis
 *
 * Created on September 20, 2012, 2:18 PM
 */

#ifndef TRIGGERTIMINGMARKERCONSTRUCTOR_H
#define	TRIGGERTIMINGMARKERCONSTRUCTOR_H
//#include "DAQDataFormats/../unittest/RawDAQDataConstructor.h"
#include "RawDAQDataConstructor.h"
#include "DAQDataFormats/RawTriggerTimingMarker.h"

/// It is requred to
///   1. include DAQDataFormats/DataFormatFirst.inc
///   2. define CURRENT_CLASS
///   3.    define CURRENT_CLASS_VERSION for version of the class
///      OR define LAST_CLASS_VERSION    for the main structure of the class
///   4. (optional) define CURRENT_FIELDS_SUB_NAMESPACE
///   5. include DAQDataFormats/DataFormatLast.inc
/// before the declaration of the DataFormat version class in the header.
#include "DAQDataFormats/DataFormatFirst.inc"
#define  CURRENT_CLASS                RawTriggerTimingMarker
#define  LAST_CLASS_VERSION           0
#define  CURRENT_FIELDS_SUB_NAMESPACE triggertimingmarker
#include "DAQDataFormats/DataFormatLast.inc"

namespace daqdataformats {

            enum TriggerTimingMarkerTestValues{
                    TEST_VALUE_TriggerStartLow_baseClock  = 1256,
                    TEST_VALUE_TriggerStartHigh_baseClock  = 1257,
                    TEST_VALUE_TriggerStartLow_833kHz  = 1258,
                    TEST_VALUE_TriggerStartHigh_833kHz  = 1259,
                    TEST_VALUE_TriggerStart_baseClock  = 1260,
                    TEST_VALUE_TriggerStart_833kHz = 1261
            };// end of TriggerTimingMarkerMASKS



class TriggerTimingMarkerConstructor: public daqdataformats::RawDAQDataConstructor {
public:
    TriggerTimingMarkerConstructor();
    ~TriggerTimingMarkerConstructor();
    DEFINE_TESTVALUE     (TriggerStartLow_baseClock);
    DEFINE_TESTVALUE     (TriggerStartHigh_baseClock);
    DEFINE_TESTVALUE     (TriggerStartLow_833kHz);
    DEFINE_TESTVALUE     (TriggerStartHigh_833kHz);
    DEFINE_TESTVALUE_64     (TriggerStart_baseClock);
    DEFINE_TESTVALUE_64     (TriggerStart_833kHz);
    daqdataformats::RawDAQData* getFilledDataFormat(const daqdataformats::version_t)   const;
    daqdataformats::RawDAQData* getEmptyDataFormat (const daqdataformats::version_t)   const;
    bool                        fillDataFormat     (daqdataformats::RawDAQData*)       const;

    version_t getVersion(const daqdataformats::RawDAQData* inver) const {
        const RawTriggerTimingMarker* nano_ver = (const RawTriggerTimingMarker*)inver;
        return nano_ver->getVersion();
    }
    
private:

};

}// end of namespaces


#endif	/* TRIGGERTIMINGMARKERCONSTRUCTOR_H */

