/* 
 * File:   TriggerTimingMarkerUnitTest.cpp
 * Author: denis
 * 
 * Created on September 24, 2012, 10:18 AM
 */
//#include "DAQDataFormats/../unittest/RawDAQDataUnitTest.h"
//#include "DAQDataFormats/../unittest/TriggerTimingMarkerConstructor.h"
#include "RawDAQDataUnitTest.h"
#include "TriggerTimingMarkerConstructor.h"

namespace daqdataformats {

class TriggerTimingMarkerUnitTest : public RawDAQDataUnitTest {
    CPPUNIT_TEST_SUITE(TriggerTimingMarkerUnitTest);
    CPPUNIT_TEST(basicFieldGetAndSetChecks);
    CPPUNIT_TEST(testReadDataIntoSameVersion);
    CPPUNIT_TEST(testReadDataIntoUnknownVersion);
    CPPUNIT_TEST(checkDeepCopyConstructor);
    CPPUNIT_TEST(checkShallowCopyConstructor);
    CPPUNIT_TEST_SUITE_END();
public:
    TriggerTimingMarkerUnitTest();
    ~TriggerTimingMarkerUnitTest();

    DEFINE_checkDeepCopyConstructor(RawTriggerTimingMarker)
    DEFINE_checkShallowCopyConstructor(RawTriggerTimingMarker)
    DEFINE_testReadDataIntoSameVersion
    DEFINE_testReadDataIntoUnknownVersion

private:
    void basicFieldGetAndSetChecksForGivenVersion(const version_t);

private:
    TriggerTimingMarkerConstructor* _mainDFConstructor;
};

//------------------------------------------------------------------------------
TriggerTimingMarkerUnitTest::TriggerTimingMarkerUnitTest():
     RawDAQDataUnitTest(new TriggerTimingMarkerConstructor())
    ,_mainDFConstructor((TriggerTimingMarkerConstructor*)_dataFormatConstructor)
{
}

//------------------------------------------------------------------------------
TriggerTimingMarkerUnitTest::~TriggerTimingMarkerUnitTest() { }

//------------------------------------------------------------------------------
void TriggerTimingMarkerUnitTest::basicFieldGetAndSetChecksForGivenVersion(const version_t version) {

    RawTriggerTimingMarker* df = (RawTriggerTimingMarker*)_mainDFConstructor->getEmptyDataFormat(version);
    ASSERT_CHECK_FIELD     (TriggerStartLow_baseClock);
    ASSERT_CHECK_FIELD     (TriggerStartHigh_baseClock);
    ASSERT_CHECK_FIELD     (TriggerStartLow_833kHz);
    ASSERT_CHECK_FIELD     (TriggerStartHigh_833kHz);
    ASSERT_CHECK_FIELD     (TriggerStart_baseClock);
    ASSERT_CHECK_FIELD     (TriggerStart_833kHz);

    CPPUNIT_ASSERT(version == (version_t) df->getVersion());

    ASSERT_PRINT_IS_NOT_UNKNOWN;

    delete df;
}

//CPPUNIT_TEST_SUITE_REGISTRATION(TriggerTimingMarkerUnitTest);
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION(TriggerTimingMarkerUnitTest, "DAQDataFormats");
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("DAQDataFormats");

}// end of class
