/* 
 * File:   UtnitTestTrace.h
 * Author: denis
 *
 * Created on September 28, 2012, 4:26 PM
 */

#ifndef UNITTESTTRACE_H
#define	UNITTESTTRACE_H

#include <boost/format.hpp>

/// This is for hard debugging
#ifndef COUT
#define COUT(xx) std::cout<<__PRETTY_FUNCTION__<<xx; std::cout<<"\n";
#endif


        enum UTLogs{
//  group corresponding to Message Logger
            LogError               =  0,
            LogWarning             =  1,
            LogInfo                =  2,
            LogDebug               =  3,
//  group for important low rate messages
            LogDLStart             =  4,
            LogRunStart            =  5,
            LogPeriodic1           =  6,
            LogPeriodic2           =  7,
//  group for General DL debug
            LogTrace               =  8,
            LogVerbatim            =  9,
            LogAbsolute            = 10,
            LogDLDebug4            = 11,
//  group for EventPool and DataAtoms
            LogEvPoolDA12          = 12,
            LogEvPoolDA13          = 13,
            LogEvPoolDA14          = 14,
            LogEvPoolDA15          = 15,
//  group for BufferNodes and DataBlocks
            LogBNDBlock16          = 16,
            LogBNDBlock17          = 17,
            LogBNDBlock18          = 18,
            LogBNDBlock19          = 19,
//  group for Trigger and TriggerBlocks
            LogTriggerTB20         = 20,
            LogTriggerTB21         = 21,
            LogTriggerTB22         = 22,
            LogTriggerTB23         = 23,
//  group for shared memory
            LogEventDebugInfo      = 24,
            LogShMem25             = 25,
            LogRunInfo             = 26,
            LogRunAddEventInfo     = 27,
//  group for data output
            LogRunDebugInfo        = 28,
            LogDataOutput29        = 29,
            LogDataOutput30        = 30,
            LogDataOutput31        = 31
        };



#endif	/* UNITTESTTRACE_H */

