#ifndef _DBUTILS_GUI_BITMAPEDITOR_H
#define _DBUTILS_GUI_BITMAPEDITOR_H

#include <QtGui/QDialog>
#include <QtGui/QCheckBox>
#include <vector>

namespace dbutils {
namespace gui {

/**
 * Class for providing easier editing of bitmaps.
 *
 * @author Kurt Biery
 * @version $Revision: 1.2 $ $Date: 2011/09/09 19:31:04 $
 */

class BitmapEditor : public QDialog
{
    Q_OBJECT

 public:

    BitmapEditor(const std::string& initialValue, int bitCount,
                 QWidget *parent = 0);

    std::string getResult() const;

 public slots:

    void selectAll();
    void deselectAll();

 private:

    bool _inputWasSpecifiedInHex;
    std::vector<QCheckBox*> _checkboxList;
};

};  // end of namespace gui
};  // end of namespace dbutils

#endif
