#ifndef _DBUTILS_GUI_CHANGEABLE_H
#define _DBUTILS_GUI_CHANGEABLE_H

#include <DatabaseUtils/DAQConfig/IDSpec.h>
#include <stdint.h>

namespace dbutils {
namespace gui {

/**
 * The interface that configuration editor classes use to report on
 * local (internal) changes.
 *
 * @author Kurt Biery
 * @version $Revision: 1.3 $ $Date: 2013/11/13 18:36:07 $
 */

class Changeable
{

 public:

    /**
     * Tests whether there are any local changes that have not
     * yet been stored in the database.
     */
    virtual bool hasChanges() const = 0;;

    /**
     * Requests that an initial row be added to the currently displayed
     * table or tree.
     */
    virtual bool addInitialRow() = 0;

 private:

};

};  // end of namespace gui
};  // end of namespace dbutils

#endif
