#ifndef _DBUTILS_GUI_CONFIGSELECTIONDIALOG_H
#define _DBUTILS_GUI_CONFIGSELECTIONDIALOG_H

#include <DatabaseUtils/DAQConfig/IDSpec.h>
#include <DatabaseUtils/GUI/NamedConfigTree.h>
#include <QtGui/QDialog>

namespace dbutils {
namespace gui {

/**
 * Dialog box for selecting a particular named configuration.
 *
 * @author Kurt Biery
 * @version $Revision: 1.1 $ $Date: 2011/12/02 23:09:07 $
 */

class ConfigSelectionDialog : public QDialog
{
    Q_OBJECT

 public:

    ConfigSelectionDialog(dbutils::daqconfig::IDSpec::
                          MAJOR_SYSTEM_TYPE systemType,
                          const std::string& detectorName,
                          QWidget *parent = 0);

    std::string getSelectedConfigName() const;
    std::string getSelectedDCMOpMode() const;
    std::string getSelectedTime() const;

    QSize sizeHint() const {return QSize(550,250);}

 private:

    NamedConfigTree* _configTree;

};

};  // end of namespace gui
};  // end of namespace dbutils

#endif
