#ifndef _DBUTILS_GUI_DCSCONFIGEDITORDISPLAY_H
#define _DBUTILS_GUI_DCSCONFIGEDITORDISPLAY_H

#include <DatabaseUtils/GUI/BasicEditorDisplay.h>
#include <DatabaseUtils/GUI/TabbedSetOfTreeEditors.h>
#include <QtGui/QMainWindow>
#include <QtGui/QCloseEvent>
#include <vector>

namespace dbutils {
namespace gui {

/**
 * Class for displaying the tabs that make up the graphical
 * configuration editor.
 *
 * @author Kurt Biery
 * @version $Revision: 1.15 $ $Date: 2013/07/31 17:17:53 $
 */

class DCSConfigEditorDisplay : public BasicEditorDisplay
{
    Q_OBJECT

 public:

    DCSConfigEditorDisplay(QWidget *parent = 0);

    bool hasChanges() const;

 public slots:

    void generateRecipeScripts();
    void loadHVAndTemps();

 protected:

    bool _doReloadCurrentDataset(const dbutils::daqconfig::IDSpec& idSpec);
    bool _doLoadNewDataset(const dbutils::daqconfig::IDSpec& idSpec);
    bool _doSaveChanges(const dbutils::daqconfig::IDSpec& oldIdSpec,
                        const dbutils::daqconfig::IDSpec& newIdSpec,
                        const dbutils::daqconfig::GlobalNameSpec& newNameSpec);

 private:

    TabbedSetOfTreeEditors* _editorSet;
    std::string _pvScriptOutputDir;

};

};  // end of namespace gui
};  // end of namespace dbutils

#endif
