#ifndef _DBUTILS_GUI_DATATREECREATORTHREAD_H
#define _DBUTILS_GUI_DATATREECREATORTHREAD_H

#include <DatabaseUtils/DAQConfig/ConfigDataTree.h>
#include <QtCore/QThread>
#include <QtCore/QMutex>
#include <boost/shared_ptr.hpp>

namespace dbutils {
namespace gui {

/**
 * Class for creating a ConfigDataTree in the background.
 *
 * @author Kurt Biery
 * @version $Revision: 1.1 $ $Date: 2011/08/19 21:52:16 $
 */

class DataTreeCreatorThread : public QThread
{
 public:

    DataTreeCreatorThread(const std::string& tableDefinitionFileName,
                          const std::vector<int64_t>& subsystemConfigIdList,
                          QObject *parent = 0);

    boost::shared_ptr<daqconfig::ConfigDataTree> getTree();

 protected:

    void run();

 private:

    std::string _tableDefinitionFileName;
    std::vector<int64_t> _subsystemConfigIdList;
    boost::shared_ptr<daqconfig::ConfigDataTree> _dataTree;
    QMutex _dataTreeMutex;

};

};  // end of namespace gui
};  // end of namespace dbutils

#endif
