#ifndef _DBUTILS_GUI_NAMEVALUELABELPAIR_H
#define _DBUTILS_GUI_NAMEVALUELABELPAIR_H

#include <QtGui/QLabel>
#include <QtGui/QWidget>

namespace dbutils {
namespace gui {

/**
 * Class for providing two labels that display a parameter name and
 * the associated value.
 *
 * @author Kurt Biery
 * @version $Revision: 1.1 $ $Date: 2011/09/20 19:47:36 $
 */

class NameValueLabelPair : public QWidget
{
    Q_OBJECT

 public:

    NameValueLabelPair(std::string name, QWidget *parent = 0);

    std::string getValue() const {return _valueLabel->text().toStdString();}

 public slots:

    void setValue(const std::string& value);

 private:

    QLabel* _valueLabel;
};

};  // end of namespace gui
};  // end of namespace dbutils

#endif
