#ifndef _DBUTILS_GUI_SETTINGSDISPLAY_H
#define _DBUTILS_GUI_SETTINGSDISPLAY_H

#include <DatabaseUtils/DAQConfig/GlobalNameSpec.h>
#include <DatabaseUtils/GUI/NamedConfigGroupBox.h>
#include <QtCore/QObject>
#include <QtGui/QWidget>
#include <iostream>

namespace dbutils {
namespace gui {

/**
 * Class for graphically displaying the current settings for
 * user-selected parameters.
 *
 * @author Kurt Biery
 * @version $Revision: 1.1 $ $Date: 2011/11/28 15:15:12 $
 */

class SettingsDisplay : public QWidget
{
    Q_OBJECT

 public:

    SettingsDisplay(QWidget *parent = 0);
    ~SettingsDisplay();

 public slots:

    void updateNamedConfiguration(const dbutils::daqconfig::
                                  GlobalNameSpec& nameSpec);

 private:

    NamedConfigGroupBox* _namedConfigChoices;
};

};  // end of namespace gui
};  // end of namespace dbutils

#endif
