#ifndef _DBUTILS_GUI_STOREABLE_H
#define _DBUTILS_GUI_STOREABLE_H

#include <DatabaseUtils/DAQConfig/GlobalNameSpec.h>
#include <DatabaseUtils/DAQConfig/IDSpec.h>
#include <stdint.h>

namespace dbutils {
namespace gui {

/**
 * The interface that configuration editor classes use to control
 * reading and writing of data to the database.
 *
 * @author Kurt Biery
 * @version $Revision: 1.3 $ $Date: 2011/12/13 14:54:56 $
 */

class Storeable
{

 public:

    /**
     * Loads the data associated with the specified config ID.
     */
    virtual bool loadData(const dbutils::daqconfig::IDSpec& idSpec) = 0;

    /**
     * Saves all local changes to the database.
     */
    virtual bool saveChanges(const dbutils::daqconfig::IDSpec& oldIdSpec,
                             const dbutils::daqconfig::IDSpec& newIdSpec,
                             const dbutils::daqconfig::GlobalNameSpec&
                             newNameSpec) = 0;

 private:

};

};  // end of namespace gui
};  // end of namespace dbutils

#endif
