#ifndef _DBUTILS_INSTALLATION_H
#define _DBUTILS_INSTALLATION_H

#include <string>
#include <vector>
#include <map>
#include <ctime>
#include <stdint.h>  /* uint64_t */

#include <NovaDatabase/Table.h>
#include <NovaDAQConventions/DAQConventions.h>

namespace db = nova::database;

namespace dbutils {

/**
 * Utilities for accessing installation data in the hardware dB
 *
 * @author Jonathan Paley
 * @version $Revision: 1.1 $ $Date: 2013/03/13 17:22:15 $
 */

  namespace hw {
    
    class FEB {
    public:
      static bool Installed(int detid, std::string dcmName, int dcmPort,
			    std::string& id, std::string ts="now");
      static bool GetAllInstalled(int detid, 
				  std::vector<std::string>& dcmName,
				  std::vector<int>& dcmPort, 
				  std::vector<std::string>& id, 
				  std::string ts="now");
    };  // end of class FEB

    class APD {
    public:
      static bool Installed(int detid, std::string dcmName, int dcmPort,
			    std::string& id, std::string ts="now");
      static bool GetAllInstalled(int detid,
				  std::vector<std::string>& dcmName,
				  std::vector<int>& dcmPort, 
				  std::vector<std::string>& id, 
				  std::string ts="now");

    };  // end of class FEB
    
    class Util {
    public:
      static nova::database::Table* PositionTable(int detid);
    };
    
  }; // end of namespace hw

};  // end of namespace dbutils

#endif
