#include <DatabaseUtils/DAQConfig/ASICRegisterValueSet.h>

namespace dbutils {
namespace daqconfig {

/**
 * Creates a set from the specified values.
 */
ASICRegisterValueSet::
ASICRegisterValueSet(int16_t spareValue, int16_t vtselValue,
                     int16_t refselValue, int16_t iselValue,
                     int16_t bwselValue, int16_t gselValue,
                     int16_t tfselValue, int16_t mux2to1Value,
                     int16_t mux8to1Value, int32_t qInjPixelMask) :
    _spareValue(spareValue), _vtselValue(vtselValue),
    _refselValue(refselValue), _iselValue(iselValue),
    _bwselValue(bwselValue), _gselValue(gselValue),
    _tfselValue(tfselValue), _mux2to1Value(mux2to1Value),
    _mux8to1Value(mux8to1Value), _qInjPixelMask(qInjPixelMask)
{
}

/**
 * Tests if the specified set is equal to this one.
 */
bool ASICRegisterValueSet::
operator==(const ASICRegisterValueSet& other)
{
    return (other._spareValue == this->_spareValue &&
            other._vtselValue == this->_vtselValue &&
            other._refselValue == this->_refselValue &&
            other._iselValue == this->_iselValue &&
            other._bwselValue == this->_bwselValue &&
            other._gselValue == this->_gselValue &&
            other._tfselValue == this->_tfselValue &&
            other._mux2to1Value == this->_mux2to1Value &&
            other._mux8to1Value == this->_mux8to1Value &&
            other._qInjPixelMask == this->_qInjPixelMask);
}

/**
 * Tests if the specified set is not equal to this one.
 */
bool ASICRegisterValueSet::
operator!=(const ASICRegisterValueSet& other)
{
    return !(*this==other);
}

};  // end of namespace daqconfig
};  // end of namespace dbutils
