#!/bin/sh

# parse arguments
if [[ $# -lt 1 ]]; then
    echo "Usage: $0 <rootDirForGeneratedFiles>"
    exit 1
fi
genFileDir=$1

# check that the target directory exists
if [ ! -d ${genFileDir} ] ; then
    echo "Error: directory ${genFileDir} does not exist!"
    exit 3
fi

# define the list of DCMs
#dcmList=`psql -h $NOVADBHOST -d $NOVADBNAME -p $NOVADBPORT -U $NOVADBUSER -c "select distinct dcmname from $NOVADAQ_ENVIRONMENT.dcs_feb_enable_masks" | grep "dcm-"`
 dcmList=`psql -h $NOVADBHOST -d $NOVADBNAME -p $NOVADBPORT -U $NOVADBUSER -c "select distinct dcmname from (select distinct dcmname from $NOVADAQ_ENVIRONMENT.dcs_feb_enable_masks  UNION select distinct dcmname from $NOVADAQ_ENVIRONMENT.feb_dry_air_channels) dcm_list" | grep "dcm-"`

# create the necessary subdirectories
for dcmName in ${dcmList} ; do
    if [ ! -d ${genFileDir}/${dcmName} ] ; then
        mkdir ${genFileDir}/${dcmName}
    fi
done

# generate the recipe scripts
for dcmName in ${dcmList} ; do
    GenerateSampleApdDcsXML -o ${genFileDir}/${dcmName}/${dcmName}.xml WarmDetectorSettings DCS ${NOVADAQ_ENVIRONMENT} ${dcmName}
    GenerateSampleApdDcsXML -o ${genFileDir}/${dcmName}/${dcmName}-cold.xml ColdDetectorSettings DCS ${NOVADAQ_ENVIRONMENT} ${dcmName}

    #GeneratePVSettings ${genFileDir}/${dcmName}/${dcmName}.xml > ${genFileDir}/${dcmName}/${dcmName}.sh
done
