#include <DatabaseUtils/GUI/NameValueLabelPair.h>
#include <QtGui/QHBoxLayout>

namespace dbutils {
namespace gui {

NameValueLabelPair::
NameValueLabelPair(std::string name, QWidget *parent) :
    QWidget(parent)
{
    QHBoxLayout* hboxLayout = new QHBoxLayout;
    hboxLayout->setContentsMargins(0,0,0,0);

    name.append(": ");
    QLabel* nameLabel = new QLabel(tr(name.c_str()));
    //nameLabel->setFrameStyle(QFrame::Box);
    hboxLayout->addWidget(nameLabel);

    _valueLabel = new QLabel(tr("unknown"));
    //_valueLabel->setFrameStyle(QFrame::Box);
    _valueLabel->setStyleSheet("background: white");
    _valueLabel->setContentsMargins(5, 0, 5, 0);
    hboxLayout->addWidget(_valueLabel);

    hboxLayout->addStretch();

    this->setLayout(hboxLayout);
}

void NameValueLabelPair::setValue(const std::string& value)
{
    _valueLabel->setText(value.c_str());
}

};  // end of namespace gui
};  // end of namespace dbutils
