#include <DatabaseUtils/GUI/NamedConfigGroupBox.h>
#include <QtGui/QGridLayout>
#include <QtGui/QHBoxLayout>

namespace dbutils {
namespace gui {

NamedConfigGroupBox::
NamedConfigGroupBox(QWidget *parent) :
    QGroupBox(tr("Current Named Configuration"), parent)
{
    QGridLayout* gridLayout = new QGridLayout;

    _configNameWidget = new NameValueLabelPair("Name");
    _configNameWidget->setValue("unknown");
    gridLayout->addWidget(_configNameWidget, 0, 0);

    _dcmOpModeWidget = new NameValueLabelPair("DCM Operating Mode");
    _dcmOpModeWidget->setValue("unknown");
    gridLayout->addWidget(_dcmOpModeWidget, 0, 1);

    _detectorNameWidget = new NameValueLabelPair("Detector");
    _detectorNameWidget->setValue("unknown");
    gridLayout->addWidget(_detectorNameWidget, 1, 0);

    _timestampWidget = new NameValueLabelPair("Time");
    _timestampWidget->setValue("unknown");
    gridLayout->addWidget(_timestampWidget, 1, 1);

    this->setLayout(gridLayout);
}

void NamedConfigGroupBox::setConfigurationName(const std::string& name)
{
    _configNameWidget->setValue(name);
}

void NamedConfigGroupBox::setDCMOperatingMode(const std::string& dcmOpMode)
{
    _dcmOpModeWidget->setValue(dcmOpMode);
}

void NamedConfigGroupBox::setDetectorName(const std::string& detectorName)
{
    _detectorNameWidget->setValue(detectorName);
}

void NamedConfigGroupBox::setTimestamp(const std::string& timestamp)
{
    _timestampWidget->setValue(timestamp);
}

};  // end of namespace gui
};  // end of namespace dbutils
