#include "DatabaseUtils/Hardware/Installation.h"
#include "NovaDAQConventions/DAQConventions.h"

#include <vector>
#include <string>
#include <iostream>
#include <sstream>
#include <algorithm>

using namespace nova::database;
using namespace dbutils;
using namespace std;

int main(int argc, char **argv)
{
  std::vector<std::string> dcmName;
  std::vector<std::string> febid;
  std::vector<int> dcmPort;

  if (! dbutils::hw::FEB::GetAllInstalled(novadaq::cnv::kNDOS,dcmName,
					  dcmPort,febid)) {
    std::cout << "No FEBs installed yet on the " << "NDOS" << " detector." 
	      << std::endl;
    return(1);
  }

  std::cout << "Currently installed on the NDOS:" << std::endl;

  std::vector<std::string> febAddr;
  for (unsigned int i=0; i<dcmName.size(); ++i) {
    std::ostringstream ss;
    ss << dcmName[i] << "-" << dcmPort[i];
    febAddr.push_back(ss.str());
  }	 

  std::sort(febAddr.begin(),febAddr.end());

  for (unsigned int i=0; i<febAddr.size(); ++i)
    std::cout << febAddr[i] << ", id: " << febid[i] << std::endl;

  std::cout << "Total installed: " << febAddr.size() << std::endl;

  return(1);
}


