#include <DatabaseUtils/Krb5Utils.h>
#include <cstdlib>

namespace dbutils {

  bool Krb5::checkTicket(std::string krb5Id) {
    std::string cmd = "klist -s";
    int iresult = system(cmd.c_str());
    return (iresult == 0);
  }

  bool Krb5::getTicket(std::string keytab, std::string krb5Id, 
		       std::string krb5IdSfx) {

    // get kerberos ticket
    if (keytab == "" && krb5Id != "" && krb5IdSfx != "") {
      std::string cmd = "kinit -f " + krb5Id + "@" + krb5IdSfx;
      int iresult = system(cmd.c_str());
      return (iresult == 0);
    }
    else {
      std::string cmd = "kinit -F -A -k -t " + keytab + " " + krb5Id + krb5IdSfx;
      int iresult = system(cmd.c_str());
      return (iresult == 0);
    }
  }
  
};  // end of namespace dbutils
