#include <boost/lexical_cast.hpp>
#include <iostream>
#include <stdint.h>
#include <sstream>
#include <iomanip>

int main(int argc, char *argv[])
{
    std::cout << std::endl;
    std::cout << "To use this application, simply enter, one at a time, "
              << "the bit numbers that you want enabled." << std::endl;
    std::cout << "Terminate input with an invalid bit number (e.g. -1)."
              << std::endl;
    std::cout << std::endl;

    int64_t mask = 0;
    int64_t sixtyFourBitOne = 1;
    int bitNumber = -1;
    std::string inputString;
    std::cout << "first enabled bit: ";
    std::cin >> inputString;
    try {
        bitNumber = boost::lexical_cast<int>(inputString);
    }
    catch (...) {
        std::cerr << "ERROR: unable to interpret \"" << inputString
                  << "\" as an integer!" << std::endl;
        exit(1);
    }
    while (bitNumber >= 0 && bitNumber <= 63) {
        mask |= (sixtyFourBitOne << bitNumber);

        std::cout << "next enabled bit: ";
        std::cin >> inputString;
        try {
            bitNumber = boost::lexical_cast<int>(inputString);
        }
        catch (...) {
            std::cerr << "ERROR: unable to interpret \"" << inputString
                      << "\" as an integer!" << std::endl;
            exit(1);
        }
    }

    std::ostringstream formatter;
    formatter << "0x" << std::hex << std::setfill('0')
              << std::setw(16) << std::nouppercase << mask;

    std::cout << std::endl;
    std::cout << "Mask = " << formatter.str() << " (" << mask
              << ")" << std::endl;

    return 0;
}
