import psycopg2
import csv
#import datetime
import time
import argparse
import os
import code
from ROOT import TH1F,gROOT,TCanvas

gs=[]
# When ROOT objects get garbage-collected they disappear from the screen
# again. Need to leak them like in C++
def New(cons, *args):
    ret = cons(*args)
    gs.append(ret)
    return ret

c1 = New(TCanvas,"c1","c1")
c1.SetLogy(1)
c2 = New(TCanvas,"c2","c2")
c2.SetLogy(1)
m100Histo = New(TH1F, "gain100","gain100",600,0,300)
m150Histo = New(TH1F,"gain150","gain150",600,0,300)
pixelRatio = New(TH1F,"pixelRatio","pixelRatio",400,0,3)
FEBRatio = New(TH1F,"FEBRatio","FEBRatio",800,0,3)

# try connecting to the database
# use the Fermilab (FL) database for testing information and the Ash River (AR)
# for the most up-to-date installation information

#read in the password for the db
pswdloc  = os.environ['NOVADBPWDFILE']
pswdfile = open(pswdloc, "r")
pswd     = pswdfile.read()

SQL = "dbname=nova_hardware host=ifdbprod.fnal.gov user=nova_reader password={} port=5432".format(pswd)

try:
    connFL = psycopg2.connect(SQL)
except:
    print "Unable to connect to the database"
    exit(0)


curFL = connFL.cursor()    
SQL = "set search_path to ashriverprod_factory;"
curFL.execute(SQL)

APDinstall_file = open("apd_installation.txt", "r")
APDinstall_list = csv.reader(APDinstall_file)

#for Location in APDinstall_list :
#    print "APD ",Location[2]," installed at ",Location[0],Location[1]
#    apdseqno = str(Location[2])
for apdseqint in xrange(10168,10169):
    apdseqno = str(apdseqint)
    
    #SQL = "select * from public.apd_raw_data where apd_id like '%12345' and target_degc < 0 order by batch_no DESC "
    SQL = "select * from public.apd_raw_data where apd_id like '%"+ apdseqno + "' and target_degc < 0 order by batch_no DESC "
    curFL.execute(SQL)
    rows  = curFL.fetchall()
    #print "retrieved ",len(rows),"\n"
    if len(rows) >= 62 :
        print len(rows)," rows returned for ",apdseqno
        #break

        currentTable = [[0 for x in range(45)] for y in range(62)] 
        gainTable = []
        #print currentTable
        rownumber = 0
        for row in rows:
            #print(row)
            #print len(row)
            for rowindex in range(0,len(row)):
                #print rownumber, rowindex, row[rowindex]
                if rownumber < 62:
                    currentTable[rownumber][rowindex]=row[rowindex]
            rownumber = rownumber +1 
        #print currentTable
        # We now have the currentTable filled with LED off/on currents for all 32 pixels at all 31 voltages
        photoCurrent = []
        illumination = []
        voltageArray = []
        pixelGain = []
        averageGain = []

        resultsFile = open("APD_pixel_gain_V.csv", "w+")

        for pixel in xrange(1,33):
            illumination.append((currentTable[1+31][pixel+12]+currentTable[2+31][pixel+12]+
                                 currentTable[3+31][pixel+12]-currentTable[1][pixel+12]-
                                 currentTable[2][pixel+12]-currentTable[3][pixel+12])/3.0)
        #print illumination
        for voltageIndex in xrange(0,30):
            voltageArray.append(currentTable[voltageIndex][11]-1.0e6*illumination[0])
            gainSum = 0
            for pixel in xrange(1,33):
                #if len(pixelGain) < 32:
                pixelGain.append((currentTable[voltageIndex+31][pixel+12]-
                                  currentTable[voltageIndex][pixel+12])/illumination[pixel-1])
                #else:
                #    pixelGain[pixel-1]=(currentTable[voltageIndex+31][pixel+12]-
                #                        currentTable[voltageIndex][pixel+12])/illumination[pixel-1]
                gainSum += pixelGain[voltageIndex*32+pixel-1]
                #m100Histo.Fill(pixelGain[voltageIndex*32+pixel-1])
                #print pixel,voltageArray[len(voltageArray)-1],pixelGain[voltageIndex*32+len(pixelGain)-1]
            #print 'Average gain ' ,voltageArray[len(voltageArray)-1],gainSum/32.0
            if len(averageGain)<31:
                averageGain.append(gainSum/32.0)
            else:
                averageGain[voltageIndex]=gainSum/32.0
            csvoutfmt = '{}, '*5 + '{:6.2f}, '*34 + '\n' # + '{:6.2f}\n'
            #print csvoutfmt
            csvout = csvoutfmt.format(row[0],row[1],row[2],row[3],row[4],voltageArray[len(voltageArray)-1],gainSum/32.0,
                                      pixelGain[voltageIndex*32+0],                             
                                      pixelGain[voltageIndex*32+1],
                                      pixelGain[voltageIndex*32+2],
                                      pixelGain[voltageIndex*32+3],
                                      pixelGain[voltageIndex*32+4],
                                      pixelGain[voltageIndex*32+5],
                                      pixelGain[voltageIndex*32+6],
                                      pixelGain[voltageIndex*32+7],
                                      pixelGain[voltageIndex*32+8],
                                      pixelGain[voltageIndex*32+9],
                                      pixelGain[voltageIndex*32+10],
                                      pixelGain[voltageIndex*32+11],
                                      pixelGain[voltageIndex*32+12],
                                      pixelGain[voltageIndex*32+13],
                                      pixelGain[voltageIndex*32+14],
                                      pixelGain[voltageIndex*32+15],
                                      pixelGain[voltageIndex*32+16],
                                      pixelGain[voltageIndex*32+17],
                                      pixelGain[voltageIndex*32+18],
                                      pixelGain[voltageIndex*32+19],
                                      pixelGain[voltageIndex*32+20],
                                      pixelGain[voltageIndex*32+21],
                                      pixelGain[voltageIndex*32+22],
                                      pixelGain[voltageIndex*32+23],
                                      pixelGain[voltageIndex*32+24],
                                      pixelGain[voltageIndex*32+25],
                                      pixelGain[voltageIndex*32+26],
                                      pixelGain[voltageIndex*32+27],
                                      pixelGain[voltageIndex*32+28],
                                      pixelGain[voltageIndex*32+29],
                                      pixelGain[voltageIndex*32+30],
                                      pixelGain[voltageIndex*32+31])
            resultsFile.write(csvout)
            #print "Average Gain of ",apdseqno, "at voltage ",voltageArray[len(voltageArray)-1],\
            #    " is ",gainSum/32.0," which should be the same as ",averageGain[len(averageGain)-1],"\n"
        #print averageGain
        #print "\n"

    #raw = (apd_raw_id,days_stamp,batch_no,apd_id,target_degc,elap_time,led,ref_diode_a,tec_degc,tec_pc,thmstr_ohms,source_v#,source_a,pix_a1,pix_a2,pix_a3,pix_a4,pix_a5,pix_a6,pix_a7,pix_a8,pix_b1,pix_b2,pix_b3,pix_b4,pix_b5,pix_b6,pix_b7,pix_#b8,pix_c1,pix_c2,pix_c3,pix_c4,pix_c5,pix_c6,pix_c7,pix_c8,pix_d1,pix_d2,pix_d3,pix_d4,pix_d5,pix_d6,pix_d7,pix_d8)

        resultsFile.close()

    # now have average gain for voltage voltageArray(index) in averageGain(index) array 
    # find linear interpolation of gain for finding gain 100 linearly interpolated from nearest points
        voltageIndex = 0
        voltage100 = 0
        for voltage in voltageArray:
            #print voltageIndex,voltage,averageGain[voltageIndex-1],averageGain[voltageIndex]
            if (voltageIndex > 0 and averageGain[voltageIndex] >= 100.0 and averageGain[voltageIndex-1] < 100.0):
                voltage100 = (voltageArray[voltageIndex-1]+
                          (100.0-averageGain[voltageIndex-1])*
                          (voltageArray[voltageIndex]-voltageArray[voltageIndex-1])/
                          (averageGain[voltageIndex]-averageGain[voltageIndex-1]))
                #print "Voltage at gain 100 = ",voltage100," at ",voltageIndex,"\n"
                print "Voltage at gain 100 = ",voltage100," for APD ",apdseqno
            voltageIndex = voltageIndex + 1
        voltage150=1.02*voltage100

    # Then find gain of each pixel at the two voltage point voltage100 and voltage150 from the gaintable.
        voltageIndex = 0
        for voltage in voltageArray:
            #print voltageIndex,voltage,averageGain[voltageIndex-1],averageGain[voltageIndex]
            if (voltageIndex > 0 and voltageArray[voltageIndex-1] < voltage100 and voltage > voltage100):
                #compute gain for each pixel at V100
                FEBGain100 = 0
                FEBGain150 = 0
                for pixel in range(0,32):
                    pixelgain100 = (pixelGain[pixel+32*(voltageIndex-1)]+
                                    (pixelGain[32*voltageIndex+pixel]-pixelGain[32*(voltageIndex-1)+pixel])*
                                    (voltage100-voltageArray[voltageIndex-1])/
                                    (voltageArray[voltageIndex]-voltageArray[voltageIndex-1]))
                    m100Histo.Fill(pixelgain100)
                    FEBGain100=FEBGain100+pixelgain100/32.0
                    print "pixel ", pixel , " gain ", pixelgain100
                #print "Voltage at gain 100 = ",voltage100," at ",voltageIndex,"\n"
                print "Voltage at gain 100 = ",voltage100," for APD ",apdseqno
            if (voltageIndex > 0 and voltageArray[voltageIndex-1] < voltage150 and voltage > voltage150):
                #compute gain for each pixel at V150
                for pixel in range(0,32):
                    pixelgain150 = (pixelGain[pixel+32*(voltageIndex-1)]+
                                    (pixelGain[32*voltageIndex+pixel]-pixelGain[32*(voltageIndex-1)+pixel])*
                                    (voltage150-voltageArray[voltageIndex-1])/
                                    (voltageArray[voltageIndex]-voltageArray[voltageIndex-1]))
                    m150Histo.Fill(pixelgain150)
                    FEBGain150=FEBGain150+pixelgain150/32.0
                    pixelRatio.Fill(pixelgain150/pixelgain100)
                    print "pixel ", pixel , " gain ", pixelgain100
                   #if ((pixelgain150/pixelgain100) < 0.8):
                    #    print "APD ",Location[2], " installed at ",\
                    #    Location[0],Location[1], " ratio" , \
                    #    pixelgain150/pixelgain100, " for pixel ",pixel
                #print "Voltage at gain 100 = ",voltage100," at ",voltageIndex,"\n"
                print "Voltage at gain 150 = ",voltage150," for APD ",apdseqno        
            voltageIndex = voltageIndex + 1
        FEBRatio.Fill(FEBGain150/FEBGain100)
    c1.cd()
    m100Histo.Draw()
    m150Histo.Draw("SAME")
    c1.Update()
    c2.cd()
    pixelRatio.Draw()
    FEBRatio.Draw("SAME")
    c2.Update()

APDinstall_file.close()


#time.sleep(10)

# Just want the console to hang around so the user can look at the plots
# without them disappearing. Ctrl-D or "exit()" to quit.
print 'Ctrl-D to quit'
code.interact(local = locals(), banner='')
