#include <iostream>
#include <fstream>
#include <sstream>
#include "TH1D.h"
#include "TH2D.h"
#include "TFile.h"
#include "TCanvas.h"
#include "TStyle.h"

using namespace std;

void diffapdhv(const char* fname1, const char* fname2){
  //little macro to compare the hv settings from two different text files.
  //so that you can make sure you understand what is changing
  
  gStyle->SetOptStat("e m r i o");
  const int NDIBLK=15;
  const int NFILES=2;
  TH2D *dcmvprt[NDIBLK][NFILES];
  TH2D *dcmvprt_volt[NDIBLK][NFILES];
  for(int i=0;i<NDIBLK;i++){
    for(int j=0;j<NFILES;j++){    
      dcmvprt[i][j] = new TH2D(Form("dcmvprt_%d_%d",i,j),Form(";DCM %d; PRT",i),12,0.5,12.5,64,-0.5,63.5);
      dcmvprt[i][j]->SetStats(0);
      
      dcmvprt_volt[i][j] = new TH2D(Form("dcmvprt_volt_%d_%d",i,j),Form(";DCM %d; PRT",i),12,0.5,12.5,64,-0.5,63.5);
      dcmvprt_volt[i][j]->SetStats(0);
      //    dcmvprt_volt[i]->SetMinimum(-1);
      //      dcmvprt_volt[i][j]->SetMaximum(4500);
    }
  }
  TH1D *voltage=new TH1D("",";Ideal (warm) APD Voltage;",100,350,450);
  TH1D *febicept = new TH1D("",";FEB calibration intercept",30,280,310);
  TH1D *febslope = new TH1D("",";FEB calibration slope",10,0.0255,0.0265);
  TH1D *febset[NFILES];

  for(int i=0;i<NFILES;i++){
    febset[i] = new TH1D(Form("febset_%d",i),";FEB Setpoint",600,0,6000);
  }
  TH1D *febdiff = new TH1D("febdiff",";FEB Setpoint",600,-6000,6000);
  TH1D *vset = new TH1D("",";Voltage for 2000",150,250,400);

  ifstream in(fname1);
  //  string apd_sn;
  int dib;
  int dcm;
  int prt;
  float t;
  //  float v;
  //  string feb;
  //  float icpt;
  //  float slope;
  string iblank;
  string dcsstring;
  float setpoint;
  //  in>>apd_sn;
  string line;
  int count = 0;
  while(std::getline(in,line)){
    std::istringstream iss(line);
    std::getline(iss,iblank,',');
    std::getline(iss,dcsstring,'-');
    std::getline(iss,iblank,'-');
    string sdib;
    std::getline(iss,sdib,'-');
    dib = atoi(sdib.c_str());
    string sdcm;
    std::getline(iss,sdcm,',');
    dcm = atoi(sdcm.c_str());
    string sprt;
    std::getline(iss,sprt,',');
    prt = atoi(sprt.c_str());
    string st;
    std::getline(iss,st,',');
    t = atof(st.c_str());
    string ssetpoint;
    std::getline(iss,ssetpoint,',');
    setpoint = atof(ssetpoint.c_str());
    if(setpoint<100){
      setpoint=2.0;
      cout<<"low setpoint "<<setpoint<<" dcm "<<dcm<<" prt "<<prt<<endl;
    }
    std::getline(iss,iblank,',');
    std::getline(iss,iblank,',');
    std::getline(iss,iblank,',');
    std::getline(iss,iblank,',');
    std::getline(iss,iblank);

    //    cout<<"dib "<<dib<<" dcm "<<dcm<<" prt "<<prt<<" setpoint "<<setpoint<<" "<<endl;
    dcmvprt[dib][0]->Fill(dcm,prt);
    dcmvprt_volt[dib][0]->Fill(dcm,prt,setpoint);
    //    voltage->Fill(v);
    //    febicept->Fill(icpt);
    //    febslope->Fill(slope);
    febset[0]->Fill(setpoint);
    //    double actualv = 2000*slope+icpt;
    //    cout<<" actual v "<<actualv<<" slope "<<slope<<endl;
    //    vset->Fill(actualv);
    //    cout<<apd_sn<<" "<<dib<<" "<<dcm<<" "<<prt<<" "<<v<<" "<<feb<<" "<<icpt<<" "<<slope<<" "<<setpoint<<endl;
    count++;
    //    getline(in,line);
  }

  ifstream in2(fname2);
  int count2=0;
  while(std::getline(in2,line)){
    std::istringstream iss(line);
    std::getline(iss,iblank,',');
    std::getline(iss,dcsstring,'-');
    std::getline(iss,iblank,'-');
    string sdib;
    std::getline(iss,sdib,'-');
    dib = atoi(sdib.c_str());
    string sdcm;
    std::getline(iss,sdcm,',');
    dcm = atoi(sdcm.c_str());
    string sprt;
    std::getline(iss,sprt,',');
    prt = atoi(sprt.c_str());
    string st;
    std::getline(iss,st,',');
    t = atof(st.c_str());
    string ssetpoint;
    std::getline(iss,ssetpoint,',');
    setpoint = atof(ssetpoint.c_str());
    if(setpoint<100){
      setpoint=2.0;
      cout<<"low setpoint "<<setpoint<<" dcm "<<dcm<<" prt "<<prt<<endl;
    }
    std::getline(iss,iblank,',');
    std::getline(iss,iblank,',');
    std::getline(iss,iblank,',');
    std::getline(iss,iblank,',');
    std::getline(iss,iblank);

    //    cout<<"dib "<<dib<<" dcm "<<dcm<<" prt "<<prt<<" setpoint "<<setpoint<<" "<<endl;
    dcmvprt[dib][1]->Fill(dcm,prt);
    dcmvprt_volt[dib][1]->Fill(dcm,prt,setpoint);
    //    voltage->Fill(v);
    //    febicept->Fill(icpt);
    //    febslope->Fill(slope);
    febset[1]->Fill(setpoint);
    //    double actualv = 2000*slope+icpt;
    //    cout<<" actual v "<<actualv<<" slope "<<slope<<endl;
    //    vset->Fill(actualv);
    //    cout<<apd_sn<<" "<<dib<<" "<<dcm<<" "<<prt<<" "<<v<<" "<<feb<<" "<<icpt<<" "<<slope<<" "<<setpoint<<endl;
    count2++;
    //    getline(in,line);
  }

  for(int i=0;i<NDIBLK;i++){
    dcmvprt[i][0]->Add(dcmvprt[i][1],-1.);
    dcmvprt_volt[i][0]->Add(dcmvprt_volt[i][1],-1.);
    for(int j=1;j<=dcmvprt_volt[i][0]->GetNbinsX();j++){
      for(int k=1;k<=dcmvprt_volt[i][0]->GetNbinsY();k++){
	febdiff->Fill(dcmvprt_volt[i][0]->GetBinContent(j,k));
      }
    }
  }




  cout<<"count "<<count<<endl;
  TCanvas *can1 = new TCanvas("can1","can1");
  can1->Divide(2,2);
  can1->cd(1);
  dcmvprt[1][0]->Draw("colz");
  dcmvprt[1][0]->GetXaxis()->CenterTitle();
  dcmvprt[1][0]->GetYaxis()->CenterTitle();
  can1->cd(2);
  dcmvprt[2][0]->Draw("colz");
  dcmvprt[2][0]->GetXaxis()->CenterTitle();
  dcmvprt[2][0]->GetYaxis()->CenterTitle();
  can1->cd(3);
  dcmvprt[3][0]->Draw("colz");
  dcmvprt[3][0]->GetXaxis()->CenterTitle();
  dcmvprt[3][0]->GetYaxis()->CenterTitle();
  can1->cd(4);
  dcmvprt[4][0]->Draw("colz");
  dcmvprt[4][0]->GetXaxis()->CenterTitle();
  dcmvprt[4][0]->GetYaxis()->CenterTitle();

  TCanvas *can2 = new TCanvas("can2","can2");
  can2->Divide(2,2);
  can2->cd(1);
  dcmvprt[5][0]->Draw("colz");
  dcmvprt[5][0]->GetXaxis()->CenterTitle();
  dcmvprt[5][0]->GetYaxis()->CenterTitle();
  can2->cd(2);
  dcmvprt[6][0]->Draw("colz");
  dcmvprt[6][0]->GetXaxis()->CenterTitle();
  dcmvprt[6][0]->GetYaxis()->CenterTitle();
  can2->cd(3);
  dcmvprt[7][0]->Draw("colz");
  dcmvprt[7][0]->GetXaxis()->CenterTitle();
  dcmvprt[7][0]->GetYaxis()->CenterTitle();
  can2->cd(4);
  dcmvprt[8][0]->Draw("colz");
  dcmvprt[8][0]->GetXaxis()->CenterTitle();
  dcmvprt[8][0]->GetYaxis()->CenterTitle();

  TCanvas *can3 = new TCanvas("can3","can3");
  can3->Divide(2,2);
  can3->cd(1);
  dcmvprt[9][0]->Draw("colz");
  dcmvprt[9][0]->GetXaxis()->CenterTitle();
  dcmvprt[9][0]->GetYaxis()->CenterTitle();
  can3->cd(2);
  dcmvprt[10][0]->Draw("colz");
  dcmvprt[10][0]->GetXaxis()->CenterTitle();
  dcmvprt[10][0]->GetYaxis()->CenterTitle();
  can3->cd(3);
  dcmvprt[11][0]->Draw("colz");
  dcmvprt[11][0]->GetXaxis()->CenterTitle();
  dcmvprt[11][0]->GetYaxis()->CenterTitle();
  can3->cd(4);
  dcmvprt[12][0]->Draw("colz");
  dcmvprt[12][0]->GetXaxis()->CenterTitle();
  dcmvprt[12][0]->GetYaxis()->CenterTitle();


  TCanvas *can6 = new TCanvas("can6","can6");
  can6->Divide(2,2);
  can6->cd(1);
  dcmvprt_volt[1][0]->Draw("colz");
  dcmvprt_volt[1][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[1][0]->GetYaxis()->CenterTitle();
  can6->cd(2);
  dcmvprt_volt[2][0]->Draw("colz");
  dcmvprt_volt[2][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[2][0]->GetYaxis()->CenterTitle();
  can6->cd(3);
  dcmvprt_volt[3][0]->Draw("colz");
  dcmvprt_volt[3][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[3][0]->GetYaxis()->CenterTitle();
  can6->cd(4);
  dcmvprt_volt[4][0]->Draw("colz");
  dcmvprt_volt[4][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[4][0]->GetYaxis()->CenterTitle();

  TCanvas *can7 = new TCanvas("can7","can7");
  can7->Divide(2,2);
  can7->cd(1);
  dcmvprt_volt[5][0]->Draw("colz");
  dcmvprt_volt[5][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[5][0]->GetYaxis()->CenterTitle();
  can7->cd(2);
  dcmvprt_volt[6][0]->Draw("colz");
  dcmvprt_volt[6][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[6][0]->GetYaxis()->CenterTitle();
  can7->cd(3);
  dcmvprt_volt[7][0]->Draw("colz");
  dcmvprt_volt[7][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[7][0]->GetYaxis()->CenterTitle();
  can7->cd(4);
  dcmvprt_volt[8][0]->Draw("colz");
  dcmvprt_volt[8][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[8][0]->GetYaxis()->CenterTitle();

  TCanvas *can8 = new TCanvas("can8","can8");
  can8->Divide(2,2);
  can8->cd(1);
  dcmvprt_volt[9][0]->Draw("colz");
  dcmvprt_volt[9][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[9][0]->GetYaxis()->CenterTitle();
  can8->cd(2);
  dcmvprt_volt[10][0]->Draw("colz");
  dcmvprt_volt[10][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[10][0]->GetYaxis()->CenterTitle();
  can8->cd(3);
  dcmvprt_volt[11][0]->Draw("colz");
  dcmvprt_volt[11][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[11][0]->GetYaxis()->CenterTitle();
  can8->cd(4);
  dcmvprt_volt[12][0]->Draw("colz");
  dcmvprt_volt[12][0]->GetXaxis()->CenterTitle();
  dcmvprt_volt[12][0]->GetYaxis()->CenterTitle();


  //  TCanvas *can2 = new TCanvas("can2","can2");
  //  can2->cd();
  //  voltage->Draw();
  //  TCanvas *can3 = new TCanvas("can3","can3");
  //  can3->cd();
  //  febicept->Draw();
  //  TCanvas *can4 = new TCanvas("can4","can4");
  //  can4->cd();
  //  febslope->GetXaxis()->SetNdivisions(504);
  //  febslope->Draw();
  TCanvas *canf = new TCanvas("canf","canf");
  canf->cd();
  febdiff->Draw();
  //  TCanvas *can7 = new TCanvas("can7","can7");
  //  can7->cd();
  //  vset->SetStats(0);
  //  vset->Draw();
  /*
  for(int i=1;i<NDIBLK;i++){
    for(int j=1;j<=dcmvprt[i]->GetNbinsX();j++){
      for(int k=1;k<=dcmvprt[i]->GetNbinsY();k++){
	if(dcmvprt[i]->GetBinContent(j,k)<0.5) cout<<"zero! diblock "<<i<<" dcm "<<j<<" port "<<k-1<<endl;
	if(dcmvprt[i]->GetBinContent(j,k)>1.5) cout<<"double! diblock "<<i<<" dcm "<<j<<" port "<<k-1<<endl;
      }
    }
  }
  */

}
