#include "EventDispatcher_CommandSet/DispatcherAck.h"

#include <sys/types.h>
#include <stdint.h>
#include <unistd.h>
#include <stdexcept>

DispatcherACK::DispatcherACK(unsigned char* output_buff):external_buff(output_buff), acknowledged_commands(new DispatcherCMD(external_buff+1)) {
 *external_buff=0;  
}

bool DispatcherACK::notEmpty() {
  return *(external_buff+1)!=0; // not empty responses should have more then two bytes
}

ssize_t DispatcherACK::write() {
  ssize_t cmdsize = acknowledged_commands->write();

  if(cmdsize>254)
	throw std::overflow_error("Response exceeds 255 bytes.");

  *external_buff=cmdsize; //update leading byte count
  *(external_buff+1)=DispatcherACK::DSPRES_ACK;

  return ++cmdsize >3?cmdsize:0;
}


