#include "NdmcClientServiceTest.h"
using namespace NDMC_NAMESPACE;

/**
 * Register the NdmcClientServiceTest suite in the registry of suites in a "folder"
 * of name "NovaDAQMonitorClient".  Store the folder in the default registry path.
 * $Id: NdmcClientServiceTest.cpp,v 1.4 2010/07/27 15:11:21 kasahara Exp $
 */
CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( NdmcClientServiceTest, "NovaDAQMonitorClient" );
CPPUNIT_REGISTRY_ADD_TO_DEFAULT("NovaDAQMonitorClient");

/**
 * A public method to setUp the environment for the test.  This will be invoked before
 * every test in the fixture to get a fresh start.
 */
void NdmcClientServiceTest::setUp() {
  _configFile = getConfigFullFilePathName("unittest/gmond.conf");
}
/**
 * A public method to tearDown the environment for the test.  This will be invoked after
 * every test in the fixture to clean up allocated memory.
 */
void NdmcClientServiceTest::tearDown() {
  std::cout.flush();
}

/**
 * A test method to test that NdmcClient::instance()
 * works correctly.
 */
void NdmcClientServiceTest::testInstance() {

  NdmcClientService::setCONFIGFILE(_configFile);
  NdmcClientService& daqmonitorclientservice = NdmcClientService::instance();
  CPPUNIT_ASSERT(daqmonitorclientservice.isEnabled() == true);

}

