#ifndef __NDMC_CLIENTTEST_HPP_
#define __NDMC_CLIENTTEST_HPP_

#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestFixture.h>

#include <NovaDAQMonitorClient/NdmcClient.h>

class NdmcClientTest : public CPPUNIT_NS::TestFixture {

  /**
   * The following set of macros construct a TestSuite of name NdmcClientTest
   * to test the NdmcClient methods.
   *
   * @author Susan Kasahara
   * @date May 5 2010 (Creation) 
   */
  CPPUNIT_TEST_SUITE( NdmcClientTest );
  CPPUNIT_TEST ( testCtor );
  CPPUNIT_TEST ( testAdoptMetric );
  CPPUNIT_TEST ( testGetMetric );
  CPPUNIT_TEST ( testSetSendTimeInterval );
  CPPUNIT_TEST ( testSetPartition );
  CPPUNIT_TEST ( testSetApplicationName );
  CPPUNIT_TEST ( testSetGroupName );
  CPPUNIT_TEST ( testCreateMetric );
  CPPUNIT_TEST ( testDestroyMetric );
  CPPUNIT_TEST ( testGetLastValueSent );
  CPPUNIT_TEST_SUITE_END();

public:

  void setUp();
  void tearDown();
  void testCtor();
  void testAdoptMetric();
  void testGetMetric();
  void testSetSendTimeInterval();
  void testSetPartition();
  void testSetApplicationName();
  void testSetGroupName();
  void testCreateMetric();
  void testDestroyMetric();
  void testGetLastValueSent();

private:

  std::string _configFile;

};
#endif // __NDMC_CLIENTTEST_HPP_
