#ifndef __NDMC_METRICTEST_HPP_
#define __NDMC_METRICTEST_HPP_

#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/TestFixture.h>

#include <NovaDAQMonitorClient/NdmcMetric.h>

class NdmcMetricTest : public CPPUNIT_NS::TestFixture {

  /**
   * The following set of macros construct a TestSuite of name NdmcMetricTest
   * to test the NdmcMetric methods.
   *
   * @author Susan Kasahara
   * @date May 5 2010 (Creation) 
   */
  CPPUNIT_TEST_SUITE( NdmcMetricTest );
  CPPUNIT_TEST ( testCtor );
  CPPUNIT_TEST ( testGetTypeUint32_t );
  CPPUNIT_TEST ( testGetTypeInt32_t );
  CPPUNIT_TEST ( testGetTypeUint16_t );
  CPPUNIT_TEST ( testGetTypeInt16_t );
  CPPUNIT_TEST ( testGetTypeUint8_t );
  CPPUNIT_TEST ( testGetTypeInt8_t );
  CPPUNIT_TEST ( testGetTypeFloat );
  CPPUNIT_TEST ( testGetTypeDouble );
  CPPUNIT_TEST ( testGetTypeUnknown );
  CPPUNIT_TEST ( testSetValueMetricTypeVALUE );
  CPPUNIT_TEST ( testSetValueMetricTypeCOUNTER );
  CPPUNIT_TEST ( testSetValueMetricTypeRATE );
  CPPUNIT_TEST ( testSetValueMetricTypeAVERAGE );
  CPPUNIT_TEST ( testSetValueMetricTypeSTDEV );
  CPPUNIT_TEST ( testSetValueMetricTypeMINIMUM );
  CPPUNIT_TEST ( testSetValueMetricTypeMAXIMUM );
  CPPUNIT_TEST ( testCalculateSendValueMetricTypeVALUE );
  CPPUNIT_TEST ( testCalculateSendValueMetricTypeCOUNTER );
  CPPUNIT_TEST ( testCalculateSendValueMetricTypeRATE );
  CPPUNIT_TEST ( testCalculateSendValueMetricTypeAVERAGE );
  CPPUNIT_TEST ( testCalculateSendValueMetricTypeSTDEV );
  CPPUNIT_TEST ( testCalculateSendValueMetricTypeMINIMUM );
  CPPUNIT_TEST ( testCalculateSendValueMetricTypeMAXIMUM );
  CPPUNIT_TEST ( testSetPartition );
  CPPUNIT_TEST ( testSetApplicationName );
  CPPUNIT_TEST ( testSetGroupName );
  CPPUNIT_TEST ( testSetTitle );
  CPPUNIT_TEST ( testSetDescription );
  CPPUNIT_TEST ( testGetLastValueSent );

  CPPUNIT_TEST_SUITE_END();

public:

  void setUp();
  void tearDown();

  void testCtor();
  void testGetTypeUint32_t();
  void testGetTypeInt32_t();
  void testGetTypeUint16_t();
  void testGetTypeInt16_t();
  void testGetTypeUint8_t();
  void testGetTypeInt8_t();
  void testGetTypeFloat();
  void testGetTypeDouble();
  void testGetTypeUnknown();
  void testSetValueMetricTypeVALUE();
  void testSetValueMetricTypeCOUNTER();
  void testSetValueMetricTypeRATE();
  void testSetValueMetricTypeAVERAGE();
  void testSetValueMetricTypeSTDEV();
  void testSetValueMetricTypeMINIMUM();
  void testSetValueMetricTypeMAXIMUM();
  void testCalculateSendValueMetricTypeVALUE();
  void testCalculateSendValueMetricTypeCOUNTER();
  void testCalculateSendValueMetricTypeRATE();
  void testCalculateSendValueMetricTypeAVERAGE();
  void testCalculateSendValueMetricTypeSTDEV();
  void testCalculateSendValueMetricTypeMINIMUM();
  void testCalculateSendValueMetricTypeMAXIMUM();
  void testSetPartition();
  void testSetApplicationName();
  void testSetGroupName();
  void testSetTitle();
  void testSetDescription();
  void testGetLastValueSent();

private:

  std::string _configFile;

};
#endif // __NDMC_METRICTEST_HPP_
