#include <NovaDAQUtilities/LocationUtils.h>
#include <boost/lexical_cast.hpp>
#include <boost/algorithm/string.hpp>
#include <iostream>
#include <string>
#include <vector>

/**
 * Command-line utility for testing how LocationUtils::findFile() works.
 */

int main(int argc, char **argv) {

    // check arguments
    if (argc < 2) {
        std::cerr << "Usage: " << argv[0]
                  << " <filename> [prefix1 [prefix2 ...]]" << std::endl;
        return -1;
    }

    // capture prefixes, if needed
    std::vector<std::string> prefixes;
    if (argc > 2) {
        for (int idx = 2; idx < argc; ++idx) {
            std::string tmpString(argv[idx]);
            prefixes.push_back(tmpString);
        }
    }

    // run the test
    std::string filename(argv[1]);
    std::string result;
    if (novadaq::LocationUtils::findFile(filename, result, prefixes)) {
        std::cout << "File \"" << filename << "\" was found at "
                  << result << "." << std::endl;
    }
    else {
        std::cout << "File \"" << filename << "\" was not found." << std::endl;
    }

    return 0;
}
