package novadaq;

/**
 * A general-purpose exception class for reporting problems in NOvA DAQ
 * classes.
 *
 * @author Kurt Biery
 * @version $Revision: 1.1 $ $Date: 2009/11/24 22:15:46 $
 */
public class Exception extends java.lang.Exception {

    /**
     * Default constructor.
     */
    public Exception() {
        super();
    }

    /**
     * Constructs a new instance with the specified detail message.
     *
     * @param messageText the error message
     */
    public Exception(String messageText) {
        super(messageText);
    }

    /**
     * Constructs a new instance with the specified cause.
     *
     * @param cause the exception or error contained within this exception
     */
    public Exception(Throwable cause) {
        super(cause);
    }

    /**
     * Constructs a new instance with the specified detail message and cause.
     *
     * @param messageText the error message
     * @param cause the exception or error contained within this exception
     */
    public Exception(String messageText, Throwable cause) {
        super(messageText, cause);
    }
}
