package novadaq;

/**
 * The interface for classes that provide the ability to serialize their
 * attributes into XML and populate their contents by deserializing XML.
 *
 * @author Kurt Biery
 * @version $Revision: 1.1 $ $Date: 2009/11/24 22:15:46 $
 */
public interface XMLSerializable extends java.io.Serializable {

    /**
     * Returns a String containing the serialized contents of the object.
     *
     * @return a string containing the serialized object
     * @throws novadaq.DataException if an error occurs serializing the
     *         object data
     */
    public String serialize() throws novadaq.DataException;

    /**
     * Populates the internal data of the object based on serialized 
     * data in the input String.
     *
     * @param serializedData a string containing serialized object data
     * @throws novadaq.DataException if an error occurs deserializing the
     *         string representation of the object into its internal data
     */
    public void deserialize(String serializedData) throws novadaq.DataException;
}
