package novadaq.demo;

/**
 * Interface for GUI applications that can be launched in a predefined manner.
 *
 * @author Kurt Biery
 * @version $Revision: 1.1 $ $Date: 2009/11/23 18:52:03 $
 */

import java.awt.Component;
import javax.swing.JFrame;
import javax.swing.JMenuBar;

public interface Launchable {

    /**
     * Returns the splash screen for the application or NULL if none.
     */
    public Component getSplashPanel() throws Exception;

    /**
     * Performs any long-running initialization needed by the application.
     */
    public void initialize() throws Exception;

    /**
     * Returns the main display for the application.
     */
    public Component getMainDisplay(JFrame parentFrame) throws Exception;

    /**
     * Returns the menu bar for the application.
     */
    public JMenuBar getMenuBar();
}
