#!/bin/sh

echo "Are you sure that you want to create the FEB Dry Air Channel table in the $NOVADBNAME database? [y/n]"
read response

if [[ "$response" == "y" ]]; then
    createTableInDB NovaDatabase/tables/DCS/FEBDryAirChannels.xml

    utc_now=`date -u '+%Y%m%d %H:%M:%S'`
    echo ""
    echo "To populate the initial default value, you can use the following commands:"
    echo "* psql -h ${NOVADBHOST} -d ${NOVADBNAME} -p ${NOVADBPORT} -U ${NOVADBUSER} -c \"select * from dcs_named_subsystem_configurations order by id desc\""
    echo "* psql -h ${NOVADBHOST} -d ${NOVADBNAME} -p ${NOVADBPORT} -U ${NOVADBUSER} -c \"insert into feb_dry_air_channels (dcmName, febId, dryAirChannel, subsysCfgId, insertTime, insertUser) values ('default', -1, 0, <CFG_ID from previous query>, '${utc_now}', '${USER}')\""
fi
