#!/bin/sh

echo "Are you sure that you want to modify the $NOVADBNAME database? [y/n]"
read response

if [[ "$response" == "y" ]]; then

  utc_now=`date -u '+%Y%m%d %H:%M:%S'`

  # create the tables
  createTableInDB -d ${NOVADAQ_ENVIRONMENT} -f NovaDatabase/tables/DCS/EPICSAlarmThresholds.xml

  # look up the most recent DCS subsystem configuration
  cfg_id=`psql -h $NOVADBHOST -d $NOVADBNAME -p $NOVADBPORT -U $NOVADBUSER -t -c "select id from ${NOVADAQ_ENVIRONMENT}.dcs_named_subsystem_configurations order by id desc limit 1"`
  #echo "_${cfg_id}_"

  # create the default entries in the new table
  psql -h $NOVADBHOST -d $NOVADBNAME -p $NOVADBPORT -U $NOVADBUSER \
      -c "INSERT INTO ${NOVADAQ_ENVIRONMENT}.epics_alarm_thresholds (dcmName, febId, pvName, hihi, hilo, lohi, lolo, subsysCfgId, inserttime, insertuser) VALUES ('default', -1, 'tecc', -13.0, -13.0, -17.0, -17.0, ${cfg_id}, '${utc_now}', '${USER}')"

  psql -h $NOVADBHOST -d $NOVADBNAME -p $NOVADBPORT -U $NOVADBUSER \
      -c "INSERT INTO ${NOVADAQ_ENVIRONMENT}.epics_alarm_thresholds (dcmName, febId, pvName, hihi, hilo, lohi, lolo, subsysCfgId, inserttime, insertuser) VALUES ('default', -1, 'febtemp', 45, 45, 15, 15, ${cfg_id}, '${utc_now}', '${USER}')"

  psql -h $NOVADBHOST -d $NOVADBNAME -p $NOVADBPORT -U $NOVADBUSER \
      -c "INSERT INTO ${NOVADAQ_ENVIRONMENT}.epics_alarm_thresholds (dcmName, febId, pvName, hihi, hilo, lohi, lolo, subsysCfgId, inserttime, insertuser) VALUES ('default', -1, 'dc', 90, 90, 10, 10, ${cfg_id}, '${utc_now}', '${USER}')"

fi
