#! /bin/bash

# the basename of the file is passed to the script
IDL_BASENAME=$1
PACKAGE=$2

# copy all the original versions of the .h and .cpp files
# into new files to be manipulated
mv ccpp_${IDL_BASENAME}.h ccpp_${IDL_BASENAME}.h.orig

for fn in ${IDL_BASENAME} ${IDL_BASENAME}Dcps ${IDL_BASENAME}Dcps_impl ${IDL_BASENAME}SplDcps 
do
  mv ${fn}.h    ${fn}.h.orig
  mv ${fn}.cpp  ${fn}.cpp.orig
done

ddsidl_namespace=`grep namespace ${IDL_BASENAME}.h.orig | awk '{print $2}'` 
#echo "namespace is ${ddsidl_namespace}"
#echo "${IDL_BASENAME}Dcps.h.orig contains"
#cat ${IDL_BASENAME}Dcps.h.orig
grep DataWriter ${IDL_BASENAME}Dcps.h.orig | grep class | grep ";" | sort -u | sed 's/;.*//' | sed 's/DataWriter//' | sed 's/^\s*//' | sed "s/class\s\+\(\S\+\)/namespace ${ddsidl_namespace} {\n  class \1TypeSupport;\n  class \1DataWriter;\n  class \1DataReader;\n}\ndeclare_dds_message(${ddsidl_namespace}::\1)/" > ddsidl.work
#echo "ddsidl.work contains:"
#cat ddsidl.work
(cat ccpp_${IDL_BASENAME}.h.orig | grep -v \#endif; echo "#include <rms/provider/CETDDS.h>" ; cat ddsidl.work ; cat ccpp_${IDL_BASENAME}.h.orig | grep \#endif) > ccpp_${IDL_BASENAME}.h
#echo "ccpp_${IDL_BASENAME}.h contains"
#cat ccpp_${IDL_BASENAME}.h
mv ccpp_${IDL_BASENAME}.h ccpp_${IDL_BASENAME}.h.orig
rm ddsidl.work

for fn in ${IDL_BASENAME} ccpp_${IDL_BASENAME} ${IDL_BASENAME}Dcps ${IDL_BASENAME}Dcps_impl ${IDL_BASENAME}SplDcps
do
  cat ${fn}.h.orig | sed "s,\(#include \"\)\(.*${IDL_BASENAME}\),\1${PACKAGE}/\2," > ${fn}.h

  # check that we are not in the rms package and if that is the case, be sure to add in 
  # the correct path to include RmsMessageCore
  if [ "${PACKAGE}" != "rms" ] ; then
      #echo "fixing include path for RmsMessageCore in ${fn}.h"
      sed -i "s,#include \"RmsMessageCore,#include \"rms/RmsMessageCore," ${fn}.h
      #cat ${fn}.h | grep RmsMessageCore
  fi

done

src=${IDL_BASENAME}Dcps_impl.cpp
echo "#include \"ccpp_${IDL_BASENAME}.h\"" > ${src}.tmp
cat ${src}.orig >> ${src}.tmp 
cat ${src}.tmp | sed "s,\(#include \"\)\(.*${IDL_BASENAME}\),\1${PACKAGE}/\2," > ${src}

for fn in ${IDL_BASENAME} ${IDL_BASENAME}Dcps ${IDL_BASENAME}Dcps_impl ${IDL_BASENAME}SplDcps 
do
  cat ${fn}.cpp.orig | sed "s,\(#include \"\)\(.*${IDL_BASENAME}\),\1${PACKAGE}/\2," > ${fn}.cpp
done

# clean up the temporary files
rm *.tmp
rm *.orig
