#!/bin/bash
#

# ups_product_tag.sh <previous ups version> <new ups version> <previous cvs tag> <new cvs tag>

usage()
{
   echo "USAGE: `basename ${0}` <previous ups version> <new ups version> <previous cvs tag> <new cvs tag>"
   echo "Please run from the ups directory of the repository"
}


# -------------------------------------------------------------------
# start processing
# -------------------------------------------------------------------

prev_version=${1}
ups_version=${2}
prev_cvstag=${3}
new_cvstag=${4}

if [ -z ${prev_version} ]
then 
    usage
    exit 1
fi

# -------------------------------------------------------------------
# need to edit product_deps, build_novasoft.sh and bootstrap.sh
# to have the correct product version
# also need to tag the repository
# -------------------------------------------------------------------

# first edit the product_deps file - only need to change the parent version line
sed -i~ "s/parent novadaq $prev_version/parent novadaq $ups_version/" product_deps

# now for the bootstrap.sh script and build_novadaq.sh scripts
sed -i~ "s/pkgver=$prev_version/pkgver=$ups_version/" bootstrap.sh
sed -i~ "s/$prev_cvstag/$new_cvstag/"                 bootstrap.sh
sed -i~ "s/pkgver=$prev_version/pkgver=$ups_version/" build_novadaq.sh

# now commit these changes to the repository
cvs commit -m"***This commit does not change any code*** Preparing for ups version $ups_version"



exit 0
