#include "ShmMilliBlock/ShmMilliBlock.h"

#include <boost/typeof/typeof.hpp>

#include <iostream>



int main()
{
  ShmMilliBlock shared_milli_block;
  RawMilliBlock milli_block;

  unsigned n_got(0), n_ungot(0);

  while (true)
  {
    // 1. Extract a milliblock from the shared memory segment:

    // The first argument is tmo_us, which could mean "time-out micro seconds".
    // A value of tmo_us = -1 is considered a "block"
    int tmo_us = 10000;
    if (shared_milli_block.getMilliBlock(tmo_us, milli_block))
    {
      ++n_got;

      int n_slices = milli_block.slices.size();
      std::cout << "This block contains " << n_slices << " millislices." 
		<< std::endl;

      // 2. Loop over the millislices in the milliblock:
      for (BOOST_AUTO(slice, milli_block.slices.begin()); 
	   slice != milli_block.slices.end(); ++slice)
      {
	std::cout << "Millislice Info:"
		  << "\n\tVersion:   " << slice->getVersion()
		  << "\n\tDCM ID:    " << slice->getDCMId()
		  << "\n\tTimeStart: " << slice->getTimeStart()
		  << std::endl;
      }
    } else {
      ++n_ungot;
      if (n_ungot % 100 == 0)
	std::cout << n_ungot << "   Could not get Milliblock!" << std::endl;
    }
  }

  return 0;
}
