//  This file (TCAttrib.h) was created by Ron Rechenmacher <ron@fnal.gov> on
//  Oct 28, 2011. "TERMS AND CONDITIONS" governing this file are in the README
//  or COPYING file. If you do not have such a file, one can be obtained by
//  contacting Ron or Fermi Lab in Batavia IL, 60510, phone: 630-840-3000.
//  $RCSfile: TCAttrib.h,v $
//  rev="$Revision: 1.1 $$Date: 2011/11/01 15:56:07 $";

#ifndef TCATTRIB_H
#define TCATTRIB_H
#include <stdio.h>		// printf
#include <stdlib.h>		// atexit
#include <termio.h>             // struct termio
#include <stdint.h>		// uint8_t

class TCAttrib
{
    static termio _tio_sav;
    static void _cleanup()
    {   printf("cleanup\n");
	ioctl( 0,TCSETA, &_tio_sav );
    }
public:
    static void keypress( uint8_t tmo )
    {
        termio           tio;
	int sts = ioctl( 0,TCGETA,&tio );
	if (sts == -1) { perror("ioctl get"); exit(0); }
	_tio_sav = tio;
	tio.c_lflag &= ~ICANON;
	tio.c_lflag &= ~ECHO;
	tio.c_cc[VEOF] = '\0';
	tio.c_cc[VTIME] = tmo;
	tio.c_cc[VMIN] = 0;
	sts = ioctl( 0,TCSETA,&tio );
	if (sts == -1) { perror("ioctl set"); exit(0); }
	atexit( _cleanup );
    }
    static void adjust_tmo( uint8_t tmo )
    {
        termio           tio;
	int sts = ioctl( 0,TCGETA,&tio );
	if (sts == -1) { perror("ioctl get"); exit(0); }
	tio.c_lflag &= ~ICANON;
	tio.c_lflag &= ~ECHO;
	tio.c_cc[VEOF] = '\0';
	tio.c_cc[VTIME] = tmo;
	tio.c_cc[VMIN] = 0;
	sts = ioctl( 0,TCSETA,&tio );
	if (sts == -1) { perror("ioctl set"); exit(0); }
    }
};
termio  TCAttrib::_tio_sav={0};

#endif // TCATTRIB_H
