 // This file (compat_writer.cc) was created by Ron Rechenmacher <ron@fnal.gov> on
 // Feb 26, 2014. "TERMS AND CONDITIONS" governing this file are in the README
 // or COPYING file. If you do not have such a file, one can be obtained by
 // contacting Ron or Fermi Lab in Batavia IL, 60510, phone: 630-840-3000.
 // $RCSfile: compat_writer.cc,v $
 // rev="$Revision: 1.2 $$Date: 2014/02/27 03:13:02 $";

#include <stdio.h>		// printf
#include "../include/ShmRdWr.h"

ShmRdWr shmwr_;

void shm_write_(void *buffer, unsigned sizeof_bytes)
{
    size_t tot_bytes=0, max_bytes;
    size_t slices=0;
    struct { int total_bytes,millislice_count; } rmb;

    // write milliblock to shm
    shmwr_.start_write(); // records time.
    max_bytes = shmwr_.start_write();
    shmwr_.seek( sizeof(rmb) );
    for (unsigned ii2=0; ii2<15; ++ii2)
    {   size_t sz=sizeof_bytes-ii2;
	shmwr_.add_data( buffer, sz );
	tot_bytes += sz;
	slices++;
    }
    rmb.total_bytes          = tot_bytes;
    rmb.millislice_count     = slices;
    shmwr_.seek( 0 );
    shmwr_.add_data( &rmb, sizeof(rmb) );
    shmwr_.end_write();
}   // shm_write_


int main(  int argc, char *argv[] )
{
    unsigned char  buffer[0x10000];
    unsigned xx=0;
    while (1)
    { shm_write_(buffer, sizeof(buffer)-xx);
      usleep(50000);
      xx+=1;
      xx&=0xff;
    }
    return (0);
}   // main
