//  This file (simple_read_grper.cc) was created by Ron Rechenmacher <ron@fnal.gov> on
//  Sep 30, 2013. "TERMS AND CONDITIONS" governing this file are in the README
//  or COPYING file. If you do not have such a file, one can be obtained by
//  contacting Ron or Fermi Lab in Batavia IL, 60510, phone: 630-840-3000.
//  $RCSfile: simple_read_grper.cc,v $
//  rev="$Revision: 1.2 $$Date: 2014/01/22 19:29:02 $";

#include <stdio.h>		// printf
#include <string.h>		// memcpy
#include "../include/ShmRdWr.h"

int
main(  int	argc
     , char	*argv[] )
{
    ShmRdWr shmrw;
    int sts=shmrw.attach();
    if (sts != 0)
    {  fprintf(stderr,"attach failed -- make sure env.var. %s is set.\n"
	       "try: SHMRW_KEY=0x0010703 simple_writer\n"
	       "(remove shm key w/ ipcrm -M key -S key)\n"
	       , shmrw.envvar() );
       return (1);
    }

    uint buf[0x100000];
    //time_t tmo_ms=-1;
    time_t tmo_ms=9999999;
    //shmrw.set_poll_ms( 100 );
    ShmRdWr_Info info;
    uint32_t ovrwt, ovrwt2;
    while (1)
    {
	sts = shmrw.read_grp( buf, sizeof(buf), info, tmo_ms );
	if (sts >0)
	{   printf("read   %u ovrwt=%u ovrwt_tot=%u\n"
		   , buf[0], info.ovrwt, info.ovrwt_tot );
	    usleep (200000);
	}
	else
	{   printf("sts=%d (tmo, error, or 0 bytes) ovrwt_tot=%u\n"
		   ,sts,info.ovrwt_tot);
	    usleep (400000);
	}

	// OR

	ssize_t bytes_avail=shmrw.read_grp_start( ovrwt );
	if (bytes_avail > 0)
	{   sts = shmrw.read_grp( buf, sizeof(buf), ovrwt2 );
	    if (sts > 0)
	    {   printf("read   %u ovrwt=%u ovrwt2=%u\n", buf[0], ovrwt, ovrwt2 );
		usleep (200000);
	    }
	    else printf("read_grp returned %d\n",sts);
	}
	else
	{   printf("read_grp_start returned %ld\n",bytes_avail);
	    shmrw.read_grp_close( ovrwt ); // for theoretical 0 bytes case to do semgive
	}

	// OR

	bytes_avail=shmrw.read_grp_start( info ); ovrwt=info.ovrwt;
	if (bytes_avail > 0)
	{   uint8_t *dptr=info.data_ptr;
	    size_t  read_bytes = bytes_avail;
	    if (read_bytes > sizeof(buf))
	    {   printf("partial read\n"); read_bytes=sizeof(buf);
	    }
	    memcpy( buf, dptr, read_bytes );
	    shmrw.read_grp_close( ovrwt2 );
	    printf("memcpy %u ovrwt=%u ovrwt2=%u\n", buf[0], ovrwt, ovrwt2 );
	    usleep (200000);
	}
	else
	{   printf("read_grp_start returned %ld\n",bytes_avail);
	    shmrw.read_grp_close( ovrwt ); // for theoretical 0 bytes case to do semgive
	}
    }
    return (0);
}   // main
