//  This file (simple_reader.cc) was created by Ron Rechenmacher <ron@fnal.gov> on
//  Sep 30, 2013. "TERMS AND CONDITIONS" governing this file are in the README
//  or COPYING file. If you do not have such a file, one can be obtained by
//  contacting Ron or Fermi Lab in Batavia IL, 60510, phone: 630-840-3000.
//  $RCSfile: simple_reader.cc,v $
//  rev="$Revision: 1.2 $$Date: 2014/01/22 19:29:02 $";

#include <stdio.h>		// printf
#include <string.h>		// memcpy
#include "../include/ShmRdWr.h"

int
main(  int	argc
     , char	*argv[] )
{
    ShmRdWr shmrw;
    int sts=shmrw.attach();
    if (sts != 0)
    {  fprintf(stderr,"attach failed -- make sure env.var. %s is set.\n"
	       "try: SHMRW_KEY=0x0010703 simple_writer\n"
	       "(remove shm key w/ ipcrm -M key -S key)\n"
	       , shmrw.envvar() );
       return (1);
    }

    uint buf[0x100000];
    //time_t tmo_ms=-1;
    time_t tmo_ms=9999999;
    //shmrw.set_poll_ms( 100 );
    ShmRdWr_Info info;
    //uint32_t ovrwt, ovrwt2;
    while (1)
    {
	sts = shmrw.read( buf, sizeof(buf), info, tmo_ms );
	if (sts >0)
	{   printf("read   %u ovrwt=%u ovrwt_tot=%u\n", buf[0], info.ovrwt, info.ovrwt_tot );
	    usleep (20000);
	}
	else
	{   printf("tmo (or 0 bytes) sts=%d\n",sts);
	    usleep (40000);
	}



    }
    return (0);
}   // main
