//  This file (simple_writer.cc) was created by Ron Rechenmacher <ron@fnal.gov> on
//  Sep 30, 2013. "TERMS AND CONDITIONS" governing this file are in the README
//  or COPYING file. If you do not have such a file, one can be obtained by
//  contacting Ron or Fermi Lab in Batavia IL, 60510, phone: 630-840-3000.
//  $RCSfile: simple_writer.cc,v $
//  rev="$Revision: 1.1 $$Date: 2013/09/30 19:41:28 $";

#include <stdio.h>		// printf
#include "../include/ShmRdWr.h"

int
main(  int	argc
     , char	*argv[] )
{
    ShmRdWr shmrw(SHMRW_O_WRITER);
    int sts=shmrw.attach();
    if (sts != 0)
    {  fprintf(stderr,"attach failed -- make sure env.var. %s is set.\n"
	       "try: SHMRW_KEY=0x0010703 simple_writer\n"
	       "(remove shm key w/ ipcrm -M key -S key)\n"
	       , shmrw.envvar() );
       return (1);
    }

    uint buf[120];
    for (uint ii=0; 1; ++ii)
    {
	buf[0] = ii;
	shmrw.write( buf, sizeof(buf) );
	printf("wrote %u\n", ii );
	usleep( 100000 );

	// OR...

	buf[0] = ++ii;
	shmrw.write( &buf[40], sizeof(buf)/3,true, 40*sizeof(buf[0]) ); // write in multiple parts to same buffer
	shmrw.write( &buf[80], sizeof(buf)/3,true );
	shmrw.write( &buf[0],  sizeof(buf)/3,(off_t)0 );
	printf("wrote %u\n", ii );
	usleep( 100000 );

    }
    return (0);
}   // main
