#ifndef _RMS_MESSAGEBODY_H
#define _RMS_MESSAGEBODY_H

#include <string>

#include <rms/RmsMessageSchema.h>

namespace gov {

namespace fnal {

namespace cd {

namespace rms {

namespace base {

/**
 * A class to contain the content of an RmsMessage.
 *
 * @author Kurt Biery
 * @author Steve Foulkes
 * @version $Revision: 1.1.1.1 $ $Date: 2009/10/09 20:03:00 $
 */

class RmsMessageBody : public gov::fnal::cd::rms::xsd::messageBody {  
 public:
    /**
     * Default constructor.
     */
    RmsMessageBody() {}
    
    /**
     * Constructs an instance from an instance of the XSD base class.
     */
    RmsMessageBody(const xsd::messageBody& baseBody) : xsd::messageBody(baseBody) {}
    
    /**
     * Get the name of the class that this message represents.
     *
     * @return The name of the class the body represents.
     */
    std::string getClassName() const {
        return this->className();
    }
    
    /**
     * Get the message content.
     *
     * @return The message content
     */
    std::string getContent() const {
        return this->content();
    }
  
    /**
     * Set the class name.
     *
     * @param name The new class name
     */
    void setClassName(std::string name) {
        this->className(name);
    }

    /** 
     * Set the body's content.
     *
     * @param text The new content
     */
    void setContent(std::string text) {
        this->content(text);
    }
};

};  // end of namespace base

};  // end of namespace rms

};  // end of namespace cd

};  // end of namespace fnal

};  // end of namespace gov

#endif
