#ifndef _RMS_MESSAGESPLITTER_H
#define _RMS_MESSAGESPLITTER_H

#include <rms/provider/MessageFragment.h>

#include <vector>
#include <string>

namespace gov {

namespace fnal {

namespace cd {

namespace rms {

namespace provider {

/**
 * This class is meant to take a message and a UUID and split
 * the message up into fragments of a maximum size.
 * 
 * @author Kurt Biery
 * @author Steve Foulkes
 * @version $Revision: 1.1.1.1 $ $Date: 2009/10/09 20:03:00 $
 */

class MessageSplitter {
 public:
    static std::vector <MessageFragment *> splitMessage(std::string messageText,
                                                 int maxFragmentSize,
                                                 const char *uuid);
};

};  // end of namespace provider

};  // end of namespace rms

};  // end of namespace cd

};  // end of namespace fnal

};  // end of namespace gov

#endif
