#include <rms/RmsMessageSchema.h>
#include <rms/util/TimeUtils.h>
#include <fstream>
#include <sstream>
#include <iostream>

int main( int argc, char *argv[] )
{
    gov::fnal::cd::rms::xsd::messageSource msource;
    msource.hostName("localhost");
    msource.applicationName("MyApplication");

    gov::fnal::cd::rms::xsd::messageBody mbody;
    mbody.content("Hello, Kurt");
    mbody.className("a.b.c.d");

    gov::fnal::cd::rms::xsd::property prop1;
    prop1.name("target");
    prop1.value("dcm005");
    gov::fnal::cd::rms::xsd::property prop2;
    prop2.name("service");
    prop2.value("control");

    gov::fnal::cd::rms::xsd::destination dest1;
    dest1.property().push_back(prop1);
    dest1.property().push_back(prop2);

    gov::fnal::cd::rms::xsd::property prop3;
    prop3.name("target");
    prop3.value("RunControl");
    gov::fnal::cd::rms::xsd::property prop4;
    prop4.name("service");
    prop4.value("control");

    gov::fnal::cd::rms::xsd::destination dest2;
    dest2.property().push_back(prop3);
    dest2.property().push_back(prop4);

    gov::fnal::cd::rms::xsd::rmsMessage rmsMsg;
    rmsMsg.body(mbody);
    rmsMsg.destination(dest1);
    rmsMsg.replyDestination(dest2);
    rmsMsg.id("IDIDIDID");
    rmsMsg.timeToLive(5000);
    rmsMsg.sentTime(
        gov::fnal::cd::rms::util::TimeUtils::convertPtimeToString(
        gov::fnal::cd::rms::util::TimeUtils::getUniversalPtime()));
    rmsMsg.source(msource);

    std::string xmlString = rmsMsg.serialize();
    std::cout << xmlString << std::endl;

    return 0;
}
