#include <rms/provider/EpicsConnection.h>
#include <rms/base/RmsDestination.h>

#include <iostream>
#include <string>

#include <unistd.h>

using namespace std;
using namespace gov::fnal::cd::rms;

class EpicsConnectionTest : public provider::ProviderListener {
public:
  int msgsReceived;

  void textReceived(boost::shared_ptr<string> messageText) {
    cout << "Received message " << *messageText << endl;
    msgsReceived++;
  }

  EpicsConnectionTest() {
    msgsReceived = 0;
  }
};

int main() {
  base::RmsDestination myDestination;
  provider::EpicsConnection *myConnection;
  EpicsConnectionTest *myTest = new EpicsConnectionTest();

  myConnection = new provider::EpicsConnection("epicsConnectionTestSubscriber", -1);

  myDestination.setProperty(base::RmsDestination::TARGET_PROPERTY_NAME, std::string("scf"));
  myDestination.setProperty(base::RmsDestination::CHANNEL_PROPERTY_NAME,
			    base::RmsDestination::CONTROL_CHANNEL);
  myDestination.setProperty(base::RmsDestination::MESSAGE_TYPE_PROPERTY_NAME,
			    base::RmsDestination::NOTIFICATION_MESSAGE_TYPE);

  myConnection->addListener(myDestination, myTest);

  sleep(500);

  return 0;
}


