#include <rms/provider/EpicsMessenger.h>
#include <rms/provider/ProviderListener.h>
#include <rms/util/UUIDGenerator.h>

#include <cadef.h>

#include <boost/shared_ptr.hpp>

#include <iostream>
#include <vector>
#include <string>

#include <unistd.h>

using namespace std;
using namespace gov::fnal::cd::rms;

int main() {
  struct ca_client_context *_caCurrentContext;
  provider::EpicsMessenger *messenger;
  util::UUIDGenerator *uuidGenerator;

  ca_context_create(ca_enable_preemptive_callback);
  _caCurrentContext = ca_current_context();
  ca_attach_context(_caCurrentContext);

  uuidGenerator = new util::UUIDGenerator(std::string("test"));

  messenger = new provider::EpicsMessenger(std::string("control/inbox"), _caCurrentContext, 
					   1024, uuidGenerator);

  if(messenger->getName() != std::string("control/inbox")) {
    cout << "getName() failed" << endl;
    
    return -1;
  }

  while(1) {
    messenger->sendMessage(std::string("Hello World!!"));
    sleep(1);
  }

  cout << "All tests passed..." << endl;

  return 0;
}

