#include <rms/provider/MessageFragment.h>
#include <rms/provider/MessageAssembler.h>

#include <iostream>
#include <string>
#include <cstring>  /* strncpy */

using namespace std;
using namespace gov::fnal::cd::rms::provider;

int main() {
  MessageFragment *fragment1;
  MessageFragment *fragment2;
  MessageFragment *fragment3;
  char *uuid;
  string payload1 = std::string("rms ");
  string payload2 = std::string("has ");
  string payload3 = std::string("c++ bindings");
  string payload = std::string("rms has c++ bindings");
  MessageAssembler *assembler;

  uuid = new char[16];
  strncpy(uuid, "1234567890123456", 16);

  fragment1 = new MessageFragment(uuid, 0, 3);
  fragment1->setPayload(payload1);

  fragment2 = new MessageFragment(uuid, 1, 3);
  fragment2->setPayload(payload2);

  fragment3 = new MessageFragment(uuid, 2, 3);
  fragment3->setPayload(payload3);
  
  assembler = new MessageAssembler(fragment1);

  if(assembler->hasCompleteMessage()) {
    cout << "hasCompleteMessage() failed after adding one fragment" << endl;

    delete[] uuid;
    delete assembler;
    return -1;
  }

  if(assembler->addFragment(fragment1)) {
    cout << "addFragment() failed when adding the initial fragment again" << endl;

    delete[] uuid;
    delete assembler;
    return -1;
  }

  if(!assembler->addFragment(fragment3)) {
    cout << "addFragment() failed while adding the third fragment" << endl;

    delete[] uuid;
    delete assembler;
    return -1;
  }

  if(assembler->hasCompleteMessage()) {
    cout << "hasCompleteMessage() failed after adding the third fragment" << endl;

    delete[] uuid;
    delete assembler;
    return -1;
  }

  if(assembler->addFragment(fragment3)) {
    cout << "addFragment() failed while adding the third fragment again" << endl;

    delete[] uuid;
    delete assembler;
    return -1;
  }

  if(!assembler->addFragment(fragment2)) {
    cout << "addFragment() failed while adding the second fragment" << endl;

    delete[] uuid;
    delete assembler;
    return -1;
  }

  if(!assembler->hasCompleteMessage()) {
    cout << "hasCompleteMessage() failed after adding the second fragment" << endl;

    delete[] uuid;
    delete assembler;
    return -1;
  }

  if(assembler->getMessage() != payload) {
    cout << "getMessage() failed to assembler the message" << endl;

    delete[] uuid;
    delete assembler;
    return -1;
  }

  delete[] uuid;
  delete assembler;

  cout << "All tests passed..." << endl;

  return 0;
}
