#include <rms/provider/MessageFragment.h>

#include <string>
#include <iostream>
#include <cstring>  /* strncpy */

using namespace std;
using namespace gov::fnal::cd::rms::provider;

int main() {
  char *uuid;
  string payload = std::string("steve is cool for reals");
  int index = 1;
  int totalCount = 3;
  MessageFragment *myFragment;
  MessageFragment *myFragment2;
  char *serializedFragment;
  int size;

  uuid = new char[16];
  strncpy(uuid, "1234567890123456", 16);

  myFragment = new MessageFragment(uuid, index, totalCount);
  myFragment->setPayload(payload);

  if(myFragment->getFragmentIndex() != index) {
    cout << "getFragmentIndex() failed with basic constructor" << endl;
    delete myFragment;
    
    return -1;
  }

  if(myFragment->getFragmentCount() != totalCount) {
    cout << "getFragmentCount() failed with basic constructor" << endl;
    delete myFragment;
    
    return -1;
  }

  if(memcmp(myFragment->getMessageId(), uuid, 16) != 0) {
    cout << "getMessageId() failed with basic constructor" << endl;
    delete myFragment;
    
    return -1;
  }

  if((unsigned int)myFragment->getPayloadSize() != payload.length()) {
    cout << "getPayloadSize() failed with basic constructor" << endl;
    delete myFragment;
    
    return -1;
  }

  if(myFragment->getPayload() != payload) {
    cout << "getPayload() failed with basic constructor" << endl;
    delete myFragment;
    
    return -1;
  }

  if(myFragment->getMaxHeaderSize() != 28) {
    cout << "getMaxHeaderSize() failed" << endl;
    delete myFragment;
    
    return -1;
  }

  myFragment->getBytes(&serializedFragment, &size);

  myFragment2 = new MessageFragment(serializedFragment);

  if(myFragment2->getFragmentIndex() != index) {
    cout << "getFragmentIndex() failed with serialize constructor" << endl;
    delete myFragment;
    
    return -1;
  }

  if(myFragment2->getFragmentCount() != totalCount) {
    cout << "getFragmentCount() failed with serialize constructor" << endl;
    delete myFragment;
    
    return -1;
  }

  if(memcmp(myFragment2->getMessageId(), uuid, 16) != 0) {
    cout << "getMessageId() failed with serialize constructor" << endl;
    cout << "getMessageId() returns " << myFragment2->getMessageId() << endl;
    delete myFragment;
    
    return -1;
  }

  if((unsigned int)myFragment2->getPayloadSize() != payload.length()) {
    cout << "getPayloadSize() failed with serialize constructor" << endl;
    delete myFragment;
    
    return -1;
  }

  if(myFragment2->getPayload() != payload) {
    cout << "getPayload() failed with basic constructor" << endl;
    delete myFragment;
    
    return -1;
  }

  delete myFragment;
  delete myFragment2;
  delete[] serializedFragment;
  delete[] uuid;

  cout << "All tests passed..." << endl;

  return 0;
}
