#include <rms/util/UUIDGenerator.h>

#include <string>
#include <iostream>
#include <stdio.h>

using namespace gov::fnal::cd::rms::util;

/**
 * Create a UUIDGenerator and print out 10 UUIDs that
 * it generated.  They should all be the same except
 * for the last couple digits, which should increment.
 *
 * Output should looking something like this:
 * [sfoulkes@cd-90837 rms]$ ./bin/x86/UUIDGeneratorTest
 * Generatoring 10 UUIDs:
 * c1a2e19a244872910f02005600d84811
 * c1a2e19a244872910f02005600c04a11
 * c1a2e19a244872910f02005600bc4c11
 * c1a2e19a244872910f02005600284e11
 * c1a2e19a244872910f02005600b44f11
 * c1a2e19a244872910f02005600385111
 * c1a2e19a244872910f02005600c05211
 * c1a2e19a244872910f02005600585411
 * c1a2e19a244872910f02005600dc5511
 * c1a2e19a244872910f02005600605711
 * [sfoulkes@cd-90837 rms]$       
 */
int main() {
  UUIDGenerator generator(std::string("nodeName"));
  const int *uuid;

  std::cout << "Generatoring 10 Human Readable UUIDs:" << std::endl;

  for(int i = 0; i < 10; i++) {
    std::cout << generator.getUUIDHex() << std::endl;
  }

  std::cout << std::endl << "Generatoring 10 Non-Human Readable UUIDs:" << std::endl;

  for(int i = 0; i < 10; i++) {
      uuid = reinterpret_cast<const int *>(generator.getUUID());

      printf("0x%x 0x%x 0x%x 0x%x\n", uuid[0], uuid[1], uuid[2], uuid[3]);

      delete[] uuid;
  }

  return 1;
}
