#!/bin/bash

source rms-test-common-functions.sh

#arguments
# $1 as string        // log file name
function run-RmsSenderExample-test-1 {
kill_signal=2;
monitored_process_name="RmsSenderExample";
send_message_interval=2;
monitored_process_args="-n 1000 -s $send_message_interval -a $HOSTNAME";
monitored_process=$monitored_process_name" "$monitored_process_args;

monitored_process_log=$1;

if [[ $monitored_process_log == "" ]]; then
  monitored_process_log=~/$monitored_process_name-$HOSTNAME.log;
  echo "Setting test output log to $monitored_process_log ."
fi

run_seconds=$(($RANDOM % 25));

touch  $monitored_process_log;

echo "---------------------------Begin---------------------------------" >> $monitored_process_log;

echo-time >> $monitored_process_log 2>&1;

kill-if-running $monitored_process_name >> $monitored_process_log 2>&1;

run-process-specified-time "$monitored_process" "$monitored_process_log" $run_seconds $kill_signal >> $monitored_process_log 2>&1;

sleep 1;

mmstat -s 2  >> $monitored_process_log  2>&1;

echo "---------------------------End---------------------------------" >> $monitored_process_log;
echo ""  >> $monitored_process_log;
}

#arguments
# $1 as string        // log file name
function run-RmsSenderExample-test-2 {
kill_signal=2;
monitored_process_name="RmsSenderExample";
monitored_process_args="-n 100000 -a $HOSTNAME";
monitored_process=$monitored_process_name" "$monitored_process_args;

monitored_process_log=$1;

if [[ $monitored_process_log == "" ]]; then
  monitored_process_log=~/$monitored_process_name-$HOSTNAME.log;
  echo "Setting test output log to $monitored_process_log ."
fi

run_seconds=$(($RANDOM % 25));

touch  $monitored_process_log;

echo "---------------------------Begin---------------------------------" >> $monitored_process_log;

echo-time >> $monitored_process_log 2>&1;

kill-if-running $monitored_process_name >> $monitored_process_log 2>&1;

run-process-specified-time "$monitored_process" "$monitored_process_log" $run_seconds $kill_signal >> $monitored_process_log 2>&1;

sleep 1;

mmstat -s 2  >> $monitored_process_log  2>&1;

echo "---------------------------End---------------------------------" >> $monitored_process_log;
echo ""  >> $monitored_process_log;
}

#arguments
# $1 as string        // log file name
function run-RmsSenderExample-test-3 {
kill_signal=2;
monitored_process_name="RmsSenderExample";
send_message_interval=2;
monitored_process_args="-n 1000 -s $send_message_interval -a $HOSTNAME";
monitored_process=$monitored_process_name" "$monitored_process_args;

monitored_process_log=$1;

if [[ $monitored_process_log == "" ]]; then
  monitored_process_log=~/$monitored_process_name-$HOSTNAME.log;
  echo "Setting test output log to $monitored_process_log ."
fi

run_seconds=$(($RANDOM % 25));

touch  $monitored_process_log;

echo "---------------------------Begin---------------------------------" >> $monitored_process_log;

echo-time >> $monitored_process_log 2>&1;

kill-if-running $monitored_process_name  >> $monitored_process_log 2>&1;

allowed_message_count=$((3+ $RANDOM %20));

let "expect_timeout= ( $allowed_message_count * $send_message_interval) + 4";

run-process-untill-pattern "$monitored_process" "$monitored_process_log" $allowed_message_count $expect_timeout >> $monitored_process_log 2>&1;

sleep 1;

mmstat -s 2  >> $monitored_process_log  2>&1;

echo "---------------------------End---------------------------------" >> $monitored_process_log;
echo ""  >> $monitored_process_log;
}

#arguments
# $1 as string        // dds version
# $2 as string        // log file name
function run-RmsSenderExample-tests {
clear;

dds_version=$1
if [[ $dds_version == "" ]]; then
  dds_version="v5_3p2";
  echo "Setting dds version to $dds_version."
fi

log_file=$2

if [[ $log_file == "" ]]; then
  log_file=~/run-RmsSenderExample-tests-$HOSTNAME.log;
  echo "Setting test output log to $log_file ."
fi

echo "Restarting DDS server version=$dds_version" 
restart-odds-X86 $dds_version;
sleep 1;

clear;

echo "Open another console window and run the following command:"
echo ""
echo "tail -100f $log_file"
echo ""
echo "Press C to continue"

read -t 10 -n 1 condition


#konsole -e "tail -100f $log_file"
#xterm_proc_id="$!"

for i in {1..5}; do

echo "##############################################################"


echo "Test iteration $i";

run-RmsSenderExample-test-1 "$log_file";

sleep 1;

run-RmsSenderExample-test-2 "$log_file";

sleep 1;

run-RmsSenderExample-test-3 "$log_file";

done;

#kill -9 $xterm_proc_id;

}
