package gov.fnal.cd.rms;

import gov.fnal.cd.rms.base.RmsMessage;

/**
 * Interface for determining whether an RmsMessage passes various
 * requirements (suitable for filtering out uninteresting messages).
 * 
 * @author Kurt Biery
 * @author Steve Foulkes
 * @version $Revision: 1.1.1.1 $ $Date: 2009/10/09 20:03:00 $
 */
public interface MessageFilter {

    /**
     * Tests whether the specified messages passes the filter.
     *
     * @param message the RmsMessage to be tested
     * @return try if the message passes the filter, false otherwise
     */
    boolean verify(RmsMessage message);
}
