package gov.fnal.cd.rms;

import gov.fnal.cd.rms.base.RmsMessage;

/**
 * This Interface defines the interface used by message listeners in RMS.
 * A message listener is an object that is notified asynchronously when
 * messages arrive (similar to a callback in C).
 *
 * @author Kurt Biery
 * @author Steve Foulkes
 * @version $Revision: 1.1.1.1 $ $Date: 2009/10/09 20:03:00 $
 */
public interface RmsMessageListener {

    /**
     * Passes the specified message to the listener.
     *
     * @param theMessage the RmsMessage that what received by the
     *        messaging system
     */
    public void messageReceived(RmsMessage theMessage);
}
