package gov.fnal.cd.rms.base;

/**
 * A class to contain the content of an RmsMessage.
 * 
 * @author Kurt Biery
 * @author Steve Foulkes
 * @version $Revision: 1.1.1.1 $ $Date: 2009/10/09 20:03:00 $
 */
public class RmsMessageBody {
    /**
     * The body class name
     */
    private String _className = null;

    /**
     * The body content
     */
    private String _content = "";

    /**
     * Creates an empty message body.
     */
    public RmsMessageBody() {
    }

    /**
     * Returns the class name associated with this message body.
     *
     * @return The class name associated with this message body.
     */
    public String getClassName() {
        return _className;
    }

    /**
     * Returns the content of this message body.
     *
     * @return The content of this message body.
     */
    public String getContent() {
        return _content;
    }

    /**
     * Sets the class name associated with this message body.
     *
     * @param name The class name to associate with this
     * message body.
     */
    public void setClassName(String name) {
        _className = name;
    }

    /**
     * Sets the content of this message body.
     *
     * @param text The content to associate with this
     * message body.
     */
    public void setContent(String text) {
        _content = text;
    }
}
