package gov.fnal.cd.rms.base;

/**
 * An exception class for reporting runtime problems in RMS.
 *
 * @author Kurt Biery
 * @author Steve Foulkes
 * @version $Revision: 1.1.1.1 $ $Date: 2009/10/09 20:03:00 $
 */
public class RmsRuntimeException extends RuntimeException {

    /**
     * Default constructor.
     */
    public RmsRuntimeException() {
        super();
    }

    /**
     * Constructs a new instance with the specified detail message.
     *
     * @param messageText the error message
     */
    public RmsRuntimeException(String messageText) {
        super(messageText);
    }

    /**
     * Constructs a new instance with the specified cause.
     *
     * @param cause the exception or error contained within this exception
     */
    public RmsRuntimeException(Throwable cause) {
        super(cause);
    }

    /**
     * Constructs a new instance with the specified detail message and cause.
     *
     * @param messageText the error message
     * @param cause the exception or error contained within this exception
     */
    public RmsRuntimeException(String messageText, Throwable cause) {
        super(messageText, cause);
    }
}
