package gov.fnal.cd.rms.provider;

/**
 * The interface for classes that want to be notified when a
 * string message has been received from a provider.
 *
 * Classes that implement this interface and are declared
 * as listeners for provider-level messages are notified
 * when messages are received.
 *
 * @author Kurt Biery
 * @author Steve Foulkes
 * @version $Revision: 1.1.1.1 $ $Date: 2009/10/09 20:03:00 $
 */
public interface ProviderListener {

    /**
     * Invoked when a string message is received from a provider.
     *
     * @param messageText the string containing the message that was
     *        received
     */
    public void textReceived(String messageText);
}
