package gov.fnal.cd.rms.util;

/**
 * A general-purpose exception class for reporting problems in RMS.
 *
 * @author Kurt Biery
 * @author Steve Foulkes
 * @version $Revision: 1.1.1.1 $ $Date: 2009/10/09 20:03:00 $
 */
public class RmsException extends Exception {

    /**
     * Default constructor.
     */
    public RmsException() {
        super();
    }

    /**
     * Constructs a new instance with the specified detail message.
     *
     * @param messageText the error message
     */
    public RmsException(String messageText) {
        super(messageText);
    }

    /**
     * Constructs a new instance with the specified cause.
     *
     * @param cause the exception or error contained within this exception
     */
    public RmsException(Throwable cause) {
        super(cause);
    }

    /**
     * Constructs a new instance with the specified detail message and cause.
     *
     * @param messageText the error message
     * @param cause the exception or error contained within this exception
     */
    public RmsException(String messageText, Throwable cause) {
        super(messageText, cause);
    }
}
