import gov.fnal.cd.rms.provider.ProviderListener;
import gov.fnal.cd.rms.provider.RmsConnection;
import gov.fnal.cd.rms.provider.RmsConnectionFactory;

import gov.fnal.cd.rms.base.RmsDestination;

/**
 * Ping a destination to determine if it is alive.
 *
 * @author Kurt Biery
 * @author Steve Foulkes
 * @version $Revision: 1.1.1.1 $ $Date: 2009/10/09 20:03:00 $
 */
public class RmsPingTest {
    private RmsConnection _myConnection;

    /**
     * Create a provider and connection object based on
     * what was passed in from the command line.
     *
     * @param args The command line arguments where args[0] is 
     * the target name and args[1] is the target service.
     */ 
    private void initializeRms(String[] args) {
	try {
	    _myConnection = RmsConnectionFactory.getConnection("rmsPing", -1);
	}
	catch (Exception excp) {
	    System.out.println("Had some problems creating the connection");
	    System.out.println(excp);
	
	    return;
	}

	return;
    }

    /**
     * Initialize the RMS system and ping the destination
     * that was specified in the command line arguments.
     *
     * @param args The command line arguments, where args[0] is
     * the target name and args[1] is the target service.
     */
    public static void main(String[] args) {
	RmsPingTest pingerObject = new RmsPingTest();

	if(args.length != 2) {
	    System.out.println("Usage: RmsPingTest [target name] [target service]");
	    
	    System.exit(0);
	}

	pingerObject.initializeRms(args);

	System.out.print("RmsDestination " + args[0] + "/" + args[1] + " is ");

	RmsDestination myDestination = new RmsDestination(args[0], args[1], "request");

	if(pingerObject._myConnection.ping(myDestination)) {
	    System.out.print("ALIVE");
	}
	else {
	    System.out.print("DEAD");
	}

	System.out.println("");
    }
}
